! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! The ODE Function of Chemical Model File
! 
! Generated by KPP-2.2.3 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : cb6_Function.f90
! Time                 : Mon Jun 20 12:52:55 2016
! Working directory    : /home/regcm/Code/kpp-2.2.3/Workspace/GAS_CB6r2_new
! Equation file        : cb6.kpp
! Output root filename : cb6
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE mod_cb6_Function

  USE mod_cb6_Parameters
  IMPLICIT NONE

! A - Rate for each equation
  REAL(kind=dp) :: A(NREACT)

CONTAINS


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Fun - time derivatives of variables - Agregate form
!   Arguments :
!      V         - Concentrations of variable species (local)
!      F         - Concentrations of fixed species (local)
!      RCT       - Rate constants (local)
!      Vdot      - Time derivative of variable species concentrations
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE Fun ( V, F, RCT, Vdot )

! V - Concentrations of variable species (local)
  REAL(kind=dp) :: V(NVAR_CB6)
! F - Concentrations of fixed species (local)
  REAL(kind=dp) :: F(NFIX_CB6)
! RCT - Rate constants (local)
  REAL(kind=dp) :: RCT(NREACT)
! Vdot - Time derivative of variable species concentrations
  REAL(kind=dp) :: Vdot(NVAR_CB6)


! Computation of equation rates
  A(1) = RCT(1)*V(76)
  A(2) = RCT(2)*V(74)*F(3)*F(5)
  A(3) = RCT(3)*V(67)*V(75)
  A(4) = RCT(4)*V(74)*V(75)*F(5)
  A(5) = RCT(5)*V(74)*V(76)
  A(6) = RCT(6)*V(74)*V(76)
  A(7) = RCT(7)*V(67)*V(74)
  A(8) = RCT(8)*V(67)
  A(9) = RCT(9)*V(67)
  A(10) = RCT(10)*V(4)*F(5)
  A(11) = RCT(11)*V(4)*F(1)
  A(12) = RCT(12)*V(67)*V(69)
  A(13) = RCT(13)*V(67)*V(70)
  A(14) = RCT(14)*V(69)*V(74)
  A(15) = RCT(15)*V(70)*V(74)
  A(16) = RCT(16)*V(69)*V(69)
  A(17) = RCT(17)*V(69)*V(69)
  A(18) = RCT(18)*V(69)*V(70)
  A(19) = RCT(19)*V(70)*V(70)
  A(20) = RCT(20)*V(70)*V(70)*F(1)
  A(21) = RCT(21)*V(26)
  A(22) = RCT(22)*V(26)*V(69)
  A(23) = RCT(23)*V(26)*V(74)
  A(24) = RCT(24)*V(75)*V(75)*F(3)
  A(25) = RCT(25)*V(70)*V(75)
  A(26) = RCT(26)*V(67)*V(76)
  A(27) = RCT(27)*V(72)
  A(28) = RCT(28)*V(72)
  A(29) = RCT(29)*V(72)*V(75)
  A(30) = RCT(30)*V(72)*V(76)
  A(31) = RCT(31)*V(72)*V(74)
  A(32) = RCT(32)*V(69)*V(72)
  A(33) = RCT(33)*V(70)*V(72)
  A(34) = RCT(34)*V(67)*V(72)
  A(35) = RCT(35)*V(72)*V(72)
  A(36) = RCT(36)*V(72)*V(76)
  A(37) = RCT(37)*V(8)
  A(38) = RCT(38)*V(8)
  A(39) = RCT(39)*V(8)*F(1)
  A(40) = RCT(40)*V(69)*V(75)
  A(41) = RCT(41)*V(75)*V(76)*F(1)
  A(42) = RCT(42)*V(22)*V(22)
  A(43) = RCT(43)*V(22)
  A(44) = RCT(44)*V(22)*V(69)
  A(45) = RCT(45)*V(69)*V(76)
  A(46) = RCT(46)*V(48)*V(69)
  A(47) = RCT(47)*V(48)
  A(48) = RCT(48)*V(70)*V(76)
  A(49) = RCT(49)*V(20)
  A(50) = RCT(50)*V(20)
  A(51) = RCT(51)*V(20)*V(69)
  A(52) = RCT(52)*V(3)*V(69)
  A(53) = RCT(53)*V(73)*V(75)
  A(54) = RCT(54)*V(73)*V(76)
  A(55) = RCT(55)*V(17)
  A(56) = RCT(56)*V(17)
  A(57) = RCT(57)*V(70)*V(73)
  A(58) = RCT(58)*V(68)*V(73)
  A(59) = RCT(59)*V(73)*V(73)
  A(60) = RCT(60)*V(71)*V(73)
  A(61) = RCT(61)*V(71)*V(75)
  A(62) = RCT(62)*V(71)*V(76)
  A(63) = RCT(63)*V(29)
  A(64) = RCT(64)*V(29)
  A(65) = RCT(65)*V(70)*V(71)
  A(66) = RCT(66)*V(68)*V(71)
  A(67) = RCT(67)*V(71)*V(71)
  A(68) = RCT(68)*V(68)*V(75)
  A(69) = RCT(69)*V(68)*V(70)
  A(70) = RCT(70)*V(68)*V(68)
  A(71) = RCT(71)*V(64)*V(75)
  A(72) = RCT(72)*V(64)*V(70)
  A(73) = RCT(73)*V(64)*V(73)
  A(74) = RCT(74)*V(64)*V(68)
  A(75) = RCT(75)*V(62)*V(75)
  A(76) = RCT(76)*V(62)*V(70)
  A(77) = RCT(77)*V(62)*V(73)
  A(78) = RCT(78)*V(62)*V(68)
  A(79) = RCT(79)*V(58)*V(75)
  A(80) = RCT(80)*V(58)*V(70)
  A(81) = RCT(81)*V(58)*V(73)
  A(82) = RCT(82)*V(58)*V(68)
  A(83) = RCT(83)*V(60)*V(75)
  A(84) = RCT(84)*V(60)*V(70)
  A(85) = RCT(85)*V(60)*V(73)
  A(86) = RCT(86)*V(60)*V(68)
  A(87) = RCT(87)*V(23)*V(69)
  A(88) = RCT(88)*V(23)
  A(89) = RCT(89)*V(32)*V(69)
  A(90) = RCT(90)*V(32)
  A(91) = RCT(91)*V(33)*V(69)
  A(92) = RCT(92)*V(33)
  A(93) = RCT(93)*V(28)*V(69)
  A(94) = RCT(94)*V(38)*V(69)
  A(95) = RCT(95)*V(18)*V(69)
  A(96) = RCT(96)*V(55)*V(69)
  A(97) = RCT(97)*V(55)
  A(98) = RCT(98)*V(55)
  A(99) = RCT(99)*V(55)*V(74)
  A(100) = RCT(100)*V(55)*V(72)
  A(101) = RCT(101)*V(55)*V(70)
  A(102) = RCT(102)*V(30)
  A(103) = RCT(103)*V(30)*V(75)
  A(104) = RCT(104)*V(30)*V(70)
  A(105) = RCT(105)*V(57)*V(74)
  A(106) = RCT(106)*V(57)*V(69)
  A(107) = RCT(107)*V(57)*V(72)
  A(108) = RCT(108)*V(57)
  A(109) = RCT(109)*V(65)*V(74)
  A(110) = RCT(110)*V(65)*V(69)
  A(111) = RCT(111)*V(65)*V(72)
  A(112) = RCT(112)*V(65)
  A(113) = RCT(113)*V(49)*V(69)
  A(114) = RCT(114)*V(49)
  A(115) = RCT(115)*V(49)*V(72)
  A(116) = RCT(116)*V(50)*V(69)
  A(117) = RCT(117)*V(50)
  A(118) = RCT(118)*V(50)*V(72)
  A(119) = RCT(119)*V(52)
  A(120) = RCT(120)*V(52)*V(72)
  A(121) = RCT(121)*V(52)*V(69)
  A(122) = RCT(122)*V(69)*F(2)
  A(123) = RCT(123)*V(42)*V(69)
  A(124) = RCT(124)*V(69)*F(4)
  A(125) = RCT(125)*V(6)*V(69)
  A(126) = RCT(126)*V(21)*V(69)
  A(127) = RCT(127)*V(11)*V(69)
  A(128) = RCT(128)*V(13)
  A(129) = RCT(129)*V(34)
  A(130) = RCT(130)*V(34)*V(69)
  A(131) = RCT(131)*V(12)*V(69)
  A(132) = RCT(132)*V(66)*V(69)
  A(133) = RCT(133)*V(39)
  A(134) = RCT(134)*V(39)*F(3)
  A(135) = RCT(135)*V(39)*V(76)
  A(136) = RCT(136)*V(7)*V(69)
  A(137) = RCT(137)*V(41)*V(74)
  A(138) = RCT(138)*V(41)*V(69)
  A(139) = RCT(139)*V(41)*V(67)
  A(140) = RCT(140)*V(41)*V(72)
  A(141) = RCT(141)*V(56)*V(74)
  A(142) = RCT(142)*V(56)*V(69)
  A(143) = RCT(143)*V(56)*V(67)
  A(144) = RCT(144)*V(56)*V(72)
  A(145) = RCT(145)*V(54)*V(74)
  A(146) = RCT(146)*V(54)*V(69)
  A(147) = RCT(147)*V(54)*V(67)
  A(148) = RCT(148)*V(54)*V(72)
  A(149) = RCT(149)*V(46)*V(69)
  A(150) = RCT(150)*V(46)*V(74)
  A(151) = RCT(151)*V(61)*V(75)
  A(152) = RCT(152)*V(61)*V(70)
  A(153) = RCT(153)*V(61)*V(73)
  A(154) = RCT(154)*V(61)*V(68)
  A(155) = RCT(155)*V(61)
  A(156) = RCT(156)*V(46)*V(67)
  A(157) = RCT(157)*V(46)*V(72)
  A(158) = RCT(158)*V(63)*V(69)
  A(159) = RCT(159)*V(63)*V(67)
  A(160) = RCT(160)*V(63)*V(72)
  A(161) = RCT(161)*V(63)
  A(162) = RCT(162)*V(27)*V(69)
  A(163) = RCT(163)*V(16)
  A(164) = RCT(164)*V(16)*V(72)
  A(165) = RCT(165)*V(10)*V(69)
  A(166) = RCT(166)*V(47)*V(70)
  A(167) = RCT(167)*V(47)*V(75)
  A(168) = RCT(168)*V(47)*V(73)
  A(169) = RCT(169)*V(47)*V(68)
  A(170) = RCT(170)*V(35)*V(69)
  A(171) = RCT(171)*V(44)*V(74)
  A(172) = RCT(172)*V(44)*V(69)
  A(173) = RCT(173)*V(44)*V(67)
  A(174) = RCT(174)*V(44)*V(72)
  A(175) = RCT(175)*V(9)*V(69)
  A(176) = RCT(176)*V(36)*V(75)
  A(177) = RCT(177)*V(36)*V(73)
  A(178) = RCT(178)*V(36)*V(70)
  A(179) = RCT(179)*V(36)*V(68)
  A(180) = RCT(180)*V(14)*V(69)
  A(181) = RCT(181)*V(40)*V(75)
  A(182) = RCT(182)*V(40)*V(73)
  A(183) = RCT(183)*V(40)*V(70)
  A(184) = RCT(184)*V(40)*V(68)
  A(185) = RCT(185)*V(15)*V(69)
  A(186) = RCT(186)*V(43)*V(75)
  A(187) = RCT(187)*V(43)*V(70)
  A(188) = RCT(188)*V(43)*V(73)
  A(189) = RCT(189)*V(43)*V(68)
  A(190) = RCT(190)*V(45)*V(69)
  A(191) = RCT(191)*V(45)*V(72)
  A(192) = RCT(192)*V(31)*V(76)
  A(193) = RCT(193)*V(31)*V(70)
  A(194) = RCT(194)*V(37)*V(69)
  A(195) = RCT(195)*V(37)*V(72)
  A(196) = RCT(196)*V(37)
  A(197) = RCT(197)*V(51)
  A(198) = RCT(198)*V(51)*V(69)
  A(199) = RCT(199)*V(51)*V(67)
  A(200) = RCT(200)*V(51)*V(72)
  A(201) = RCT(201)*V(53)
  A(202) = RCT(202)*V(53)*V(69)
  A(203) = RCT(203)*V(53)*V(67)
  A(204) = RCT(204)*V(53)*V(72)
  A(205) = RCT(205)*V(25)*V(69)
  A(206) = RCT(206)*V(25)*V(72)
  A(207) = RCT(207)*V(59)*V(75)
  A(208) = RCT(208)*V(59)*V(76)
  A(209) = RCT(209)*V(24)
  A(210) = RCT(210)*V(59)*V(70)
  A(211) = RCT(211)*V(59)*V(73)
  A(212) = RCT(212)*V(59)*V(68)
  A(213) = RCT(213)*V(24)*V(69)
  A(214) = RCT(214)*V(29)*V(69)
  A(215) = RCT(215)*V(19)
  A(216) = RCT(216)*V(5)*V(69)

! Aggregate function
  Vdot(1) = 0.266*A(170)+0.53*A(174)+0.082*A(176)+0.14*A(181)
  Vdot(2) = A(52)
  Vdot(3) = -A(52)
  Vdot(4) = A(9)-A(10)-A(11)
  Vdot(5) = -A(216)
  Vdot(6) = -A(125)
  Vdot(7) = -A(136)
  Vdot(8) = A(36)-A(37)-A(38)-A(39)
  Vdot(9) = -A(175)
  Vdot(10) = 0.904*A(162)-A(165)
  Vdot(11) = -A(127)
  Vdot(12) = -A(131)
  Vdot(13) = -A(128)+0.2*A(133)+A(134)
  Vdot(14) = -A(180)
  Vdot(15) = -A(185)
  Vdot(16) = A(155)-A(163)-A(164)
  Vdot(17) = A(54)-A(55)-A(56)
  Vdot(18) = 0.41*A(57)+0.41*A(65)-A(95)+0.41*A(210)
  Vdot(19) = 0.5*A(83)+A(91)+0.65*A(157)+0.142*A(160)+0.14*A(186)+A(194)+A(195)+0.5*A(200)+0.5*A(213)-A(215)
  Vdot(20) = A(48)-A(49)-A(50)-A(51)
  Vdot(21) = 0.315*A(74)+0.15*A(114)-A(126)
  Vdot(22) = A(40)+2*A(41)-2*A(42)-A(43)-A(44)+A(196)
  Vdot(23) = 0.9*A(72)-A(87)-A(88)+0.5*A(104)
  Vdot(24) = A(208)-A(209)-A(213)
  Vdot(25) = 0.732*A(190)-A(205)-A(206)
  Vdot(26) = A(17)+A(19)+A(20)-A(21)-A(22)-A(23)+0.04*A(143)+0.08*A(147)
  Vdot(27) = 0.88*A(152)-A(162)
  Vdot(28) = -A(93)+A(103)+0.5*A(104)+0.3*A(136)+0.37*A(139)+0.09*A(143)+0.15*A(159)+0.074*A(166)+0.185*A(170)
  Vdot(29) = A(62)-A(63)-A(64)-A(214)
  Vdot(30) = A(101)-A(102)-A(103)-A(104)
  Vdot(31) = 0.06*A(190)+0.3*A(191)-A(192)-A(193)+0.5*A(194)+0.5*A(195)+0.5*A(205)+A(206)
  Vdot(32) = A(76)+A(80)+A(84)-A(89)-A(90)
  Vdot(33) = 0.5*A(83)-A(91)-A(92)+A(135)+0.5*A(140)+0.5*A(144)+0.5*A(148)
  Vdot(34) = -A(129)-A(130)+0.71*A(131)+0.42*A(133)+0.137*A(158)+0.17*A(159)+0.17*A(161)
  Vdot(35) = 0.1*A(151)-0.896*A(170)
  Vdot(36) = 0.352*A(175)-A(176)-A(177)-A(178)-A(179)
  Vdot(37) = A(192)-A(194)-A(195)-A(196)
  Vdot(38) = 0.15*A(57)+0.15*A(65)+0.1*A(73)+0.2*A(77)+0.2*A(81)+0.2*A(85)-A(94)+0.13*A(143)+0.08*A(147)+0.2*A(153)+0.2&
               &*A(168)+0.15*A(210)+0.2*A(212)
  Vdot(39) = 0.76*A(132)-0.98*A(133)-A(134)-A(135)
  Vdot(40) = 0.65*A(180)-A(181)-A(182)-A(183)-A(184)
  Vdot(41) = -A(137)-A(138)-A(139)-A(140)
  Vdot(42) = A(96)+A(97)+A(98)+A(99)+A(100)+A(108)+A(112)+0.89*A(114)+1.8*A(116)+2*A(117)+1.5*A(118)+A(119)+A(121)&
               &-A(123)+0.38*A(129)+0.3*A(136)+A(137)+0.51*A(139)+0.2*A(141)+0.378*A(143)+0.1*A(145)+0.245*A(147)+0.066&
               &*A(156)+0.137*A(158)+0.543*A(159)+0.251*A(166)+0.251*A(167)+0.2*A(168)+0.251*A(169)+0.001*A(173)+0.06*A(190)&
               &+0.7*A(197)+0.5*A(199)+A(201)+1.98*A(203)+0.5*A(207)+A(213)
  Vdot(43) = 0.544*A(185)-A(186)-A(187)-A(188)-A(189)
  Vdot(44) = -A(171)-A(172)-A(173)-A(174)
  Vdot(45) = 0.53*A(175)+0.18*A(180)+0.155*A(185)-A(190)-A(191)+A(193)
  Vdot(46) = -A(149)-A(150)-A(156)-A(157)
  Vdot(47) = A(165)-A(166)-A(167)-A(168)-A(169)
  Vdot(48) = 2*A(39)+A(45)-A(46)-A(47)+A(100)+A(107)+A(111)+A(115)+A(118)+A(120)+0.717*A(160)+A(164)+A(191)+A(195)&
               &+A(204)+A(206)+A(215)
  Vdot(49) = -A(113)-A(114)-A(115)+0.011*A(127)+0.22*A(138)+0.269*A(158)+0.113*A(160)+0.128*A(161)+0.275*A(166)+0.275&
               &*A(167)+0.22*A(168)+0.275*A(169)+0.331*A(170)
  Vdot(50) = 0.2*A(113)+0.11*A(114)-A(116)-A(117)-A(118)+0.7*A(136)+0.075*A(143)+0.24*A(147)+0.17*A(159)+0.275*A(166)&
               &+0.275*A(167)+0.22*A(168)+0.275*A(169)+0.918*A(176)+A(177)+A(179)+0.417*A(181)+0.48*A(182)+0.48*A(184)+0.221&
               &*A(186)+0.26*A(188)+0.26*A(189)+0.24*A(191)+0.4*A(197)+0.4*A(198)+0.4*A(202)+1.4*A(203)+0.5*A(207)+0.5&
               &*A(213)
  Vdot(51) = 0.2*A(181)+0.23*A(182)+0.23*A(184)+0.244*A(185)+0.56*A(186)+0.65*A(188)+0.65*A(189)-A(197)-A(198)-A(199)&
               &-A(200)
  Vdot(52) = -A(119)-A(120)-A(121)+0.075*A(143)+0.06*A(147)+0.115*A(158)+0.531*A(159)+0.113*A(160)+0.275*A(166)+0.275&
               &*A(167)+0.22*A(168)+0.275*A(169)+0.443*A(181)+0.52*A(182)+0.52*A(184)+0.675*A(186)+0.77*A(188)+0.77*A(189)&
               &+0.24*A(191)+A(198)+1.2*A(199)+0.25*A(200)+0.24*A(203)
  Vdot(53) = 0.118*A(175)+0.918*A(176)+A(177)+A(179)+0.1*A(180)+0.66*A(181)+0.77*A(182)+0.77*A(184)+0.3*A(186)+0.35&
               &*A(188)+0.35*A(189)+0.13*A(190)+A(196)+0.25*A(200)-A(201)-A(202)-A(203)-A(204)
  Vdot(54) = -A(145)-A(146)-A(147)-A(148)+0.029*A(162)
  Vdot(55) = A(71)+0.1*A(72)+A(73)+0.685*A(74)+0.4*A(87)-A(96)-A(97)-A(98)-A(99)-A(100)-A(101)+A(102)+0.74*A(114)+A(126)&
               &+0.078*A(127)+A(130)+A(137)+1.56*A(138)+A(139)+1.125*A(140)+0.2*A(141)+0.781*A(142)+0.555*A(143)+0.5*A(144)&
               &+0.128*A(147)+0.5*A(150)+0.673*A(151)+0.12*A(152)+0.598*A(153)+0.598*A(154)+0.6*A(156)+0.35*A(157)+0.231&
               &*A(159)+0.26*A(161)+0.375*A(166)+0.375*A(167)+0.3*A(168)+0.375*A(169)+0.592*A(170)+0.28*A(172)+0.24*A(173)&
               &+0.06*A(190)+A(196)+0.08*A(203)+0.14*A(205)
  Vdot(56) = -A(141)-A(142)-A(143)-A(144)+0.24*A(161)+0.098*A(170)
  Vdot(57) = A(60)+A(61)+0.4*A(64)+0.44*A(65)+0.8*A(66)+2*A(67)-A(105)-A(106)-A(107)-A(108)+A(112)+0.991*A(125)+0.95&
               &*A(127)+0.5*A(128)+0.74*A(133)+0.2*A(141)+0.488*A(142)+0.295*A(143)+0.25*A(144)+1.24*A(145)+1.3*A(146)+0.732&
               &*A(147)+0.5*A(148)+0.04*A(159)+0.1*A(199)+0.02*A(203)+A(214)
  Vdot(58) = -A(79)-A(80)-A(81)-A(82)+0.2*A(116)+0.5*A(118)+A(120)+A(130)+0.76*A(132)+0.5*A(140)+0.195*A(142)+0.48&
               &*A(144)+0.48*A(148)+0.25*A(150)+0.2*A(156)+0.33*A(157)+1.042*A(158)+0.142*A(160)+0.16*A(161)+0.63*A(170)+0.5&
               &*A(172)+0.69*A(173)+0.75*A(174)+0.48*A(191)+0.9*A(200)+A(211)
  Vdot(59) = 0.457*A(158)+0.48*A(191)+A(201)+0.6*A(202)+A(204)-A(207)-A(208)+A(209)-A(210)-A(211)-A(212)
  Vdot(60) = -A(83)-A(84)-A(85)-A(86)+0.06*A(89)+0.009*A(125)+0.03*A(131)+0.13*A(132)+0.04*A(133)+0.01*A(141)+0.024&
               &*A(142)+0.04*A(144)+0.04*A(148)+0.03*A(157)+0.022*A(158)+0.25*A(172)+0.18*A(173)+0.25*A(174)+0.06*A(190)+0.1&
               &*A(191)+0.1*A(200)
  Vdot(61) = A(149)-A(151)-A(152)-A(153)-A(154)-A(155)+0.067*A(162)
  Vdot(62) = A(60)+A(61)+0.4*A(64)+0.44*A(65)+0.8*A(66)+2*A(67)-A(75)-A(76)-A(77)-A(78)+0.54*A(89)+A(112)+0.11*A(114)&
               &+0.991*A(125)+0.1*A(127)+0.5*A(128)+0.97*A(131)+0.11*A(132)+0.94*A(133)+0.7*A(137)+A(138)+0.5*A(140)+0.2&
               &*A(141)+0.976*A(142)+0.15*A(143)+0.48*A(144)+0.1*A(145)+A(146)+0.3*A(147)+0.48*A(148)+0.082*A(151)+0.072&
               &*A(153)+0.072*A(154)+0.64*A(157)+0.142*A(160)+0.34*A(161)+0.37*A(170)+0.75*A(172)+0.07*A(173)+0.28*A(174)&
               &+0.07*A(180)+0.058*A(185)+0.12*A(190)+0.12*A(191)+A(197)+2*A(198)+0.3*A(199)+0.45*A(200)+0.4*A(202)+0.44&
               &*A(210)+0.8*A(212)
  Vdot(63) = 0.75*A(150)+0.9*A(151)+0.12*A(152)+A(153)+A(154)+0.65*A(156)+0.35*A(157)-A(158)-A(159)-A(160)-A(161)+A(163)&
               &+A(164)
  Vdot(64) = A(53)+0.4*A(56)+0.44*A(57)+2*A(59)+A(60)-A(71)-A(72)-0.1*A(73)-A(74)+0.8*A(77)+0.8*A(81)+0.8*A(85)+0.6&
               &*A(87)+A(88)+A(94)+A(108)+A(124)+0.5*A(128)+1.38*A(129)+0.8*A(153)+0.115*A(158)+0.34*A(161)+0.8*A(168)&
               &+A(177)+A(182)+A(188)+A(211)+A(216)
  Vdot(65) = -A(109)-A(110)-A(111)-A(112)+0.26*A(131)+0.11*A(132)+0.37*A(133)+0.3*A(141)+0.488*A(142)+0.27*A(143)+0.375&
               &*A(144)+0.66*A(145)+0.7*A(146)+0.442*A(147)+0.625*A(148)+0.15*A(156)+0.029*A(162)+0.078*A(170)+0.15*A(171)&
               &+0.47*A(172)+0.21*A(173)+0.47*A(174)+0.44*A(210)+A(211)+0.8*A(212)
  Vdot(66) = -2.5*A(128)+0.26*A(131)-1.11*A(132)-2.7*A(133)+0.2*A(141)-0.73*A(142)-0.79*A(143)-A(144)+0.1*A(145)+0.29&
               &*A(147)+A(148)+0.25*A(150)+0.35*A(156)+0.117*A(158)+0.717*A(160)+0.24*A(161)+2.175*A(166)+2.175*A(167)+1.74&
               &*A(168)+2.175*A(169)+2.7*A(170)+5.12*A(171)+1.66*A(172)+7*A(173)
  Vdot(67) = A(2)-A(3)-A(7)-A(8)-A(9)-A(12)-A(13)-A(26)-A(34)+0.15*A(57)+0.15*A(65)-A(139)-A(143)-A(147)-A(156)-A(159)&
               &-A(173)-A(199)-A(203)+0.15*A(210)
  Vdot(68) = A(53)+0.4*A(56)+0.44*A(57)-A(58)+2*A(59)+2*A(60)+A(61)+0.4*A(64)+0.44*A(65)-0.2*A(66)+2*A(67)-A(68)-A(69)-2&
               &*A(70)+0.9*A(73)+0.8*A(77)+0.8*A(81)+0.8*A(85)+0.6*A(87)+A(88)+0.6*A(89)+A(94)+A(108)+A(112)+0.11*A(114)+0.2&
               &*A(116)+0.5*A(118)+A(120)+A(124)+A(125)+0.1*A(127)+A(128)+1.38*A(129)+A(130)+A(131)+A(132)+0.98*A(133)+0.7&
               &*A(137)+A(138)+A(140)+0.21*A(141)+1.195*A(142)+0.15*A(143)+A(144)+0.1*A(145)+A(146)+0.3*A(147)+A(148)+A(149)&
               &+0.25*A(150)+0.082*A(151)+0.872*A(153)-0.928*A(154)+0.2*A(156)+A(157)+0.658*A(158)+0.284*A(160)+0.84*A(161)&
               &+0.067*A(162)+A(165)+0.8*A(168)+A(170)+1.5*A(172)+0.94*A(173)+1.28*A(174)+0.352*A(175)+A(177)+0.72*A(180)&
               &+A(182)+0.602*A(185)+A(188)+0.18*A(190)+0.7*A(191)+2*A(198)+0.3*A(199)+A(200)+0.4*A(202)+0.44*A(210)+2&
               &*A(211)+0.8*A(212)+A(216)
  Vdot(69) = 2*A(11)-A(12)+A(13)-A(14)+A(15)-2*A(16)-2*A(17)-A(18)+2*A(21)-A(22)+A(23)+A(25)-A(32)+A(33)-A(40)+A(43)&
               &-A(44)-A(45)-A(46)+A(47)+0.41*A(50)-A(51)-A(52)+0.44*A(57)+0.44*A(65)-0.6*A(87)+A(88)-0.6*A(89)+A(90)-A(91)&
               &-A(93)-A(94)-A(95)-A(96)+A(99)+0.2*A(104)+A(105)-A(106)+A(109)-A(110)-A(113)+0.19*A(114)-A(116)-A(121)&
               &-A(122)-A(123)-A(124)-A(125)-A(126)-A(127)-A(130)-A(131)-A(132)-0.3*A(136)+0.3*A(137)-A(138)+0.16*A(139)+0.1&
               &*A(141)-A(142)+0.334*A(143)-A(146)+0.5*A(147)-A(149)+0.12*A(152)+0.266*A(156)-A(158)+0.461*A(159)-0.067&
               &*A(162)+A(163)-A(165)+1.125*A(166)+0.125*A(167)+0.1*A(168)+0.125*A(169)-A(170)-A(172)+0.57*A(173)-0.882&
               &*A(175)-0.9*A(180)-0.756*A(185)-A(190)-A(194)-A(198)+0.5*A(199)-A(202)+0.5*A(203)-A(205)+0.44*A(210)-A(213)&
               &-A(214)-A(216)
  Vdot(70) = A(12)-A(13)+A(14)-A(15)-A(18)-2*A(19)-2*A(20)+A(22)+A(23)-A(25)+A(32)-A(33)-A(48)+A(49)+0.59*A(50)+A(52)&
               &-A(57)-A(65)+A(71)-A(72)+0.9*A(73)+0.37*A(74)+A(75)-A(76)+0.8*A(77)+0.6*A(78)-A(80)-A(84)+0.8*A(85)+A(90)&
               &+A(93)+A(96)+2*A(97)+A(99)+A(100)-A(101)+A(102)+A(103)-0.8*A(104)+A(108)+A(112)+0.2*A(113)+1.4*A(114)+A(116)&
               &+2*A(117)+A(118)+A(119)+A(122)+A(123)+A(126)+0.9*A(127)+A(134)+0.3*A(136)+A(137)+0.16*A(139)+0.1*A(141)+0.08&
               &*A(143)+0.25*A(150)+0.818*A(151)-0.88*A(152)+0.728*A(153)+0.728*A(154)+A(155)+0.066*A(156)+0.137*A(158)&
               &+0.398*A(159)+0.76*A(161)-0.175*A(166)+0.825*A(167)+0.66*A(168)+0.825*A(169)+0.53*A(175)+0.918*A(176)+A(177)&
               &-A(178)+A(179)+0.18*A(180)+0.86*A(181)+A(182)-A(183)+A(184)+0.155*A(185)+0.86*A(186)-A(187)+A(188)+A(189)&
               &+A(190)-A(193)+A(196)+0.7*A(197)+A(201)+0.56*A(203)+0.2*A(205)+0.8*A(207)-A(210)
  Vdot(71) = -A(60)-A(61)-A(62)+A(63)+0.6*A(64)-A(65)-A(66)-2*A(67)+A(109)+A(110)+A(111)+0.5*A(128)+0.25*A(150)+0.2&
               &*A(156)+0.717*A(160)+0.39*A(173)+0.2*A(207)
  Vdot(72) = A(6)+A(26)-A(27)-A(28)-A(29)-A(30)-A(31)-A(32)-A(33)-A(34)-2*A(35)-A(36)+A(37)+A(38)+A(46)+0.41*A(50)+0.4&
               &*A(56)+0.4*A(64)-A(100)-A(107)-A(111)-A(115)-A(118)-A(120)-A(140)-A(144)-A(148)-A(157)-A(160)-A(164)+0.185&
               &*A(170)-A(174)-A(191)-A(195)-A(200)-A(204)-A(206)
  Vdot(73) = -A(53)-A(54)+A(55)+0.6*A(56)-A(57)-2*A(59)-A(60)-A(73)-A(77)-A(81)-A(85)+A(95)+A(105)+A(106)+A(107)+0.8&
               &*A(113)+A(115)+A(119)+A(120)+A(121)+0.5*A(128)+0.62*A(129)+A(130)-A(153)+0.269*A(158)+0.143*A(159)+0.208&
               &*A(161)-A(168)-A(177)-A(182)-A(188)+0.3*A(197)+0.6*A(199)+0.12*A(203)-A(211)
  Vdot(74) = A(1)-A(2)-A(4)-A(5)-A(6)-A(7)+A(8)+A(10)-A(14)-A(15)+A(16)-A(23)+A(27)-A(31)-A(99)-A(105)-A(109)-A(137)&
               &-A(141)-A(145)-A(150)-A(171)
  Vdot(75) = A(1)-A(3)-A(4)+A(5)-2*A(24)-A(25)+A(28)-A(29)+A(30)-A(40)-A(41)+A(42)+A(43)-A(53)-A(61)-A(71)-A(75)-A(79)&
               &-A(83)-A(103)-A(151)-A(167)-A(176)-A(181)-A(186)-A(207)
  Vdot(76) = -A(1)+A(3)+A(4)-A(5)-A(6)+2*A(24)+A(25)-A(26)+A(27)+2*A(29)+A(31)+A(32)+A(33)+A(34)+2*A(35)-A(36)+A(37)&
               &+A(38)-A(41)+A(42)+A(44)-A(45)+A(47)-A(48)+A(49)+0.59*A(50)+A(51)+A(53)-A(54)+A(55)+0.6*A(56)+A(61)-A(62)&
               &+A(63)+0.6*A(64)+A(71)+A(75)+A(79)+A(92)+A(103)-A(135)+0.5*A(140)+0.5*A(144)+0.5*A(148)+0.9*A(151)+0.35&
               &*A(157)+0.142*A(160)+A(167)+0.444*A(170)+0.47*A(174)+0.918*A(176)+0.86*A(181)+0.86*A(186)-A(192)+0.5*A(200)&
               &+A(207)-A(208)+A(209)+0.5*A(213)+A(214)
      
END SUBROUTINE Fun

! End of Fun function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



END MODULE mod_cb6_Function

