! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Global Data Module File
! 
! Generated by KPP-2.2.3 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : cb6_Global.f90
! Time                 : Wed Jul 16 14:29:47 2014
! Working directory    : /home/regcm/Code/kpp-2.2.3/Workspace/cb6
! Equation file        : cb6.kpp
! Output root filename : cb6
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE mod_cb6_Global

  USE mod_cb6_Parameters, ONLY: dp, NVAR_CB6, NREACT
  PUBLIC
  SAVE


! Declaration of global variables

!! C - Concentration of all species
!  REAL(kind=dp) :: C_CB6(NSPEC)
!! VAR - Concentrations of variable species (global)
!  REAL(kind=dp) :: VAR(NVAR)
!! FIX - Concentrations of fixed species (global)
!  REAL(kind=dp) :: FIX(NFIX_CB6)
!! VAR, FIX are chunks of array C
!      EQUIVALENCE( C_CB6(1),VAR(1) )
!      EQUIVALENCE( C_CB6(77),FIX(1) )
! RCONST - Rate constants (global)
  REAL(kind=dp) :: RCONST(NREACT)
  real(kind=dp) :: kmax(nreact)
! TIME - Current integration time
  REAL(kind=dp) :: TIMEB ! Timeb renamed to avoid clashes with CBMZ
! SUN - Sunlight intensity between [0,1]
  REAL(kind=dp) :: SUN
! TEMP - Temperature
  REAL(kind=dp) :: TEMPb ! b to avoid CBMZ conflicts
! RTOLS - (scalar) Relative tolerance
  REAL(kind=dp) :: RTOLS
! TSTART - Integration start time
  REAL(kind=dp) :: TSTART
! TEND - Integration end time
  REAL(kind=dp) :: TEND
! DT - Integration step
  REAL(kind=dp) :: DT
! ATOL - Absolute tolerance
  REAL(kind=dp) :: ATOL(NVAR_CB6)
! RTOL - Relative tolerance
  REAL(kind=dp) :: RTOL(NVAR_CB6)
! STEPMIN - Lower bound for integration step
  REAL(kind=dp) :: STEPMIN
! STEPMAX - Upper bound for integration step
  REAL(kind=dp) :: STEPMAX
! CFACTOR - Conversion factor for concentration units
  REAL(kind=dp) :: CFACTOR

! INLINED global variable declarations

  INTEGER, PARAMETER :: nperox=10
  REAL(KIND=4), DIMENSION(nperox,nperox) :: Aperox,Bperox
  REAL(KIND=4), DIMENSION(nperox) :: rk_param
! The molar Concentration of AIR
  REAL(KIND=dp)::   C_Mb ! addition of b due to CBMZ
  REAL(KIND=dp)::   C_MEO2
! REAL(KIND=dp)::   C_ETHP
  REAL(KIND=dp)::   C_ACOO
! REAL(KIND=dp)::   C_ANO2
! REAL(KIND=dp)::   C_NAP
  REAL(KIND=dp)::   C_ROO
  REAL(KIND=dp)::   C_ISO2
! REAL(KIND=dp)::   C_ISOPN
! REAL(KIND=dp)::   C_ISOPO2
  REAL(KIND=dp)::   C_XYLR
! The temperature field
  REAL(KIND=dp)::TEMPNEW
  INTEGER, PARAMETER :: jmeo2=1, jroo=2, jacoo=3, jiso2=4, jxylr=5

  REAL(KIND=dp)::  jval_NDOX,jval_O33P,jval_O31D,jval_HPOX,jval_NTOXb,         &
                   jval_NTOXa,jval_DNPOb,jval_HONO,jval_NTRC,jval_PNA,         &
                   jval_PACN,jval_PANX,jval_MEPX,jval_RPOX,jval_NTR,           &
                   jval_FORM,jval_AALD,jval_ALDX,jval_GLYD,jval_GLY,           &
                   jval_MEGY,jval_KET,jval_ACET,jval_ISPD,jval_HPLD,           &
                   jval_CRON,jval_XOPN,jval_ROPN

! addition of b due to CBMZ to avoid conflicts
  REAL(KIND=dp) :: zenithb,PRNEW,wtrin,wtrout ! b 
  REAL(KIND=dp), POINTER , DIMENSION(:) :: xrb,xrinb,xroutb,c_cb6,var,fix ! b
  REAL(KIND=dp), POINTER , DIMENSION(:) :: xrin_nu0,xrin_ac0,xrin_nu3,xrin_ac3  
  REAL(KIND=dp), POINTER , DIMENSION(:) :: chemtmpn,chemtmpa,chemtmpt
  REAL(KIND=dp),DIMENSION(1,56)    :: c_jvalb ! b 

  REAL(kind=dp) :: altmidb ! altitude at midpoint, km ! b 
  REAL(kind=dp) :: densb   ! Density molec cm-3 ! b
  REAL(kind=dp) :: relhum  ! Relative Humidity, fraction
  REAL(kind=dp) :: depthab,depthbb,altaboveb,altbelowb ! b 

! INLINED global variable declarations

END MODULE mod_cb6_Global
