! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Main Program File
! 
! Generated by KPP-2.2.3 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : cb6_Main.f90
! Time                 : Wed Jul 16 14:29:47 2014
! Working directory    : /home/regcm/Code/kpp-2.2.3/Workspace/cb6
! Equation file        : cb6.kpp
! Output root filename : cb6
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! MAIN - Main program - driver routine
!   Arguments :
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
module mod_cb6_main1
  use mod_cb6_Model
  use mod_cb6_Global
  use mod_cb6_Parameters

  public :: chemmain_cb6

  contains

  subroutine chemmain_cb6(jday,dtche)
    use mod_cb6_Model
    use mod_cb6_Global
    use mod_cb6_Parameters
    use mod_cb6_jval2
    implicit none
    real(kind=dp) , intent(in) :: jday , dtche

    real(kind=dp) :: t
    real(kind=dp) :: rstate(20)
    integer :: i

!------------------Declaration part for jval----------

    integer :: c_hvin
    integer , dimension(22) :: c_nhv(22)
    real(kind=dp) , dimension(22) :: jparam
    real(kind=dp) , dimension(22,40) :: c_hvmat
    real(kind=dp) , dimension(22) :: c_hvmatb
    real(kind=dp) , dimension(80,510,56) :: c_jarray

    common /hvrvars/ c_hvmat , c_hvmatb , c_jarray
    common /HVINT/ c_hvin , c_nhv
    real(kind=dp) , dimension(56) :: jval

    integer , parameter :: jO31D  = 2
    integer , parameter :: jO33P  = 3
    integer , parameter :: jNDOX  = 4
    integer , parameter :: jNTOXa = 5
    integer , parameter :: jNTOXb = 6
    integer , parameter :: jDNPOb = 8
    integer , parameter :: jHPOX  = 11
    integer , parameter :: jHONO  = 12
    integer , parameter :: jNTRC  = 13
    integer , parameter :: jPNA   = 14
    integer , parameter :: jFORM  = 15
    integer , parameter :: jAALD  = 17
    integer , parameter :: jISPD  = 18
    integer , parameter :: jALDX  = 20
    integer , parameter :: jGLY   = 21
    integer , parameter :: jMEGY  = 22
    integer , parameter :: jACET  = 23
    integer , parameter :: jMEPX  = 24
    integer , parameter :: jNTR   = 25
    integer , parameter :: jPACN  = 26
    integer , parameter :: jPANX  = 29
    integer , parameter :: jRPOX  = 30
    integer , parameter :: jGLYD  = 31
    integer , parameter :: jKET   = 32
    integer , parameter :: jHPLD  = 33
    integer , parameter :: jCRON  = 34
    integer , parameter :: jXOPN  = 35
    integer , parameter :: jROPN  = 36

    !~~~> Initialization 

    var => c_cb6(1:nvar_cb6)
    fix => c_cb6(nvar_cb6+1:)

    stepmin = 0.0d0
    stepmax = 0.0d0

    do i = 1 , nvar_cb6
      rtol(i) = 0.1D0
      atol(i) = 0.1D0
    end do
!   fix(1) = (3.0E+5)*C_Mb
    fix(1) = wtrin
    fix(2) = (0.00000055D0)*C_Mb !DIHY   -  0.000055 %
    fix(3) = (0.20946000D0)*C_Mb !O2     - 20.946000 %
    fix(4) = (0.00000180D0)*C_Mb !METH   -  0.000180 %
    fix(5) = (0.78084000D0)*C_Mb !M (N2) - 78.084000 %
!   fix(6) = (0.22D0)*C_Mb !DUMMY2 as O2

    !call loadperoxyparameters

    ! constant rate coefficients
    rconst(11) = ((2.14D-10))
    rconst(31) = ((1.70D-11))
    rconst(32) = ((2.00D-11))
    rconst(33) = ((4.00D-12))
    rconst(34) = ((1.00D-17))
    rconst(39) = ((1.00D-22))
    rconst(41) = ((5.00D-40))
    rconst(42) = ((1.00D-20))
    rconst(91) = ((2.00D-12))
    rconst(93) = ((4.50D-13))
    rconst(100) = ((5.50D-16))
    rconst(103) = ((5.60D-12))
    rconst(111) = ((6.30D-15))
    rconst(113) = ((8.00D-12))
    rconst(132) = ((8.10D-13))
    rconst(145) = ((2.30D-11))
    rconst(148) = ((3.70D-13))
    rconst(150) = ((3.00D-11))
    rconst(170) = ((3.10D-11))
    rconst(171) = ((3.60D-11))
    rconst(185) = ((1.85D-11))
    rconst(191) = ((1.40D-11))
    rconst(192) = ((2.10D-12))
    rconst(193) = ((5.50D-12))
    rconst(194) = ((1.53D-12))
    rconst(195) = ((3.80D-12))
    rconst(198) = ((9.00D-11))
    rconst(200) = ((3.00D-12))
    rconst(202) = ((4.40D-11))
    rconst(204) = ((3.80D-12))
    rconst(205) = ((5.00D-11))
    rconst(206) = ((1.70D-10))
    rconst(207) = ((1.00D-11))
    rconst(213) = ((3.60D-11))
    rconst(214) = ((3.00D-12))
    rconst(215) = ((2.30D-05))

    tstart = 0.0D0*3600.0D0
    dt = dtche

    do i = 1 , nvar_cb6
      var(i)  = xrinb(i)
    end do
    t = tstart
    tend = tstart+dtche

    timeb = t
    jparam(1) = zenithb
    jparam(2) = altmidb
    jparam(3) = 330._dp
    jparam(4) = 0.1_dp
    jparam(5) = 0.1_dp
    jparam(6) = 0.38_dp
    jparam(7) = 0.85_dp
    jparam(8) = 0.1_dp
    jparam(9) = depthab
    jparam(10)= depthbb
    jparam(11)= altaboveb
    jparam(12)= altbelowb
    jparam(13)= tempb
    jparam(20)= jday

    call jvalpro(c_nhv,c_hvmat,c_jarray,jparam,jval) 
    jval_O31D    =  jval(jO31D)
    jval_O33P    =  jval(jO33P)
    jval_NDOX    =  jval(jNDOX)
    jval_NTOXa   =  jval(jNTOXa)
    jval_NTOXb   =  jval(jNTOXb)
    jval_DNPOb   =  jval(jDNPOb)
    jval_HPOX    =  jval(jHPOX)
    jval_HONO    =  jval(jHONO)
    jval_NTRC    =  jval(jNTRC)
    jval_PNA     =  jval(jPNA)
    jval_FORM    =  jval(jFORM)
    jval_AALD    =  jval(jAALD)
    jval_ISPD    =  jval(jISPD)
    jval_ALDX    =  jval(jALDX)
    jval_GLY     =  jval(jGLY)
    jval_MEGY    =  jval(jMEGY)
    jval_ACET    =  jval(jACET)
    jval_MEPX    =  jval(jMEPX)
    jval_NTR     =  jval(jNTR)
    jval_PACN    =  jval(jPACN)
    ! list jval values based on proxies
    jval(jPANX)  = jval(jPACN)
    jval(jRPOX)  = jval(jMEPX)
    jval(jGLYD)  = jval(jGLY )
    jval(jKET )  = jval(jACET)
    jval(jHPLD)  = jval(jMEPX)
    jval(jCRON)  = jval(jNTR ) ! should be aromatic
    jval(jXOPN)  = jval(jMEGY) ! should be unsaturated
    jval(jROPN)  = jval(jMEGY) ! ring opening product
    ! continue jval values
    jval_PANX    =  jval(jPANX)
    jval_RPOX    =  jval(jRPOX)
    jval_GLYD    =  jval(jGLYD)
    jval_KET     =  jval(jKET)
    jval_HPLD    =  jval(jHPLD)
    jval_CRON    =  jval(jCRON)
    jval_XOPN    =  jval(jXOPN)
    jval_ROPN    =  jval(jROPN)
    c_jvalb(1,:) = jval(:)

    kron: &
    do while (t < tend)
      call update_rconst()
      call integrate( tin = t, tout = t+dt, rstatus_u = rstate, &
               icntrl_u = (/ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 /))
      t = rstate(1)
    end do kron

    do i = 1 , nvar_cb6
      xroutb(i) = var(i)
    end do
    wtrout = fix(1)

    end subroutine chemmain_cb6

end module  mod_cb6_main1

! End of MAIN function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


