! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!
! Global Data Module File
!
! Generated by KPP-2.2.3 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
!
! File                 : mod_cbmz_Global.f90
! Time                 : Mon Nov 25 13:41:15 2013
! Working directory    : /scratch/ashalaby/kpp-2.2.3/compare/CBMZ
! Equation file        : mod_cbmz.kpp
! Output root filename : mod_cbmz
!
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

module mod_cbmz_global

  use mod_cbmz_parameters , only: dp , nreact , nvar

  public

  save

  ! declaration of global variables

  ! rconst - rate constants (global)
  real(kind=dp) , dimension(nreact) :: rconst
  ! time - current integration time
  real(kind=dp) :: time
  ! sun - sunlight intensity between [0,1]
  real(kind=dp) :: sun
  ! temp - temperature
  real(kind=dp) :: temp
  ! rtols - (scalar) relative tolerance
  real(kind=dp) :: rtols
  ! tstart - integration start time
  real(kind=dp) :: tstart
  ! tend - integration end time
  real(kind=dp) :: tend
  ! dt - integration step
  real(kind=dp) :: dt
  ! atol - absolute tolerance
  real(kind=dp) , dimension(nvar) :: atol
  ! rtol - relative tolerance
  real(kind=dp) , dimension(nvar) :: rtol
  ! stepmin - lower bound for integration step
  real(kind=dp) :: stepmin
  ! stepmax - upper bound for integration step
  real(kind=dp) :: stepmax
  ! cfactor - conversion factor for concentration units
  real(kind=dp) :: cfactor

  ! inlined global variable declarations

  integer , parameter :: nperox = 10
  real(kind=dp), dimension(nperox,nperox) :: aperox , bperox
  real(kind=dp), dimension(nperox) :: rk_param
  !the molar concentration of air
  real(kind=dp) :: c_m
  real(kind=dp) :: c_ch3o2
  real(kind=dp) :: c_ethp
  real(kind=dp) :: c_c2o3
  real(kind=dp) :: c_ano2
  real(kind=dp) :: c_nap
  real(kind=dp) :: c_ro2
  real(kind=dp) :: c_isopp
  real(kind=dp) :: c_isopn
  real(kind=dp) :: c_isopo2
  real(kind=dp) :: c_xo2
  !the temperature field
  real(kind=dp) :: tempnew

  integer , parameter :: jch3o2 = 1
  integer , parameter :: jethp = 2
  integer , parameter :: jro2 = 3
  integer , parameter :: jc2o3 = 4
  integer , parameter :: jano2 = 5
  integer , parameter :: jnap = 6
  integer , parameter :: jisopp = 7
  integer , parameter :: jisopn = 8
  integer , parameter :: jisopo2 = 9
  integer , parameter :: jxo2 = 10

  real(kind=dp) :: jval_o31d
  real(kind=dp) :: jval_o33p
  real(kind=dp) :: jval_no2
  real(kind=dp) :: jval_h2o2
  real(kind=dp) :: jval_ch2oa
  real(kind=dp) :: jval_ch2ob
  real(kind=dp) :: jval_hno3
  real(kind=dp) :: jval_hno2
  real(kind=dp) :: jval_hno4
  real(kind=dp) :: jval_no3b
  real(kind=dp) :: jval_no3a
  real(kind=dp) :: jval_n2o5b
  real(kind=dp) :: jval_ch3choa
  real(kind=dp) :: jval_pan
  real(kind=dp) :: jval_c2h5cho
  real(kind=dp) :: jval_ch3coch3
  real(kind=dp) :: jval_chocho
  real(kind=dp) :: jval_ch3ooh

  real(kind=dp) :: zenith
  real(kind=dp) :: prnew
  real(kind=dp) , pointer , dimension(:) :: xr
  real(kind=dp) , pointer , dimension(:) :: xrin
  real(kind=dp) , pointer , dimension(:) :: xrout
  real(kind=dp) , pointer , dimension(:) :: c
  real(kind=dp) , pointer , dimension(:) :: var
  real(kind=dp) , pointer , dimension(:) :: fix
  real(kind=dp) , dimension(1,56) :: c_jval

  real(kind=dp) :: altmid ! altitude at midpoint, km
  real(kind=dp) :: dens   ! density molec cm-3
  real(kind=dp) :: deptha
  real(kind=dp) :: depthb
  real(kind=dp) :: altabove
  real(kind=dp) :: altbelow

  ! inlined global variable declarations

end module mod_cbmz_global

! vim: tabstop=8 expandtab shiftwidth=2 softtabstop=2
