! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!
! The ODE Jacobian of Chemical Model File
!
! Generated by KPP-2.2.3 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
!
! File                 : mod_cbmz_Jacobian.f90
! Time                 : Mon Nov 25 13:41:15 2013
! Working directory    : /scratch/ashalaby/kpp-2.2.3/compare/CBMZ
! Equation file        : mod_cbmz.kpp
! Output root filename : mod_cbmz
!
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

module mod_cbmz_jacobian

  use mod_cbmz_parameters
  use mod_cbmz_jacobiansp

  implicit none

  contains

  ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  !
  ! Jac_SP - the Jacobian of Variables in sparse matrix representation
  !   Arguments :
  !      V         - Concentrations of variable species (local)
  !      F         - Concentrations of fixed species (local)
  !      RCT       - Rate constants (local)
  !      JVS       - sparse Jacobian of variables
  !
  ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

  subroutine jac_sp ( v, f, rct, jvs )
    implicit none
    ! v - concentrations of variable species (local)
    real(kind=dp) , dimension(nvar) , intent(in) :: v
    ! f - concentrations of fixed species (local)
    real(kind=dp) , dimension(nfix) , intent(in) :: f
    ! rct - rate constants (local)
    real(kind=dp) , dimension(nreact) , intent(in) :: rct
    ! jvs - sparse jacobian of variables
    real(kind=dp) , dimension(lu_nonzero) , intent(inout) :: jvs

    ! local variables
    ! b - temporary array
    real(kind=dp) :: b(224)

    ! b(1) = da(1)/dv(56)
    b(1) = rct(1)
    ! b(2) = da(2)/dv(57)
    b(2) = rct(2)
    ! b(3) = da(3)/dv(21)
    b(3) = rct(3)
    ! b(4) = da(4)/dv(29)
    b(4) = rct(4)
    ! b(5) = da(5)/dv(17)
    b(5) = rct(5)
    ! b(6) = da(6)/dv(53)
    b(6) = rct(6)
    ! b(7) = da(7)/dv(53)
    b(7) = rct(7)
    ! b(8) = da(8)/dv(10)
    b(8) = rct(8)
    ! b(9) = da(9)/dv(9)
    b(9) = rct(9)*f(1)
    ! b(11) = da(10)/dv(9)
    b(11) = rct(10)*f(2)
    ! b(13) = da(11)/dv(9)
    b(13) = 2.2e-10_dp*v(35)
    ! b(14) = da(11)/dv(35)
    b(14) = 2.2e-10_dp*v(9)
    ! b(15) = da(12)/dv(27)
    b(15) = rct(12)*f(1)
    ! b(17) = da(13)/dv(27)
    b(17) = rct(13)*v(53)
    ! b(18) = da(13)/dv(53)
    b(18) = rct(13)*v(27)
    ! b(19) = da(14)/dv(27)
    b(19) = rct(14)*v(56)
    ! b(20) = da(14)/dv(56)
    b(20) = rct(14)*v(27)
    ! b(21) = da(15)/dv(27)
    b(21) = rct(15)*v(56)
    ! b(22) = da(15)/dv(56)
    b(22) = rct(15)*v(27)
    ! b(23) = da(16)/dv(27)
    b(23) = rct(16)*v(55)
    ! b(24) = da(16)/dv(55)
    b(24) = rct(16)*v(27)
    ! b(25) = da(17)/dv(53)
    b(25) = rct(17)*v(55)
    ! b(26) = da(17)/dv(55)
    b(26) = rct(17)*v(53)
    ! b(27) = da(18)/dv(53)
    b(27) = rct(18)*v(56)
    ! b(28) = da(18)/dv(56)
    b(28) = rct(18)*v(53)
    ! b(29) = da(19)/dv(53)
    b(29) = rct(19)*v(54)
    ! b(30) = da(19)/dv(54)
    b(30) = rct(19)*v(53)
    ! b(31) = da(20)/dv(52)
    b(31) = rct(20)*v(53)
    ! b(32) = da(20)/dv(53)
    b(32) = rct(20)*v(52)
    ! b(33) = da(21)/dv(18)
    b(33) = rct(21)*v(54)
    ! b(34) = da(21)/dv(54)
    b(34) = rct(21)*v(18)
    ! b(35) = da(22)/dv(54)
    b(35) = rct(22)*v(55)
    ! b(36) = da(22)/dv(55)
    b(36) = rct(22)*v(54)
    ! b(37) = da(23)/dv(54)
    b(37) = rct(23)*v(56)
    ! b(38) = da(23)/dv(56)
    b(38) = rct(23)*v(54)
    ! b(39) = da(24)/dv(54)
    b(39) = 2.2e-11_dp*v(57)
    ! b(40) = da(24)/dv(57)
    b(40) = 2.2e-11_dp*v(54)
    ! b(41) = da(25)/dv(21)
    b(41) = rct(25)*v(54)
    ! b(42) = da(25)/dv(54)
    b(42) = rct(25)*v(21)
    ! b(43) = da(26)/dv(29)
    b(43) = rct(26)*v(54)
    ! b(44) = da(26)/dv(54)
    b(44) = rct(26)*v(29)
    ! b(45) = da(27)/dv(17)
    b(45) = rct(27)*v(54)
    ! b(46) = da(27)/dv(54)
    b(46) = rct(27)*v(17)
    ! b(47) = da(28)/dv(52)
    b(47) = rct(28)*v(54)
    ! b(48) = da(28)/dv(54)
    b(48) = rct(28)*v(52)
    ! b(49) = da(29)/dv(10)
    b(49) = rct(29)*v(54)
    ! b(50) = da(29)/dv(54)
    b(50) = rct(29)*v(10)
    ! b(51) = da(30)/dv(52)
    b(51) = rct(30)*2_dp*v(52)
    ! b(52) = da(31)/dv(35)
    b(52) = rct(31)*v(52)*v(52)
    ! b(53) = da(31)/dv(52)
    b(53) = rct(31)*2_dp*v(35)*v(52)
    ! b(54) = da(32)/dv(52)
    b(54) = rct(32)*v(55)
    ! b(55) = da(32)/dv(55)
    b(55) = rct(32)*v(52)
    ! b(56) = da(33)/dv(52)
    b(56) = rct(33)*v(56)
    ! b(57) = da(33)/dv(56)
    b(57) = rct(33)*v(52)
    ! b(58) = da(34)/dv(52)
    b(58) = 5e-16_dp*v(56)
    ! b(59) = da(34)/dv(56)
    b(59) = 5e-16_dp*v(52)
    ! b(60) = da(35)/dv(17)
    b(60) = rct(35)
    ! b(61) = da(36)/dv(55)
    b(61) = rct(36)*v(57)
    ! b(62) = da(36)/dv(57)
    b(62) = rct(36)*v(55)
    ! b(63) = da(37)/dv(56)
    b(63) = rct(37)*v(57)
    ! b(64) = da(37)/dv(57)
    b(64) = rct(37)*v(56)
    ! b(65) = da(38)/dv(56)
    b(65) = rct(38)*v(57)
    ! b(66) = da(38)/dv(57)
    b(66) = rct(38)*v(56)
    ! b(67) = da(39)/dv(57)
    b(67) = rct(39)*2_dp*v(57)
    ! b(68) = da(40)/dv(52)
    b(68) = 3.5e-12_dp*v(57)
    ! b(69) = da(40)/dv(57)
    b(69) = 3.5e-12_dp*v(52)
    ! b(70) = da(41)/dv(24)
    b(70) = 2e-21_dp*v(35)
    ! b(71) = da(41)/dv(35)
    b(71) = 2e-21_dp*v(24)
    ! b(72) = da(42)/dv(24)
    b(72) = rct(42)
    ! b(73) = da(43)/dv(55)
    b(73) = rct(43)*2_dp*v(55)*f(1)
    ! b(75) = da(44)/dv(28)
    b(75) = rct(44)*v(54)
    ! b(76) = da(44)/dv(54)
    b(76) = rct(44)*v(28)
    ! b(77) = da(45)/dv(11)
    b(77) = rct(45)*v(54)
    ! b(78) = da(45)/dv(54)
    b(78) = rct(45)*v(11)
    ! b(79) = da(46)/dv(13)
    b(79) = rct(46)*v(54)
    ! b(80) = da(46)/dv(54)
    b(80) = rct(46)*v(13)
    ! b(81) = da(47)/dv(14)
    b(81) = rct(47)*v(54)
    ! b(82) = da(47)/dv(54)
    b(82) = rct(47)*v(14)
    ! b(83) = da(48)/dv(30)
    b(83) = 8.1e-13_dp*v(54)
    ! b(84) = da(48)/dv(54)
    b(84) = 8.1e-13_dp*v(30)
    ! b(85) = da(49)/dv(20)
    b(85) = rct(49)*v(54)
    ! b(86) = da(49)/dv(54)
    b(86) = rct(49)*v(20)
    ! b(87) = da(50)/dv(39)
    b(87) = rct(50)
    ! b(88) = da(51)/dv(39)
    b(88) = rct(51)
    ! b(89) = da(52)/dv(39)
    b(89) = 1e-11_dp*v(54)
    ! b(90) = da(52)/dv(54)
    b(90) = 1e-11_dp*v(39)
    ! b(91) = da(53)/dv(39)
    b(91) = rct(53)*v(57)
    ! b(92) = da(53)/dv(57)
    b(92) = rct(53)*v(39)
    ! b(93) = da(54)/dv(45)
    b(93) = rct(54)
    ! b(94) = da(55)/dv(45)
    b(94) = rct(55)*v(54)
    ! b(95) = da(55)/dv(54)
    b(95) = rct(55)*v(45)
    ! b(96) = da(56)/dv(45)
    b(96) = rct(56)*v(57)
    ! b(97) = da(56)/dv(57)
    b(97) = rct(56)*v(45)
    ! b(98) = da(57)/dv(36)
    b(98) = rct(57)
    ! b(99) = da(58)/dv(36)
    b(99) = rct(58)*v(54)
    ! b(100) = da(58)/dv(54)
    b(100) = rct(58)*v(36)
    ! b(101) = da(59)/dv(42)
    b(101) = rct(59)
    ! b(102) = da(60)/dv(42)
    b(102) = 1.7e-11_dp*v(54)
    ! b(103) = da(60)/dv(54)
    b(103) = 1.7e-11_dp*v(42)
    ! b(104) = da(61)/dv(42)
    b(104) = rct(61)*v(57)
    ! b(105) = da(61)/dv(57)
    b(105) = rct(61)*v(42)
    ! b(106) = da(62)/dv(25)
    b(106) = rct(62)*v(53)
    ! b(107) = da(62)/dv(53)
    b(107) = rct(62)*v(25)
    ! b(108) = da(63)/dv(25)
    b(108) = rct(63)*v(54)
    ! b(109) = da(63)/dv(54)
    b(109) = rct(63)*v(25)
    ! b(110) = da(64)/dv(40)
    b(110) = rct(64)*v(53)
    ! b(111) = da(64)/dv(53)
    b(111) = rct(64)*v(40)
    ! b(112) = da(65)/dv(37)
    b(112) = rct(65)*v(53)
    ! b(113) = da(65)/dv(53)
    b(113) = rct(65)*v(37)
    ! b(114) = da(66)/dv(40)
    b(114) = rct(66)*v(54)
    ! b(115) = da(66)/dv(54)
    b(115) = rct(66)*v(40)
    ! b(116) = da(67)/dv(37)
    b(116) = rct(67)*v(54)
    ! b(117) = da(67)/dv(54)
    b(117) = rct(67)*v(37)
    ! b(118) = da(68)/dv(40)
    b(118) = rct(68)*v(57)
    ! b(119) = da(68)/dv(57)
    b(119) = rct(68)*v(40)
    ! b(120) = da(69)/dv(37)
    b(120) = 2.5e-12_dp*v(57)
    ! b(121) = da(69)/dv(57)
    b(121) = 2.5e-12_dp*v(37)
    ! b(122) = da(70)/dv(8)
    b(122) = rct(70)*v(54)
    ! b(123) = da(70)/dv(54)
    b(123) = rct(70)*v(8)
    ! b(124) = da(71)/dv(12)
    b(124) = rct(71)*v(54)
    ! b(125) = da(71)/dv(54)
    b(125) = rct(71)*v(12)
    ! b(126) = da(72)/dv(19)
    b(126) = 8.1e-12_dp*v(55)
    ! b(127) = da(72)/dv(55)
    b(127) = 8.1e-12_dp*v(19)
    ! b(128) = da(73)/dv(26)
    b(128) = 4.1e-11_dp*v(54)
    ! b(129) = da(73)/dv(54)
    b(129) = 4.1e-11_dp*v(26)
    ! b(130) = da(74)/dv(26)
    b(130) = 2.2e-11_dp*v(57)
    ! b(131) = da(74)/dv(57)
    b(131) = 2.2e-11_dp*v(26)
    ! b(132) = da(75)/dv(15)
    b(132) = 1.4e-11_dp*v(56)
    ! b(133) = da(75)/dv(56)
    b(133) = 1.4e-11_dp*v(15)
    ! b(134) = da(76)/dv(31)
    b(134) = 3e-11_dp*v(54)
    ! b(135) = da(76)/dv(54)
    b(135) = 3e-11_dp*v(31)
    ! b(136) = da(77)/dv(31)
    b(136) = rct(77)
    ! b(137) = da(78)/dv(31)
    b(137) = rct(78)*v(53)
    ! b(138) = da(78)/dv(53)
    b(138) = rct(78)*v(31)
    ! b(139) = da(79)/dv(38)
    b(139) = rct(79)*v(54)
    ! b(140) = da(79)/dv(54)
    b(140) = rct(79)*v(38)
    ! b(141) = da(80)/dv(38)
    b(141) = rct(80)*v(53)
    ! b(142) = da(80)/dv(53)
    b(142) = rct(80)*v(38)
    ! b(143) = da(81)/dv(38)
    b(143) = rct(81)*v(57)
    ! b(144) = da(81)/dv(57)
    b(144) = rct(81)*v(38)
    ! b(145) = da(82)/dv(47)
    b(145) = 3.3e-11_dp*v(54)
    ! b(146) = da(82)/dv(54)
    b(146) = 3.3e-11_dp*v(47)
    ! b(147) = da(83)/dv(47)
    b(147) = 7e-18_dp*v(53)
    ! b(148) = da(83)/dv(53)
    b(148) = 7e-18_dp*v(47)
    ! b(149) = da(84)/dv(47)
    b(149) = rct(84)
    ! b(150) = da(85)/dv(47)
    b(150) = 1e-15_dp*v(57)
    ! b(151) = da(85)/dv(57)
    b(151) = 1e-15_dp*v(47)
    ! b(152) = da(86)/dv(22)
    b(152) = rct(86)
    ! b(153) = da(87)/dv(23)
    b(153) = rct(87)
    ! b(154) = da(88)/dv(49)
    b(154) = rct(88)
    ! b(155) = da(89)/dv(22)
    b(155) = rct(89)*v(54)
    ! b(156) = da(89)/dv(54)
    b(156) = rct(89)*v(22)
    ! b(157) = da(90)/dv(23)
    b(157) = rct(90)*v(54)
    ! b(158) = da(90)/dv(54)
    b(158) = rct(90)*v(23)
    ! b(159) = da(91)/dv(49)
    b(159) = rct(91)*v(54)
    ! b(160) = da(91)/dv(54)
    b(160) = rct(91)*v(49)
    ! b(161) = da(92)/dv(51)
    b(161) = rct(92)*v(54)
    ! b(162) = da(92)/dv(54)
    b(162) = rct(92)*v(51)
    ! b(163) = da(93)/dv(51)
    b(163) = rct(93)
    ! b(164) = da(94)/dv(56)
    b(164) = rct(94)*v(58)
    ! b(165) = da(94)/dv(58)
    b(165) = rct(94)*v(56)
    ! b(166) = da(95)/dv(7)
    b(166) = rct(95)
    ! b(167) = da(96)/dv(46)
    b(167) = rct(96)*v(55)
    ! b(168) = da(96)/dv(55)
    b(168) = rct(96)*v(46)
    ! b(169) = da(97)/dv(43)
    b(169) = rct(97)*v(55)
    ! b(170) = da(97)/dv(55)
    b(170) = rct(97)*v(43)
    ! b(171) = da(98)/dv(50)
    b(171) = 4e-12_dp*v(55)
    ! b(172) = da(98)/dv(55)
    b(172) = 4e-12_dp*v(50)
    ! b(173) = da(99)/dv(55)
    b(173) = rct(99)*v(58)
    ! b(174) = da(99)/dv(58)
    b(174) = rct(99)*v(55)
    ! b(175) = da(100)/dv(48)
    b(175) = 4e-12_dp*v(55)
    ! b(176) = da(100)/dv(55)
    b(176) = 4e-12_dp*v(48)
    ! b(177) = da(101)/dv(44)
    b(177) = 4e-12_dp*v(55)
    ! b(178) = da(101)/dv(55)
    b(178) = 4e-12_dp*v(44)
    ! b(179) = da(102)/dv(33)
    b(179) = 4e-12_dp*v(55)
    ! b(180) = da(102)/dv(55)
    b(180) = 4e-12_dp*v(33)
    ! b(181) = da(103)/dv(32)
    b(181) = 4e-12_dp*v(55)
    ! b(182) = da(103)/dv(55)
    b(182) = 4e-12_dp*v(32)
    ! b(183) = da(104)/dv(34)
    b(183) = 4e-12_dp*v(55)
    ! b(184) = da(104)/dv(55)
    b(184) = 4e-12_dp*v(34)
    ! b(185) = da(105)/dv(41)
    b(185) = 4e-12_dp*v(55)
    ! b(186) = da(105)/dv(55)
    b(186) = 4e-12_dp*v(41)
    ! b(187) = da(106)/dv(46)
    b(187) = 1.1e-12_dp*v(57)
    ! b(188) = da(106)/dv(57)
    b(188) = 1.1e-12_dp*v(46)
    ! b(189) = da(107)/dv(43)
    b(189) = 2.5e-12_dp*v(57)
    ! b(190) = da(107)/dv(57)
    b(190) = 2.5e-12_dp*v(43)
    ! b(191) = da(108)/dv(50)
    b(191) = 2.5e-12_dp*v(57)
    ! b(192) = da(108)/dv(57)
    b(192) = 2.5e-12_dp*v(50)
    ! b(193) = da(109)/dv(57)
    b(193) = 4e-12_dp*v(58)
    ! b(194) = da(109)/dv(58)
    b(194) = 4e-12_dp*v(57)
    ! b(195) = da(110)/dv(48)
    b(195) = 1.2e-12_dp*v(57)
    ! b(196) = da(110)/dv(57)
    b(196) = 1.2e-12_dp*v(48)
    ! b(197) = da(111)/dv(44)
    b(197) = 4e-12_dp*v(57)
    ! b(198) = da(111)/dv(57)
    b(198) = 4e-12_dp*v(44)
    ! b(199) = da(112)/dv(41)
    b(199) = 2.5e-12_dp*v(57)
    ! b(200) = da(112)/dv(57)
    b(200) = 2.5e-12_dp*v(41)
    ! b(201) = da(113)/dv(46)
    b(201) = rct(113)*v(52)
    ! b(202) = da(113)/dv(52)
    b(202) = rct(113)*v(46)
    ! b(203) = da(114)/dv(43)
    b(203) = rct(114)*v(52)
    ! b(204) = da(114)/dv(52)
    b(204) = rct(114)*v(43)
    ! b(205) = da(115)/dv(50)
    b(205) = rct(115)*v(52)
    ! b(206) = da(115)/dv(52)
    b(206) = rct(115)*v(50)
    ! b(207) = da(116)/dv(52)
    b(207) = rct(116)*v(58)
    ! b(208) = da(116)/dv(58)
    b(208) = rct(116)*v(52)
    ! b(209) = da(117)/dv(48)
    b(209) = rct(117)*v(52)
    ! b(210) = da(117)/dv(52)
    b(210) = rct(117)*v(48)
    ! b(211) = da(118)/dv(44)
    b(211) = rct(118)*v(52)
    ! b(212) = da(118)/dv(52)
    b(212) = rct(118)*v(44)
    ! b(213) = da(119)/dv(33)
    b(213) = rct(119)*v(52)
    ! b(214) = da(119)/dv(52)
    b(214) = rct(119)*v(33)
    ! b(215) = da(120)/dv(32)
    b(215) = rct(120)*v(52)
    ! b(216) = da(120)/dv(52)
    b(216) = rct(120)*v(32)
    ! b(217) = da(121)/dv(34)
    b(217) = rct(121)*v(52)
    ! b(218) = da(121)/dv(52)
    b(218) = rct(121)*v(34)
    ! b(219) = da(122)/dv(41)
    b(219) = rct(122)*v(52)
    ! b(220) = da(122)/dv(52)
    b(220) = rct(122)*v(41)
    ! b(221) = da(123)/dv(16)
    b(221) = rct(123)*v(54)
    ! b(222) = da(123)/dv(54)
    b(222) = rct(123)*v(16)
    ! b(223) = da(124)/dv(16)
    b(223) = rct(124)*v(57)
    ! b(224) = da(124)/dv(57)
    b(224) = rct(124)*v(16)

    ! construct the jacobian terms from b's
    ! jvs(1) = jac_full(1,1)
    jvs(1) = 0.0_dp
    ! jvs(2) = jac_full(1,25)
    jvs(2) = 0.24_dp*b(106)
    ! jvs(3) = jac_full(1,37)
    jvs(3) = 0.18_dp*b(112)
    ! jvs(4) = jac_full(1,40)
    jvs(4) = 0.22_dp*b(110)
    ! jvs(5) = jac_full(1,53)
    jvs(5) = 0.24_dp*b(107)+0.22_dp*b(111)+0.18_dp*b(113)
    ! jvs(6) = jac_full(1,55)
    jvs(6) = b(173)
    ! jvs(7) = jac_full(1,58)
    jvs(7) = b(174)
    ! jvs(8) = jac_full(2,2)
    jvs(8) = 0.0_dp
    ! jvs(9) = jac_full(2,11)
    jvs(9) = b(77)
    ! jvs(10) = jac_full(2,54)
    jvs(10) = b(78)
    ! jvs(11) = jac_full(3,3)
    jvs(11) = 0.0_dp
    ! jvs(12) = jac_full(3,25)
    jvs(12) = 0.52_dp*b(106)
    ! jvs(13) = jac_full(3,40)
    jvs(13) = 0.22_dp*b(110)
    ! jvs(14) = jac_full(3,53)
    jvs(14) = 0.52_dp*b(107)+0.22_dp*b(111)
    ! jvs(15) = jac_full(4,4)
    jvs(15) = 0.0_dp
    ! jvs(16) = jac_full(4,37)
    jvs(16) = 0.16_dp*b(112)
    ! jvs(17) = jac_full(4,38)
    jvs(17) = 0.39_dp*b(141)
    ! jvs(18) = jac_full(4,40)
    jvs(18) = 0.09_dp*b(110)
    ! jvs(19) = jac_full(4,47)
    jvs(19) = 0.46_dp*b(147)
    ! jvs(20) = jac_full(4,52)
    jvs(20) = 0.4_dp*b(207)
    ! jvs(21) = jac_full(4,53)
    jvs(21) = 0.09_dp*b(111)+0.16_dp*b(113)+0.39_dp*b(142)+0.46_dp*b(148)
    ! jvs(22) = jac_full(4,58)
    jvs(22) = 0.4_dp*b(208)
    ! jvs(23) = jac_full(5,5)
    jvs(23) = 0.0_dp
    ! jvs(24) = jac_full(5,16)
    jvs(24) = 0.6_dp*b(221)
    ! jvs(25) = jac_full(5,54)
    jvs(25) = 0.6_dp*b(222)
    ! jvs(26) = jac_full(6,6)
    jvs(26) = 0.0_dp
    ! jvs(27) = jac_full(6,41)
    jvs(27) = b(219)
    ! jvs(28) = jac_full(6,52)
    jvs(28) = b(220)
    ! jvs(29) = jac_full(7,7)
    jvs(29) = -b(166)
    ! jvs(30) = jac_full(7,56)
    jvs(30) = b(164)
    ! jvs(31) = jac_full(7,58)
    jvs(31) = b(165)
    ! jvs(32) = jac_full(8,8)
    jvs(32) = -b(122)
    ! jvs(33) = jac_full(8,54)
    jvs(33) = -b(123)
    ! jvs(34) = jac_full(9,9)
    jvs(34) = -b(9)-b(11)-b(13)
    ! jvs(35) = jac_full(9,35)
    jvs(35) = -b(14)
    ! jvs(36) = jac_full(9,53)
    jvs(36) = b(7)
    ! jvs(37) = jac_full(10,10)
    jvs(37) = -b(8)-b(49)
    ! jvs(38) = jac_full(10,35)
    jvs(38) = b(52)
    ! jvs(39) = jac_full(10,52)
    jvs(39) = b(51)+b(53)
    ! jvs(40) = jac_full(10,54)
    jvs(40) = -b(50)
    ! jvs(41) = jac_full(11,11)
    jvs(41) = -b(77)
    ! jvs(42) = jac_full(11,16)
    jvs(42) = 0.4_dp*b(221)+b(223)
    ! jvs(43) = jac_full(11,54)
    jvs(43) = -b(78)+0.4_dp*b(222)
    ! jvs(44) = jac_full(11,57)
    jvs(44) = b(224)
    ! jvs(45) = jac_full(12,12)
    jvs(45) = -b(124)
    ! jvs(46) = jac_full(12,54)
    jvs(46) = -b(125)
    ! jvs(47) = jac_full(13,13)
    jvs(47) = -b(79)
    ! jvs(48) = jac_full(13,37)
    jvs(48) = 0.08_dp*b(112)
    ! jvs(49) = jac_full(13,40)
    jvs(49) = 0.06_dp*b(110)
    ! jvs(50) = jac_full(13,53)
    jvs(50) = 0.06_dp*b(111)+0.08_dp*b(113)
    ! jvs(51) = jac_full(13,54)
    jvs(51) = -b(80)
    ! jvs(52) = jac_full(14,14)
    jvs(52) = -b(81)
    ! jvs(53) = jac_full(14,37)
    jvs(53) = 0.01_dp*b(112)
    ! jvs(54) = jac_full(14,40)
    jvs(54) = 0.01_dp*b(110)
    ! jvs(55) = jac_full(14,53)
    jvs(55) = 0.01_dp*b(111)+0.01_dp*b(113)
    ! jvs(56) = jac_full(14,54)
    jvs(56) = -b(82)
    ! jvs(57) = jac_full(15,15)
    jvs(57) = -b(132)
    ! jvs(58) = jac_full(15,26)
    jvs(58) = 0.4_dp*b(128)+b(130)
    ! jvs(59) = jac_full(15,54)
    jvs(59) = 0.4_dp*b(129)
    ! jvs(60) = jac_full(15,56)
    jvs(60) = -b(133)
    ! jvs(61) = jac_full(15,57)
    jvs(61) = b(131)
    ! jvs(62) = jac_full(16,16)
    jvs(62) = -b(221)-b(223)
    ! jvs(63) = jac_full(16,54)
    jvs(63) = -b(222)
    ! jvs(64) = jac_full(16,57)
    jvs(64) = -b(224)
    ! jvs(65) = jac_full(17,17)
    jvs(65) = -b(5)-b(45)-b(60)
    ! jvs(66) = jac_full(17,52)
    jvs(66) = b(56)
    ! jvs(67) = jac_full(17,54)
    jvs(67) = -b(46)
    ! jvs(68) = jac_full(17,56)
    jvs(68) = b(57)
    ! jvs(69) = jac_full(18,18)
    jvs(69) = -b(33)
    ! jvs(70) = jac_full(18,40)
    jvs(70) = 0.08_dp*b(110)
    ! jvs(71) = jac_full(18,53)
    jvs(71) = 0.08_dp*b(111)
    ! jvs(72) = jac_full(18,54)
    jvs(72) = -b(34)
    ! jvs(73) = jac_full(19,8)
    jvs(73) = 0.8_dp*b(122)
    ! jvs(74) = jac_full(19,12)
    jvs(74) = 0.45_dp*b(124)
    ! jvs(75) = jac_full(19,19)
    jvs(75) = -b(126)
    ! jvs(76) = jac_full(19,54)
    jvs(76) = 0.8_dp*b(123)+0.45_dp*b(125)
    ! jvs(77) = jac_full(19,55)
    jvs(77) = -b(127)
    ! jvs(78) = jac_full(20,20)
    jvs(78) = -b(85)
    ! jvs(79) = jac_full(20,37)
    jvs(79) = 0.04_dp*b(112)
    ! jvs(80) = jac_full(20,40)
    jvs(80) = 0.03_dp*b(110)
    ! jvs(81) = jac_full(20,53)
    jvs(81) = 0.03_dp*b(111)+0.04_dp*b(113)
    ! jvs(82) = jac_full(20,54)
    jvs(82) = -b(86)
    ! jvs(83) = jac_full(21,21)
    jvs(83) = -b(3)-b(41)
    ! jvs(84) = jac_full(21,52)
    jvs(84) = b(58)
    ! jvs(85) = jac_full(21,54)
    jvs(85) = b(35)-b(42)
    ! jvs(86) = jac_full(21,55)
    jvs(86) = b(36)
    ! jvs(87) = jac_full(21,56)
    jvs(87) = b(59)
    ! jvs(88) = jac_full(22,22)
    jvs(88) = -b(152)-b(155)
    ! jvs(89) = jac_full(22,46)
    jvs(89) = b(201)
    ! jvs(90) = jac_full(22,52)
    jvs(90) = b(202)
    ! jvs(91) = jac_full(22,54)
    jvs(91) = -b(156)
    ! jvs(92) = jac_full(23,23)
    jvs(92) = -b(153)-b(157)
    ! jvs(93) = jac_full(23,43)
    jvs(93) = b(203)
    ! jvs(94) = jac_full(23,52)
    jvs(94) = b(204)
    ! jvs(95) = jac_full(23,54)
    jvs(95) = -b(158)
    ! jvs(96) = jac_full(24,24)
    jvs(96) = -b(70)-b(72)
    ! jvs(97) = jac_full(24,35)
    jvs(97) = -b(71)
    ! jvs(98) = jac_full(24,56)
    jvs(98) = b(65)
    ! jvs(99) = jac_full(24,57)
    jvs(99) = b(66)
    ! jvs(100) = jac_full(25,25)
    jvs(100) = -b(106)-b(108)
    ! jvs(101) = jac_full(25,53)
    jvs(101) = -b(107)
    ! jvs(102) = jac_full(25,54)
    jvs(102) = -b(109)
    ! jvs(103) = jac_full(26,8)
    jvs(103) = 0.12_dp*b(122)
    ! jvs(104) = jac_full(26,12)
    jvs(104) = 0.05_dp*b(124)
    ! jvs(105) = jac_full(26,26)
    jvs(105) = -b(128)-b(130)
    ! jvs(106) = jac_full(26,54)
    jvs(106) = 0.12_dp*b(123)+0.05_dp*b(125)-b(129)
    ! jvs(107) = jac_full(26,57)
    jvs(107) = -b(131)
    ! jvs(108) = jac_full(27,9)
    jvs(108) = b(9)+b(11)
    ! jvs(109) = jac_full(27,27)
    jvs(109) = -b(15)-b(17)-b(19)-b(21)-b(23)
    ! jvs(110) = jac_full(27,35)
    jvs(110) = 0.0_dp
    ! jvs(111) = jac_full(27,53)
    jvs(111) = b(6)-b(18)
    ! jvs(112) = jac_full(27,55)
    jvs(112) = -b(24)
    ! jvs(113) = jac_full(27,56)
    jvs(113) = b(1)-b(20)-b(22)
    ! jvs(114) = jac_full(27,57)
    jvs(114) = 0.89_dp*b(2)
    ! jvs(115) = jac_full(28,25)
    jvs(115) = 0.24_dp*b(106)
    ! jvs(116) = jac_full(28,28)
    jvs(116) = -b(75)
    ! jvs(117) = jac_full(28,31)
    jvs(117) = 2_dp*b(134)+b(136)+0.69_dp*b(137)
    ! jvs(118) = jac_full(28,34)
    jvs(118) = 0.59_dp*b(183)
    ! jvs(119) = jac_full(28,37)
    jvs(119) = 0.3_dp*b(112)
    ! jvs(120) = jac_full(28,38)
    jvs(120) = 0.07_dp*b(141)
    ! jvs(121) = jac_full(28,39)
    jvs(121) = b(87)+b(88)+b(89)+b(91)
    ! jvs(122) = jac_full(28,40)
    jvs(122) = 0.31_dp*b(110)
    ! jvs(123) = jac_full(28,42)
    jvs(123) = b(101)+b(104)
    ! jvs(124) = jac_full(28,45)
    jvs(124) = b(93)
    ! jvs(125) = jac_full(28,47)
    jvs(125) = 0.1_dp*b(147)+0.33_dp*b(149)+0.64_dp*b(150)
    ! jvs(126) = jac_full(28,53)
    jvs(126) = 0.24_dp*b(107)+0.31_dp*b(111)+0.3_dp*b(113)+0.69_dp*b(138) + &
               0.07_dp*b(142)+0.1_dp*b(148)
    ! jvs(127) = jac_full(28,54)
    jvs(127) = -b(76)+b(90)+2_dp*b(135)
    ! jvs(128) = jac_full(28,55)
    jvs(128) = 0.59_dp*b(184)
    ! jvs(129) = jac_full(28,57)
    jvs(129) = b(92)+b(105)+0.64_dp*b(151)
    ! jvs(130) = jac_full(29,16)
    jvs(130) = b(223)
    ! jvs(131) = jac_full(29,24)
    jvs(131) = 2_dp*b(70)
    ! jvs(132) = jac_full(29,26)
    jvs(132) = b(130)
    ! jvs(133) = jac_full(29,29)
    jvs(133) = -b(4)-b(43)
    ! jvs(134) = jac_full(29,35)
    jvs(134) = 2_dp*b(71)
    ! jvs(135) = jac_full(29,39)
    jvs(135) = b(91)
    ! jvs(136) = jac_full(29,42)
    jvs(136) = b(104)
    ! jvs(137) = jac_full(29,45)
    jvs(137) = b(96)
    ! jvs(138) = jac_full(29,47)
    jvs(138) = 0.07_dp*b(150)
    ! jvs(139) = jac_full(29,52)
    jvs(139) = 0.3_dp*b(68)
    ! jvs(140) = jac_full(29,54)
    jvs(140) = b(37)-b(44)
    ! jvs(141) = jac_full(29,56)
    jvs(141) = b(38)
    ! jvs(142) = jac_full(29,57)
    jvs(142) = 0.3_dp*b(69)+b(92)+b(97)+b(105)+b(131)+0.07_dp*b(151)+b(224)
    ! jvs(143) = jac_full(30,12)
    jvs(143) = 1.1_dp*b(124)
    ! jvs(144) = jac_full(30,30)
    jvs(144) = -b(83)
    ! jvs(145) = jac_full(30,32)
    jvs(145) = 1.6_dp*b(181)+2_dp*b(215)
    ! jvs(146) = jac_full(30,33)
    jvs(146) = 0.18_dp*b(179)
    ! jvs(147) = jac_full(30,37)
    jvs(147) = -2.26_dp*b(112)-2.23_dp*b(116)
    ! jvs(148) = jac_full(30,40)
    jvs(148) = -1.06_dp*b(110)-b(114)
    ! jvs(149) = jac_full(30,44)
    jvs(149) = -b(177)-b(197)
    ! jvs(150) = jac_full(30,47)
    jvs(150) = 1.86_dp*b(150)
    ! jvs(151) = jac_full(30,49)
    jvs(151) = -1.98_dp*b(154)+0.42_dp*b(159)
    ! jvs(152) = jac_full(30,50)
    jvs(152) = -1.68_dp*b(171)-1.98_dp*b(191)
    ! jvs(153) = jac_full(30,51)
    jvs(153) = -1.98_dp*b(163)
    ! jvs(154) = jac_full(30,52)
    jvs(154) = 2_dp*b(216)
    ! jvs(155) = jac_full(30,53)
    jvs(155) = -1.06_dp*b(111)-2.26_dp*b(113)
    ! jvs(156) = jac_full(30,54)
    jvs(156) = -b(84)-b(115)-2.23_dp*b(117)+1.1_dp*b(125)+0.42_dp*b(160)
    ! jvs(157) = jac_full(30,55)
    jvs(157) = -1.68_dp*b(172)-b(178)+0.18_dp*b(180)+1.6_dp*b(182)
    ! jvs(158) = jac_full(30,57)
    jvs(158) = 1.86_dp*b(151)-1.98_dp*b(192)-b(198)
    ! jvs(159) = jac_full(31,19)
    jvs(159) = 0.95_dp*b(126)
    ! jvs(160) = jac_full(31,26)
    jvs(160) = 0.3_dp*b(128)
    ! jvs(161) = jac_full(31,31)
    jvs(161) = -b(134)-b(136)-b(137)
    ! jvs(162) = jac_full(31,53)
    jvs(162) = -b(138)
    ! jvs(163) = jac_full(31,54)
    jvs(163) = 0.3_dp*b(129)-b(135)
    ! jvs(164) = jac_full(31,55)
    jvs(164) = 0.95_dp*b(127)
    ! jvs(165) = jac_full(31,57)
    jvs(165) = 0.0_dp
    ! jvs(166) = jac_full(32,32)
    jvs(166) = -b(181)-b(215)
    ! jvs(167) = jac_full(32,38)
    jvs(167) = b(143)
    ! jvs(168) = jac_full(32,52)
    jvs(168) = -b(216)
    ! jvs(169) = jac_full(32,55)
    jvs(169) = -b(182)
    ! jvs(170) = jac_full(32,57)
    jvs(170) = b(144)
    ! jvs(171) = jac_full(33,33)
    jvs(171) = -b(179)-b(213)
    ! jvs(172) = jac_full(33,38)
    jvs(172) = b(139)
    ! jvs(173) = jac_full(33,52)
    jvs(173) = -b(214)
    ! jvs(174) = jac_full(33,54)
    jvs(174) = b(140)
    ! jvs(175) = jac_full(33,55)
    jvs(175) = -b(180)
    ! jvs(176) = jac_full(34,34)
    jvs(176) = -b(183)-b(217)
    ! jvs(177) = jac_full(34,47)
    jvs(177) = 0.5_dp*b(145)
    ! jvs(178) = jac_full(34,52)
    jvs(178) = -b(218)
    ! jvs(179) = jac_full(34,54)
    jvs(179) = 0.5_dp*b(146)
    ! jvs(180) = jac_full(34,55)
    jvs(180) = -b(184)
    ! jvs(181) = jac_full(35,9)
    jvs(181) = -b(13)
    ! jvs(182) = jac_full(35,18)
    jvs(182) = b(33)
    ! jvs(183) = jac_full(35,24)
    jvs(183) = -b(70)
    ! jvs(184) = jac_full(35,35)
    jvs(184) = -b(14)-b(52)-b(71)
    ! jvs(185) = jac_full(35,40)
    jvs(185) = 0.0_dp
    ! jvs(186) = jac_full(35,52)
    jvs(186) = b(47)-b(53)
    ! jvs(187) = jac_full(35,53)
    jvs(187) = 0.0_dp
    ! jvs(188) = jac_full(35,54)
    jvs(188) = b(34)+b(48)
    ! jvs(189) = jac_full(35,56)
    jvs(189) = 0.0_dp
    ! jvs(190) = jac_full(35,57)
    jvs(190) = 0.0_dp
    ! jvs(191) = jac_full(36,34)
    jvs(191) = 0.63_dp*b(183)
    ! jvs(192) = jac_full(36,36)
    jvs(192) = -b(98)-b(99)
    ! jvs(193) = jac_full(36,37)
    jvs(193) = 0.07_dp*b(112)+0.23_dp*b(116)
    ! jvs(194) = jac_full(36,47)
    jvs(194) = 0.09_dp*b(147)+0.03_dp*b(149)
    ! jvs(195) = jac_full(36,49)
    jvs(195) = 0.74_dp*b(154)
    ! jvs(196) = jac_full(36,50)
    jvs(196) = 0.62_dp*b(171)+0.74_dp*b(191)
    ! jvs(197) = jac_full(36,51)
    jvs(197) = 0.74_dp*b(163)
    ! jvs(198) = jac_full(36,52)
    jvs(198) = 0.0_dp
    ! jvs(199) = jac_full(36,53)
    jvs(199) = 0.07_dp*b(113)+0.09_dp*b(148)
    ! jvs(200) = jac_full(36,54)
    jvs(200) = -b(100)+0.23_dp*b(117)
    ! jvs(201) = jac_full(36,55)
    jvs(201) = 0.62_dp*b(172)+0.63_dp*b(184)
    ! jvs(202) = jac_full(36,57)
    jvs(202) = 0.74_dp*b(192)
    ! jvs(203) = jac_full(37,37)
    jvs(203) = -b(112)-b(116)-b(120)
    ! jvs(204) = jac_full(37,53)
    jvs(204) = -b(113)
    ! jvs(205) = jac_full(37,54)
    jvs(205) = -b(117)
    ! jvs(206) = jac_full(37,57)
    jvs(206) = -b(121)
    ! jvs(207) = jac_full(38,38)
    jvs(207) = -b(139)-b(141)-b(143)
    ! jvs(208) = jac_full(38,53)
    jvs(208) = -b(142)
    ! jvs(209) = jac_full(38,54)
    jvs(209) = -b(140)
    ! jvs(210) = jac_full(38,57)
    jvs(210) = -b(144)
    ! jvs(211) = jac_full(39,20)
    jvs(211) = b(85)
    ! jvs(212) = jac_full(39,22)
    jvs(212) = b(152)+0.3_dp*b(155)
    ! jvs(213) = jac_full(39,25)
    jvs(213) = b(106)+1.56_dp*b(108)
    ! jvs(214) = jac_full(39,31)
    jvs(214) = b(134)+0.7_dp*b(137)
    ! jvs(215) = jac_full(39,33)
    jvs(215) = 0.63_dp*b(179)
    ! jvs(216) = jac_full(39,34)
    jvs(216) = 0.25_dp*b(183)
    ! jvs(217) = jac_full(39,37)
    jvs(217) = 0.0_dp
    ! jvs(218) = jac_full(39,38)
    jvs(218) = 0.6_dp*b(141)
    ! jvs(219) = jac_full(39,39)
    jvs(219) = -b(87)-b(88)-b(89)-b(91)
    ! jvs(220) = jac_full(39,40)
    jvs(220) = 0.57_dp*b(110)+b(114)
    ! jvs(221) = jac_full(39,44)
    jvs(221) = 0.5_dp*b(177)+0.5_dp*b(197)
    ! jvs(222) = jac_full(39,46)
    jvs(222) = b(167)+b(187)
    ! jvs(223) = jac_full(39,47)
    jvs(223) = 0.15_dp*b(147)+0.2_dp*b(149)+0.28_dp*b(150)
    ! jvs(224) = jac_full(39,48)
    jvs(224) = b(175)+b(195)
    ! jvs(225) = jac_full(39,52)
    jvs(225) = 0.0_dp
    ! jvs(226) = jac_full(39,53)
    jvs(226) = b(107)+0.57_dp*b(111)+0.7_dp*b(138)+0.6_dp*b(142)+0.15_dp*b(148)
    ! jvs(227) = jac_full(39,54)
    jvs(227) = b(86)-b(90)+1.56_dp*b(109)+b(115)+b(135)+0.3_dp*b(156)
    ! jvs(228) = jac_full(39,55)
    jvs(228) = b(168)+b(176)+0.5_dp*b(178)+0.63_dp*b(180)+0.25_dp*b(184)
    ! jvs(229) = jac_full(39,57)
    jvs(229) = -b(92)+0.28_dp*b(151)+b(188)+b(196)+0.5_dp*b(198)
    ! jvs(230) = jac_full(40,40)
    jvs(230) = -b(110)-b(114)-b(118)
    ! jvs(231) = jac_full(40,53)
    jvs(231) = -b(111)
    ! jvs(232) = jac_full(40,54)
    jvs(232) = -b(115)
    ! jvs(233) = jac_full(40,57)
    jvs(233) = -b(119)
    ! jvs(234) = jac_full(41,8)
    jvs(234) = 0.08_dp*b(122)
    ! jvs(235) = jac_full(41,12)
    jvs(235) = 0.5_dp*b(124)
    ! jvs(236) = jac_full(41,25)
    jvs(236) = b(108)
    ! jvs(237) = jac_full(41,26)
    jvs(237) = 0.6_dp*b(128)
    ! jvs(238) = jac_full(41,31)
    jvs(238) = b(134)+0.03_dp*b(137)
    ! jvs(239) = jac_full(41,37)
    jvs(239) = b(116)
    ! jvs(240) = jac_full(41,38)
    jvs(240) = 0.08_dp*b(139)+0.2_dp*b(141)
    ! jvs(241) = jac_full(41,40)
    jvs(241) = b(114)
    ! jvs(242) = jac_full(41,41)
    jvs(242) = -b(185)-b(199)-b(219)
    ! jvs(243) = jac_full(41,42)
    jvs(243) = b(102)
    ! jvs(244) = jac_full(41,47)
    jvs(244) = 0.2_dp*b(145)+0.07_dp*b(147)+0.93_dp*b(150)
    ! jvs(245) = jac_full(41,49)
    jvs(245) = 0.4_dp*b(154)
    ! jvs(246) = jac_full(41,50)
    jvs(246) = 0.34_dp*b(171)+0.4_dp*b(191)
    ! jvs(247) = jac_full(41,51)
    jvs(247) = 0.41_dp*b(163)
    ! jvs(248) = jac_full(41,52)
    jvs(248) = -b(220)
    ! jvs(249) = jac_full(41,53)
    jvs(249) = 0.03_dp*b(138)+0.2_dp*b(142)+0.07_dp*b(148)
    ! jvs(250) = jac_full(41,54)
    jvs(250) = b(103)+b(109)+b(115)+b(117)+0.08_dp*b(123)+0.5_dp*b(125) + &
               0.6_dp*b(129)+b(135)+0.08_dp*b(140)+0.2_dp*b(146)
    ! jvs(251) = jac_full(41,55)
    jvs(251) = 0.34_dp*b(172)-b(186)
    ! jvs(252) = jac_full(41,57)
    jvs(252) = 0.93_dp*b(151)+0.4_dp*b(192)-b(200)
    ! jvs(253) = jac_full(42,12)
    jvs(253) = 0.8_dp*b(124)
    ! jvs(254) = jac_full(42,31)
    jvs(254) = 0.2_dp*b(137)
    ! jvs(255) = jac_full(42,34)
    jvs(255) = 0.34_dp*b(183)
    ! jvs(256) = jac_full(42,37)
    jvs(256) = 0.07_dp*b(112)
    ! jvs(257) = jac_full(42,40)
    jvs(257) = 0.04_dp*b(110)
    ! jvs(258) = jac_full(42,42)
    jvs(258) = -b(101)-b(102)-b(104)
    ! jvs(259) = jac_full(42,47)
    jvs(259) = 0.85_dp*b(147)
    ! jvs(260) = jac_full(42,49)
    jvs(260) = 0.19_dp*b(159)
    ! jvs(261) = jac_full(42,52)
    jvs(261) = 0.0_dp
    ! jvs(262) = jac_full(42,53)
    jvs(262) = 0.04_dp*b(111)+0.07_dp*b(113)+0.2_dp*b(138)+0.85_dp*b(148)
    ! jvs(263) = jac_full(42,54)
    jvs(263) = -b(103)+0.8_dp*b(125)+0.19_dp*b(160)
    ! jvs(264) = jac_full(42,55)
    jvs(264) = 0.34_dp*b(184)
    ! jvs(265) = jac_full(42,57)
    jvs(265) = -b(105)
    ! jvs(266) = jac_full(43,14)
    jvs(266) = b(81)
    ! jvs(267) = jac_full(43,23)
    jvs(267) = 0.7_dp*b(157)
    ! jvs(268) = jac_full(43,37)
    jvs(268) = 0.05_dp*b(112)
    ! jvs(269) = jac_full(43,40)
    jvs(269) = 0.06_dp*b(110)
    ! jvs(270) = jac_full(43,43)
    jvs(270) = -b(169)-b(189)-b(203)
    ! jvs(271) = jac_full(43,49)
    jvs(271) = 0.1_dp*b(154)
    ! jvs(272) = jac_full(43,50)
    jvs(272) = 0.08_dp*b(171)+0.1_dp*b(191)
    ! jvs(273) = jac_full(43,51)
    jvs(273) = 0.1_dp*b(163)
    ! jvs(274) = jac_full(43,52)
    jvs(274) = -b(204)
    ! jvs(275) = jac_full(43,53)
    jvs(275) = 0.06_dp*b(111)+0.05_dp*b(113)
    ! jvs(276) = jac_full(43,54)
    jvs(276) = b(82)+0.7_dp*b(158)
    ! jvs(277) = jac_full(43,55)
    jvs(277) = -b(170)+0.08_dp*b(172)
    ! jvs(278) = jac_full(43,57)
    jvs(278) = -b(190)+0.1_dp*b(192)
    ! jvs(279) = jac_full(44,37)
    jvs(279) = b(120)
    ! jvs(280) = jac_full(44,40)
    jvs(280) = b(118)
    ! jvs(281) = jac_full(44,44)
    jvs(281) = -b(177)-b(197)-b(211)
    ! jvs(282) = jac_full(44,51)
    jvs(282) = b(161)
    ! jvs(283) = jac_full(44,52)
    jvs(283) = -b(212)
    ! jvs(284) = jac_full(44,53)
    jvs(284) = 0.0_dp
    ! jvs(285) = jac_full(44,54)
    jvs(285) = b(162)
    ! jvs(286) = jac_full(44,55)
    jvs(286) = -b(178)
    ! jvs(287) = jac_full(44,57)
    jvs(287) = b(119)+b(121)-b(198)
    ! jvs(288) = jac_full(45,23)
    jvs(288) = b(153)+0.3_dp*b(157)
    ! jvs(289) = jac_full(45,25)
    jvs(289) = 0.22_dp*b(108)
    ! jvs(290) = jac_full(45,31)
    jvs(290) = 0.03_dp*b(137)
    ! jvs(291) = jac_full(45,32)
    jvs(291) = 0.8_dp*b(181)
    ! jvs(292) = jac_full(45,34)
    jvs(292) = 0.55_dp*b(183)
    ! jvs(293) = jac_full(45,37)
    jvs(293) = 1.03_dp*b(112)+1.77_dp*b(116)
    ! jvs(294) = jac_full(45,38)
    jvs(294) = 0.15_dp*b(141)
    ! jvs(295) = jac_full(45,40)
    jvs(295) = 0.47_dp*b(110)+b(114)
    ! jvs(296) = jac_full(45,43)
    jvs(296) = b(169)+b(189)
    ! jvs(297) = jac_full(45,44)
    jvs(297) = 0.5_dp*b(177)+0.5_dp*b(197)
    ! jvs(298) = jac_full(45,45)
    jvs(298) = -b(93)-b(94)-b(96)
    ! jvs(299) = jac_full(45,47)
    jvs(299) = 0.02_dp*b(147)+0.07_dp*b(149)+0.28_dp*b(150)
    ! jvs(300) = jac_full(45,49)
    jvs(300) = 0.3_dp*b(154)+0.04_dp*b(159)
    ! jvs(301) = jac_full(45,50)
    jvs(301) = 0.25_dp*b(171)+0.3_dp*b(191)
    ! jvs(302) = jac_full(45,51)
    jvs(302) = 0.3_dp*b(163)
    ! jvs(303) = jac_full(45,52)
    jvs(303) = 0.0_dp
    ! jvs(304) = jac_full(45,53)
    jvs(304) = 0.47_dp*b(111)+1.03_dp*b(113)+0.03_dp*b(138) + &
               0.15_dp*b(142)+0.02_dp*b(148)
    ! jvs(305) = jac_full(45,54)
    jvs(305) = -b(95)+0.22_dp*b(109)+b(115)+1.77_dp*b(117) + &
               0.3_dp*b(158)+0.04_dp*b(160)
    ! jvs(306) = jac_full(45,55)
    jvs(306) = b(170)+0.25_dp*b(172)+0.5_dp*b(178)+0.8_dp*b(182)+0.55_dp*b(184)
    ! jvs(307) = jac_full(45,57)
    jvs(307) = -b(97)+0.28_dp*b(151)+b(190)+0.3_dp*b(192)+0.5_dp*b(198)
    ! jvs(308) = jac_full(46,13)
    jvs(308) = b(79)
    ! jvs(309) = jac_full(46,22)
    jvs(309) = 0.7_dp*b(155)
    ! jvs(310) = jac_full(46,36)
    jvs(310) = b(98)
    ! jvs(311) = jac_full(46,37)
    jvs(311) = 0.1_dp*b(112)
    ! jvs(312) = jac_full(46,40)
    jvs(312) = 0.07_dp*b(110)
    ! jvs(313) = jac_full(46,45)
    jvs(313) = b(93)
    ! jvs(314) = jac_full(46,46)
    jvs(314) = -b(167)-b(187)-b(201)
    ! jvs(315) = jac_full(46,47)
    jvs(315) = 0.05_dp*b(147)+0.7_dp*b(149)
    ! jvs(316) = jac_full(46,49)
    jvs(316) = 0.0_dp
    ! jvs(317) = jac_full(46,50)
    jvs(317) = 0.0_dp
    ! jvs(318) = jac_full(46,51)
    jvs(318) = 0.0_dp
    ! jvs(319) = jac_full(46,52)
    jvs(319) = -b(202)
    ! jvs(320) = jac_full(46,53)
    jvs(320) = 0.07_dp*b(111)+0.1_dp*b(113)+0.05_dp*b(148)
    ! jvs(321) = jac_full(46,54)
    jvs(321) = b(80)+0.7_dp*b(156)
    ! jvs(322) = jac_full(46,55)
    jvs(322) = -b(168)+b(173)
    ! jvs(323) = jac_full(46,57)
    jvs(323) = -b(188)+b(193)
    ! jvs(324) = jac_full(46,58)
    jvs(324) = b(174)+b(194)
    ! jvs(325) = jac_full(47,32)
    jvs(325) = 0.2_dp*b(181)
    ! jvs(326) = jac_full(47,33)
    jvs(326) = 0.91_dp*b(179)
    ! jvs(327) = jac_full(47,38)
    jvs(327) = 0.65_dp*b(141)
    ! jvs(328) = jac_full(47,47)
    jvs(328) = -b(145)-b(147)-b(149)-b(150)
    ! jvs(329) = jac_full(47,52)
    jvs(329) = 0.0_dp
    ! jvs(330) = jac_full(47,53)
    jvs(330) = 0.65_dp*b(142)-b(148)
    ! jvs(331) = jac_full(47,54)
    jvs(331) = -b(146)
    ! jvs(332) = jac_full(47,55)
    jvs(332) = 0.91_dp*b(180)+0.2_dp*b(182)
    ! jvs(333) = jac_full(47,57)
    jvs(333) = -b(151)
    ! jvs(334) = jac_full(48,36)
    jvs(334) = b(99)
    ! jvs(335) = jac_full(48,37)
    jvs(335) = 0.11_dp*b(112)
    ! jvs(336) = jac_full(48,47)
    jvs(336) = 0.0_dp
    ! jvs(337) = jac_full(48,48)
    jvs(337) = -b(175)-b(195)-b(209)
    ! jvs(338) = jac_full(48,49)
    jvs(338) = 0.0_dp
    ! jvs(339) = jac_full(48,50)
    jvs(339) = 0.0_dp
    ! jvs(340) = jac_full(48,51)
    jvs(340) = 0.0_dp
    ! jvs(341) = jac_full(48,52)
    jvs(341) = -b(210)
    ! jvs(342) = jac_full(48,53)
    jvs(342) = 0.11_dp*b(113)
    ! jvs(343) = jac_full(48,54)
    jvs(343) = b(100)
    ! jvs(344) = jac_full(48,55)
    jvs(344) = -b(176)
    ! jvs(345) = jac_full(48,57)
    jvs(345) = -b(196)
    ! jvs(346) = jac_full(49,33)
    jvs(346) = b(213)
    ! jvs(347) = jac_full(49,34)
    jvs(347) = b(217)
    ! jvs(348) = jac_full(49,38)
    jvs(348) = 0.0_dp
    ! jvs(349) = jac_full(49,47)
    jvs(349) = 0.0_dp
    ! jvs(350) = jac_full(49,48)
    jvs(350) = b(209)
    ! jvs(351) = jac_full(49,49)
    jvs(351) = -b(154)-b(159)
    ! jvs(352) = jac_full(49,50)
    jvs(352) = b(205)
    ! jvs(353) = jac_full(49,51)
    jvs(353) = 0.0_dp
    ! jvs(354) = jac_full(49,52)
    jvs(354) = b(206)+b(210)+b(214)+b(218)
    ! jvs(355) = jac_full(49,53)
    jvs(355) = 0.0_dp
    ! jvs(356) = jac_full(49,54)
    jvs(356) = -b(160)
    ! jvs(357) = jac_full(49,55)
    jvs(357) = 0.0_dp
    ! jvs(358) = jac_full(49,57)
    jvs(358) = 0.0_dp
    ! jvs(359) = jac_full(50,30)
    jvs(359) = b(83)
    ! jvs(360) = jac_full(50,32)
    jvs(360) = 0.0_dp
    ! jvs(361) = jac_full(50,33)
    jvs(361) = 0.0_dp
    ! jvs(362) = jac_full(50,37)
    jvs(362) = 0.09_dp*b(112)
    ! jvs(363) = jac_full(50,38)
    jvs(363) = 0.0_dp
    ! jvs(364) = jac_full(50,40)
    jvs(364) = 0.03_dp*b(110)
    ! jvs(365) = jac_full(50,44)
    jvs(365) = 0.0_dp
    ! jvs(366) = jac_full(50,47)
    jvs(366) = 0.0_dp
    ! jvs(367) = jac_full(50,49)
    jvs(367) = 0.77_dp*b(159)
    ! jvs(368) = jac_full(50,50)
    jvs(368) = -b(171)-b(191)-b(205)
    ! jvs(369) = jac_full(50,51)
    jvs(369) = 0.0_dp
    ! jvs(370) = jac_full(50,52)
    jvs(370) = -b(206)
    ! jvs(371) = jac_full(50,53)
    jvs(371) = 0.03_dp*b(111)+0.09_dp*b(113)
    ! jvs(372) = jac_full(50,54)
    jvs(372) = b(84)+0.77_dp*b(160)
    ! jvs(373) = jac_full(50,55)
    jvs(373) = -b(172)
    ! jvs(374) = jac_full(50,57)
    jvs(374) = -b(192)
    ! jvs(375) = jac_full(51,15)
    jvs(375) = b(132)
    ! jvs(376) = jac_full(51,19)
    jvs(376) = 0.05_dp*b(126)
    ! jvs(377) = jac_full(51,26)
    jvs(377) = 0.0_dp
    ! jvs(378) = jac_full(51,32)
    jvs(378) = 0.8_dp*b(181)+b(215)
    ! jvs(379) = jac_full(51,33)
    jvs(379) = 0.09_dp*b(179)
    ! jvs(380) = jac_full(51,38)
    jvs(380) = 0.0_dp
    ! jvs(381) = jac_full(51,44)
    jvs(381) = 0.5_dp*b(177)+0.5_dp*b(197)+b(211)
    ! jvs(382) = jac_full(51,47)
    jvs(382) = 0.93_dp*b(150)
    ! jvs(383) = jac_full(51,50)
    jvs(383) = 0.16_dp*b(171)
    ! jvs(384) = jac_full(51,51)
    jvs(384) = -b(161)-b(163)
    ! jvs(385) = jac_full(51,52)
    jvs(385) = b(212)+b(216)
    ! jvs(386) = jac_full(51,53)
    jvs(386) = 0.0_dp
    ! jvs(387) = jac_full(51,54)
    jvs(387) = -b(162)
    ! jvs(388) = jac_full(51,55)
    jvs(388) = 0.05_dp*b(127)+0.16_dp*b(172)+0.5_dp*b(178) + &
               0.09_dp*b(180)+0.8_dp*b(182)
    ! jvs(389) = jac_full(51,56)
    jvs(389) = b(133)
    ! jvs(390) = jac_full(51,57)
    jvs(390) = 0.93_dp*b(151)+0.5_dp*b(198)
    ! jvs(391) = jac_full(52,8)
    jvs(391) = 0.2_dp*b(122)
    ! jvs(392) = jac_full(52,10)
    jvs(392) = b(49)
    ! jvs(393) = jac_full(52,11)
    jvs(393) = b(77)
    ! jvs(394) = jac_full(52,12)
    jvs(394) = 0.55_dp*b(124)
    ! jvs(395) = jac_full(52,16)
    jvs(395) = 0.0_dp
    ! jvs(396) = jac_full(52,17)
    jvs(396) = b(5)+b(60)
    ! jvs(397) = jac_full(52,18)
    jvs(397) = b(33)
    ! jvs(398) = jac_full(52,19)
    jvs(398) = 0.95_dp*b(126)
    ! jvs(399) = jac_full(52,20)
    jvs(399) = b(85)
    ! jvs(400) = jac_full(52,22)
    jvs(400) = b(152)
    ! jvs(401) = jac_full(52,23)
    jvs(401) = b(153)
    ! jvs(402) = jac_full(52,25)
    jvs(402) = 0.2_dp*b(106)+b(108)
    ! jvs(403) = jac_full(52,26)
    jvs(403) = 0.6_dp*b(128)
    ! jvs(404) = jac_full(52,28)
    jvs(404) = b(75)
    ! jvs(405) = jac_full(52,31)
    jvs(405) = 2_dp*b(134)+b(136)+0.76_dp*b(137)
    ! jvs(406) = jac_full(52,32)
    jvs(406) = 0.8_dp*b(181)-b(215)
    ! jvs(407) = jac_full(52,33)
    jvs(407) = 0.91_dp*b(179)-b(213)
    ! jvs(408) = jac_full(52,34)
    jvs(408) = b(183)-b(217)
    ! jvs(409) = jac_full(52,35)
    jvs(409) = -2_dp*b(52)
    ! jvs(410) = jac_full(52,37)
    jvs(410) = 0.22_dp*b(112)+b(116)
    ! jvs(411) = jac_full(52,38)
    jvs(411) = 0.07_dp*b(141)
    ! jvs(412) = jac_full(52,39)
    jvs(412) = 2_dp*b(87)+b(89)+b(91)
    ! jvs(413) = jac_full(52,40)
    jvs(413) = 0.26_dp*b(110)+b(114)
    ! jvs(414) = jac_full(52,41)
    jvs(414) = -b(219)
    ! jvs(415) = jac_full(52,42)
    jvs(415) = b(101)
    ! jvs(416) = jac_full(52,43)
    jvs(416) = b(169)+b(189)-b(203)
    ! jvs(417) = jac_full(52,44)
    jvs(417) = 0.5_dp*b(177)+0.5_dp*b(197)-b(211)
    ! jvs(418) = jac_full(52,45)
    jvs(418) = b(93)
    ! jvs(419) = jac_full(52,46)
    jvs(419) = b(167)+b(187)-b(201)
    ! jvs(420) = jac_full(52,47)
    jvs(420) = 0.1_dp*b(147)+0.33_dp*b(149)+0.93_dp*b(150)
    ! jvs(421) = jac_full(52,48)
    jvs(421) = -b(209)
    ! jvs(422) = jac_full(52,49)
    jvs(422) = 0.9_dp*b(154)
    ! jvs(423) = jac_full(52,50)
    jvs(423) = 0.76_dp*b(171)+0.9_dp*b(191)-b(205)
    ! jvs(424) = jac_full(52,51)
    jvs(424) = 0.9_dp*b(163)
    ! jvs(425) = jac_full(52,52)
    jvs(425) = -b(31)-b(47)-2_dp*b(51)-2_dp*b(53)-b(54)-b(56)-b(58) - &
               b(68)-b(202)-b(204)-b(206)-b(207)-b(210)-b(212)-b(214) - &
               b(216)-b(218)-b(220)
    ! jvs(426) = jac_full(52,53)
    jvs(426) = b(29)-b(32)+0.2_dp*b(107)+0.26_dp*b(111)+0.22_dp*b(113) + &
               0.76_dp*b(138)+0.07_dp*b(142)+0.1_dp*b(148)
    ! jvs(427) = jac_full(52,54)
    jvs(427) = b(30)+b(34)+b(39)-b(48)+b(50)+b(76)+b(78)+b(86) + &
               b(90)+b(109)+b(115)+b(117)+0.2_dp*b(123)+0.55_dp*b(125) + &
               0.6_dp*b(129)+2_dp*b(135)
    ! jvs(428) = jac_full(52,55)
    jvs(428) = -b(55)+0.95_dp*b(127)+b(168)+b(170)+0.76_dp*b(172) + &
               0.5_dp*b(178)+0.91_dp*b(180)+0.8_dp*b(182)+b(184)
    ! jvs(429) = jac_full(52,56)
    jvs(429) = -b(57)-b(59)
    ! jvs(430) = jac_full(52,57)
    jvs(430) = b(40)-b(69)+b(92)+0.93_dp*b(151)+b(188)+b(190) + &
               0.9_dp*b(192)+0.5_dp*b(198)
    ! jvs(431) = jac_full(52,58)
    jvs(431) = -b(208)
    ! jvs(432) = jac_full(53,25)
    jvs(432) = -b(106)
    ! jvs(433) = jac_full(53,27)
    jvs(433) = b(15)-b(17)
    ! jvs(434) = jac_full(53,31)
    jvs(434) = -b(137)
    ! jvs(435) = jac_full(53,35)
    jvs(435) = 0.0_dp
    ! jvs(436) = jac_full(53,37)
    jvs(436) = -b(112)
    ! jvs(437) = jac_full(53,38)
    jvs(437) = -b(141)
    ! jvs(438) = jac_full(53,40)
    jvs(438) = -b(110)
    ! jvs(439) = jac_full(53,47)
    jvs(439) = -b(147)
    ! jvs(440) = jac_full(53,52)
    jvs(440) = -b(31)+0.4_dp*b(207)
    ! jvs(441) = jac_full(53,53)
    jvs(441) = -b(6)-b(7)-b(18)-b(25)-b(27)-b(29)-b(32)-b(107) - &
               b(111)-b(113)-b(138)-b(142)-b(148)
    ! jvs(442) = jac_full(53,54)
    jvs(442) = -b(30)
    ! jvs(443) = jac_full(53,55)
    jvs(443) = -b(26)
    ! jvs(444) = jac_full(53,56)
    jvs(444) = -b(28)
    ! jvs(445) = jac_full(53,57)
    jvs(445) = 0.0_dp
    ! jvs(446) = jac_full(53,58)
    jvs(446) = 0.4_dp*b(208)
    ! jvs(447) = jac_full(54,8)
    jvs(447) = -b(122)
    ! jvs(448) = jac_full(54,9)
    jvs(448) = 2_dp*b(13)
    ! jvs(449) = jac_full(54,10)
    jvs(449) = 2_dp*b(8)-b(49)
    ! jvs(450) = jac_full(54,11)
    jvs(450) = -b(77)
    ! jvs(451) = jac_full(54,12)
    jvs(451) = -b(124)
    ! jvs(452) = jac_full(54,13)
    jvs(452) = -b(79)
    ! jvs(453) = jac_full(54,14)
    jvs(453) = -b(81)
    ! jvs(454) = jac_full(54,16)
    jvs(454) = -b(221)
    ! jvs(455) = jac_full(54,17)
    jvs(455) = -b(45)
    ! jvs(456) = jac_full(54,18)
    jvs(456) = -b(33)
    ! jvs(457) = jac_full(54,20)
    jvs(457) = -b(85)
    ! jvs(458) = jac_full(54,21)
    jvs(458) = b(3)-b(41)
    ! jvs(459) = jac_full(54,22)
    jvs(459) = b(152)-0.7_dp*b(155)
    ! jvs(460) = jac_full(54,23)
    jvs(460) = b(153)-0.7_dp*b(157)
    ! jvs(461) = jac_full(54,25)
    jvs(461) = 0.12_dp*b(106)-b(108)
    ! jvs(462) = jac_full(54,26)
    jvs(462) = -b(128)
    ! jvs(463) = jac_full(54,28)
    jvs(463) = -b(75)
    ! jvs(464) = jac_full(54,29)
    jvs(464) = b(4)-b(43)
    ! jvs(465) = jac_full(54,30)
    jvs(465) = -b(83)
    ! jvs(466) = jac_full(54,31)
    jvs(466) = -b(134)+0.08_dp*b(137)
    ! jvs(467) = jac_full(54,32)
    jvs(467) = 0.0_dp
    ! jvs(468) = jac_full(54,33)
    jvs(468) = 0.0_dp
    ! jvs(469) = jac_full(54,34)
    jvs(469) = 0.0_dp
    ! jvs(470) = jac_full(54,35)
    jvs(470) = 2_dp*b(14)
    ! jvs(471) = jac_full(54,36)
    jvs(471) = -b(99)
    ! jvs(472) = jac_full(54,37)
    jvs(472) = 0.6_dp*b(112)-b(116)
    ! jvs(473) = jac_full(54,38)
    jvs(473) = -b(139)+0.27_dp*b(141)
    ! jvs(474) = jac_full(54,39)
    jvs(474) = -b(89)
    ! jvs(475) = jac_full(54,40)
    jvs(475) = 0.33_dp*b(110)-b(114)
    ! jvs(476) = jac_full(54,42)
    jvs(476) = -b(102)
    ! jvs(477) = jac_full(54,43)
    jvs(477) = 0.0_dp
    ! jvs(478) = jac_full(54,44)
    jvs(478) = 0.0_dp
    ! jvs(479) = jac_full(54,45)
    jvs(479) = -b(94)
    ! jvs(480) = jac_full(54,46)
    jvs(480) = 0.0_dp
    ! jvs(481) = jac_full(54,47)
    jvs(481) = -b(145)+0.27_dp*b(147)
    ! jvs(482) = jac_full(54,48)
    jvs(482) = 0.0_dp
    ! jvs(483) = jac_full(54,49)
    jvs(483) = b(154)-0.77_dp*b(159)
    ! jvs(484) = jac_full(54,50)
    jvs(484) = 0.0_dp
    ! jvs(485) = jac_full(54,51)
    jvs(485) = -b(161)
    ! jvs(486) = jac_full(54,52)
    jvs(486) = b(31)-b(47)+b(54)+0.7_dp*b(68)
    ! jvs(487) = jac_full(54,53)
    jvs(487) = -b(29)+b(32)+0.12_dp*b(107)+0.33_dp*b(111)+0.6_dp*b(113) + &
               0.08_dp*b(138)+0.27_dp*b(142)+0.27_dp*b(148)
    ! jvs(488) = jac_full(54,54)
    jvs(488) = -b(30)-b(34)-b(35)-b(37)-b(39)-b(42)-b(44)-b(46) - &
                b(48)-b(50)-b(76)-b(78)-b(80)-b(82)-b(84)-b(86) - &
                b(90)-b(95)-b(100)-b(103)-b(109)-b(115)-b(117) - &
                b(123)-b(125)-b(129)-b(135)-b(140)-b(146) - &
                0.7_dp*b(156)-0.7_dp*b(158)-0.77_dp*b(160)-b(162)-b(222)
    ! jvs(489) = jac_full(54,55)
    jvs(489) = -b(36)+b(55)
    ! jvs(490) = jac_full(54,56)
    jvs(490) = -b(38)
    ! jvs(491) = jac_full(54,57)
    jvs(491) = -b(40)+0.7_dp*b(69)
    ! jvs(492) = jac_full(54,58)
    jvs(492) = 0.0_dp
    ! jvs(493) = jac_full(55,19)
    jvs(493) = -b(126)
    ! jvs(494) = jac_full(55,21)
    jvs(494) = b(3)
    ! jvs(495) = jac_full(55,27)
    jvs(495) = b(19)-b(23)
    ! jvs(496) = jac_full(55,32)
    jvs(496) = -b(181)
    ! jvs(497) = jac_full(55,33)
    jvs(497) = -b(179)
    ! jvs(498) = jac_full(55,34)
    jvs(498) = -b(183)
    ! jvs(499) = jac_full(55,35)
    jvs(499) = 0.0_dp
    ! jvs(500) = jac_full(55,38)
    jvs(500) = 0.0_dp
    ! jvs(501) = jac_full(55,40)
    jvs(501) = 0.0_dp
    ! jvs(502) = jac_full(55,41)
    jvs(502) = -b(185)
    ! jvs(503) = jac_full(55,42)
    jvs(503) = 0.0_dp
    ! jvs(504) = jac_full(55,43)
    jvs(504) = -b(169)
    ! jvs(505) = jac_full(55,44)
    jvs(505) = -b(177)
    ! jvs(506) = jac_full(55,46)
    jvs(506) = -b(167)
    ! jvs(507) = jac_full(55,47)
    jvs(507) = 0.0_dp
    ! jvs(508) = jac_full(55,48)
    jvs(508) = -b(175)
    ! jvs(509) = jac_full(55,49)
    jvs(509) = 0.0_dp
    ! jvs(510) = jac_full(55,50)
    jvs(510) = -b(171)
    ! jvs(511) = jac_full(55,51)
    jvs(511) = 0.0_dp
    ! jvs(512) = jac_full(55,52)
    jvs(512) = -b(54)
    ! jvs(513) = jac_full(55,53)
    jvs(513) = -b(25)
    ! jvs(514) = jac_full(55,54)
    jvs(514) = -b(35)
    ! jvs(515) = jac_full(55,55)
    jvs(515) = -b(24)-b(26)-b(36)-b(55)-b(61)-2_dp*b(73)-b(127) - &
               b(168)-b(170)-b(172)-b(173)-b(176)-b(178)-b(180) - &
               b(182)-b(184)-b(186)
    ! jvs(516) = jac_full(55,56)
    jvs(516) = b(1)+b(20)+b(63)
    ! jvs(517) = jac_full(55,57)
    jvs(517) = 0.11_dp*b(2)-b(62)+b(64)
    ! jvs(518) = jac_full(55,58)
    jvs(518) = -b(174)
    ! jvs(519) = jac_full(56,7)
    jvs(519) = b(166)
    ! jvs(520) = jac_full(56,15)
    jvs(520) = -b(132)
    ! jvs(521) = jac_full(56,17)
    jvs(521) = b(5)+b(45)+b(60)
    ! jvs(522) = jac_full(56,19)
    jvs(522) = 0.95_dp*b(126)
    ! jvs(523) = jac_full(56,21)
    jvs(523) = b(41)
    ! jvs(524) = jac_full(56,24)
    jvs(524) = b(72)
    ! jvs(525) = jac_full(56,26)
    jvs(525) = 0.0_dp
    ! jvs(526) = jac_full(56,27)
    jvs(526) = -b(19)-b(21)+b(23)
    ! jvs(527) = jac_full(56,29)
    jvs(527) = b(4)
    ! jvs(528) = jac_full(56,32)
    jvs(528) = 1.2_dp*b(181)
    ! jvs(529) = jac_full(56,33)
    jvs(529) = 0.91_dp*b(179)
    ! jvs(530) = jac_full(56,34)
    jvs(530) = b(183)
    ! jvs(531) = jac_full(56,35)
    jvs(531) = 0.0_dp
    ! jvs(532) = jac_full(56,38)
    jvs(532) = 0.0_dp
    ! jvs(533) = jac_full(56,39)
    jvs(533) = 0.0_dp
    ! jvs(534) = jac_full(56,40)
    jvs(534) = 0.0_dp
    ! jvs(535) = jac_full(56,41)
    jvs(535) = b(185)+b(199)
    ! jvs(536) = jac_full(56,42)
    jvs(536) = 0.0_dp
    ! jvs(537) = jac_full(56,43)
    jvs(537) = b(169)+b(189)
    ! jvs(538) = jac_full(56,44)
    jvs(538) = 1.5_dp*b(177)+1.5_dp*b(197)
    ! jvs(539) = jac_full(56,45)
    jvs(539) = 0.0_dp
    ! jvs(540) = jac_full(56,46)
    jvs(540) = b(167)+b(187)
    ! jvs(541) = jac_full(56,47)
    jvs(541) = 0.0_dp
    ! jvs(542) = jac_full(56,48)
    jvs(542) = b(175)+b(195)
    ! jvs(543) = jac_full(56,49)
    jvs(543) = 0.0_dp
    ! jvs(544) = jac_full(56,50)
    jvs(544) = 0.84_dp*b(171)+b(191)
    ! jvs(545) = jac_full(56,51)
    jvs(545) = b(163)
    ! jvs(546) = jac_full(56,52)
    jvs(546) = b(54)-b(56)-b(58)+0.7_dp*b(68)
    ! jvs(547) = jac_full(56,53)
    jvs(547) = b(25)-b(27)
    ! jvs(548) = jac_full(56,54)
    jvs(548) = -b(37)+b(39)+b(42)+b(46)
    ! jvs(549) = jac_full(56,55)
    jvs(549) = b(24)+b(26)+b(55)+2_dp*b(61)+2_dp*b(73)+0.95_dp*b(127) + &
               b(168)+b(170)+0.84_dp*b(172)+b(173)+b(176)+1.5_dp*b(178) + &
               0.91_dp*b(180)+1.2_dp*b(182)+b(184)+b(186)
    ! jvs(550) = jac_full(56,56)
    jvs(550) = -b(1)-b(20)-b(22)-b(28)-b(38)-b(57)-b(59)-b(65)-b(133)-b(164)
    ! jvs(551) = jac_full(56,57)
    jvs(551) = 0.89_dp*b(2)+b(40)+2_dp*b(62)-b(66)+2_dp*b(67)+0.7_dp*b(69) + &
               b(188)+b(190)+b(192)+b(193)+b(196)+1.5_dp*b(198)+b(200)
    ! jvs(552) = jac_full(56,58)
    jvs(552) = -b(165)+b(174)+b(194)
    ! jvs(553) = jac_full(57,16)
    jvs(553) = -b(223)
    ! jvs(554) = jac_full(57,24)
    jvs(554) = b(72)
    ! jvs(555) = jac_full(57,26)
    jvs(555) = -b(130)
    ! jvs(556) = jac_full(57,27)
    jvs(556) = b(21)
    ! jvs(557) = jac_full(57,29)
    jvs(557) = b(43)
    ! jvs(558) = jac_full(57,35)
    jvs(558) = 0.0_dp
    ! jvs(559) = jac_full(57,37)
    jvs(559) = -b(120)
    ! jvs(560) = jac_full(57,38)
    jvs(560) = -b(143)
    ! jvs(561) = jac_full(57,39)
    jvs(561) = -b(91)
    ! jvs(562) = jac_full(57,40)
    jvs(562) = -b(118)
    ! jvs(563) = jac_full(57,41)
    jvs(563) = -b(199)
    ! jvs(564) = jac_full(57,42)
    jvs(564) = -b(104)
    ! jvs(565) = jac_full(57,43)
    jvs(565) = -b(189)
    ! jvs(566) = jac_full(57,44)
    jvs(566) = -b(197)
    ! jvs(567) = jac_full(57,45)
    jvs(567) = -b(96)
    ! jvs(568) = jac_full(57,46)
    jvs(568) = -b(187)
    ! jvs(569) = jac_full(57,47)
    jvs(569) = -b(150)
    ! jvs(570) = jac_full(57,48)
    jvs(570) = -b(195)
    ! jvs(571) = jac_full(57,49)
    jvs(571) = 0.0_dp
    ! jvs(572) = jac_full(57,50)
    jvs(572) = -b(191)
    ! jvs(573) = jac_full(57,51)
    jvs(573) = 0.0_dp
    ! jvs(574) = jac_full(57,52)
    jvs(574) = -b(68)
    ! jvs(575) = jac_full(57,53)
    jvs(575) = b(27)
    ! jvs(576) = jac_full(57,54)
    jvs(576) = -b(39)+b(44)
    ! jvs(577) = jac_full(57,55)
    jvs(577) = -b(61)
    ! jvs(578) = jac_full(57,56)
    jvs(578) = b(22)+b(28)-b(63)-b(65)
    ! jvs(579) = jac_full(57,57)
    jvs(579) = -b(2)-b(40)-b(62)-b(64)-b(66)-2_dp*b(67)-b(69)-b(92) - &
               b(97)-b(105)-b(119)-b(121)-b(131)-b(144)-b(151) - &
               b(188)-b(190)-b(192)-b(193)-b(196)-b(198)-b(200)-b(224)
    ! jvs(580) = jac_full(57,58)
    jvs(580) = -b(194)
    ! jvs(581) = jac_full(58,7)
    jvs(581) = b(166)
    ! jvs(582) = jac_full(58,31)
    jvs(582) = b(134)+b(136)+0.62_dp*b(137)
    ! jvs(583) = jac_full(58,36)
    jvs(583) = b(98)
    ! jvs(584) = jac_full(58,37)
    jvs(584) = 0.19_dp*b(112)
    ! jvs(585) = jac_full(58,38)
    jvs(585) = 0.2_dp*b(141)
    ! jvs(586) = jac_full(58,40)
    jvs(586) = 0.13_dp*b(110)
    ! jvs(587) = jac_full(58,42)
    jvs(587) = b(101)+b(102)+b(104)
    ! jvs(588) = jac_full(58,45)
    jvs(588) = b(94)+b(96)
    ! jvs(589) = jac_full(58,47)
    jvs(589) = 0.5_dp*b(145)+0.11_dp*b(147)+0.97_dp*b(149)+0.07_dp*b(150)
    ! jvs(590) = jac_full(58,48)
    jvs(590) = b(175)+b(195)
    ! jvs(591) = jac_full(58,49)
    jvs(591) = 0.0_dp
    ! jvs(592) = jac_full(58,50)
    jvs(592) = 0.0_dp
    ! jvs(593) = jac_full(58,51)
    jvs(593) = 0.0_dp
    ! jvs(594) = jac_full(58,52)
    jvs(594) = -b(207)
    ! jvs(595) = jac_full(58,53)
    jvs(595) = 0.13_dp*b(111)+0.19_dp*b(113)+0.62_dp*b(138) + &
               0.2_dp*b(142)+0.11_dp*b(148)
    ! jvs(596) = jac_full(58,54)
    jvs(596) = b(95)+b(103)+b(135)+0.5_dp*b(146)
    ! jvs(597) = jac_full(58,55)
    jvs(597) = -b(173)+b(176)
    ! jvs(598) = jac_full(58,56)
    jvs(598) = -b(164)
    ! jvs(599) = jac_full(58,57)
    jvs(599) = b(97)+b(105)+0.07_dp*b(151)-b(193)+b(196)
    ! jvs(600) = jac_full(58,58)
    jvs(600) = -b(165)-b(174)-b(194)-b(208)

  end subroutine jac_sp

end module mod_cbmz_jacobian

! vim: tabstop=8 expandtab shiftwidth=2 softtabstop=2
