! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!
! Linear Algebra Data and Routines File
!
! Generated by KPP-2.2.3 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
!
! File                 : mod_cbmz_LinearAlgebra.f90
! Time                 : Mon Nov 25 13:41:15 2013
! Working directory    : /scratch/ashalaby/kpp-2.2.3/compare/CBMZ
! Equation file        : mod_cbmz.kpp
! Output root filename : mod_cbmz
!
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

module mod_cbmz_linearalgebra

  use mod_cbmz_parameters
  use mod_cbmz_jacobiansp

  implicit none

  contains

  ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  !        sparse lu factorization
  ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  subroutine kppdecomp( jvs, ier )
    implicit none
    real(kind=dp) , dimension(lu_nonzero) , intent(inout) :: jvs
    real(kind=dp) , dimension(nvar) ::  w
    real(kind=dp) :: a
    integer , intent(out) :: ier
    integer :: k, kk, j, jj

    ier = 0
    a = 0.0_dp ! mz_rs_20050606
    do k=1,nvar
      ! mz_rs_20050606: don't check if real value == 0
      ! if ( jvs( lu_diag(k) ) .eq. 0. ) then
      if ( abs(jvs(lu_diag(k))) < tiny(a) ) then
        ier = k
        return
      end if
      do kk = lu_crow(k), lu_crow(k+1)-1
        w( lu_icol(kk) ) = jvs(kk)
      end do
      do kk = lu_crow(k), lu_diag(k)-1
        j = lu_icol(kk)
        a = -w(j) / jvs( lu_diag(j) )
        w(j) = -a
        do jj = lu_diag(j)+1, lu_crow(j+1)-1
          w( lu_icol(jj) ) = w( lu_icol(jj) ) + a*jvs(jj)
        end do
      end do
      do kk = lu_crow(k), lu_crow(k+1)-1
        jvs(kk) = w( lu_icol(kk) )
      end do
    end do
  end subroutine kppdecomp

  ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  !
  ! kppsolve - sparse back substitution
  !   arguments :
  !      jvs       - sparse jacobian of variables
  !      x         - vector for variables
  !
  ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

  subroutine kppsolve ( jvs, x )
    implicit none
    ! jvs - sparse jacobian of variables
    real(kind=dp) , dimension(lu_nonzero) , intent(in) :: jvs
    ! x - vector for variables
    real(kind=dp) , dimension(nvar) , intent(inout) :: x

    x(19) = x(19)-jvs(73)*x(8)-jvs(74)*x(12)
    x(26) = x(26)-jvs(103)*x(8)-jvs(104)*x(12)
    x(27) = x(27)-jvs(108)*x(9)
    x(28) = x(28)-jvs(115)*x(25)
    x(29) = x(29)-jvs(130)*x(16)-jvs(131)*x(24)-jvs(132)*x(26)
    x(30) = x(30)-jvs(143)*x(12)
    x(31) = x(31)-jvs(159)*x(19)-jvs(160)*x(26)
    x(35) = x(35)-jvs(181)*x(9)-jvs(182)*x(18)-jvs(183)*x(24)
    x(36) = x(36)-jvs(191)*x(34)
    x(39) = x(39)-jvs(211)*x(20)-jvs(212)*x(22)-jvs(213)*x(25) - &
            jvs(214)*x(31)-jvs(215)*x(33)-jvs(216)*x(34)-jvs(217)*x(37) - &
            jvs(218)*x(38)
    x(41) = x(41)-jvs(234)*x(8)-jvs(235)*x(12)-jvs(236)*x(25) - &
            jvs(237)*x(26)-jvs(238)*x(31)-jvs(239)*x(37)-jvs(240)*x(38) - &
            jvs(241)*x(40)
    x(42) = x(42)-jvs(253)*x(12)-jvs(254)*x(31)-jvs(255)*x(34) - &
            jvs(256)*x(37)-jvs(257)*x(40)
    x(43) = x(43)-jvs(266)*x(14)-jvs(267)*x(23)-jvs(268)*x(37)-jvs(269)*x(40)
    x(44) = x(44)-jvs(279)*x(37)-jvs(280)*x(40)
    x(45) = x(45)-jvs(288)*x(23)-jvs(289)*x(25)-jvs(290)*x(31) - &
            jvs(291)*x(32)-jvs(292)*x(34)-jvs(293)*x(37)-jvs(294)*x(38) - &
            jvs(295)*x(40)-jvs(296)*x(43)-jvs(297)*x(44)
    x(46) = x(46)-jvs(308)*x(13)-jvs(309)*x(22)-jvs(310)*x(36) - &
            jvs(311)*x(37)-jvs(312)*x(40)-jvs(313)*x(45)
    x(47) = x(47)-jvs(325)*x(32)-jvs(326)*x(33)-jvs(327)*x(38)
    x(48) = x(48)-jvs(334)*x(36)-jvs(335)*x(37)-jvs(336)*x(47)
    x(49) = x(49)-jvs(346)*x(33)-jvs(347)*x(34)-jvs(348)*x(38) - &
            jvs(349)*x(47)-jvs(350)*x(48)
    x(50) = x(50)-jvs(359)*x(30)-jvs(360)*x(32)-jvs(361)*x(33) - &
            jvs(362)*x(37)-jvs(363)*x(38)-jvs(364)*x(40)-jvs(365)*x(44) - &
            jvs(366)*x(47)-jvs(367)*x(49)
    x(51) = x(51)-jvs(375)*x(15)-jvs(376)*x(19)-jvs(377)*x(26) - &
            jvs(378)*x(32)-jvs(379)*x(33)-jvs(380)*x(38)-jvs(381)*x(44) - &
            jvs(382)*x(47)-jvs(383)*x(50)
    x(52) = x(52)-jvs(391)*x(8)-jvs(392)*x(10)-jvs(393)*x(11) - &
            jvs(394)*x(12)-jvs(395)*x(16)-jvs(396)*x(17)-jvs(397)*x(18) - &
            jvs(398)*x(19)-jvs(399)*x(20)-jvs(400)*x(22)-jvs(401)*x(23) - &
            jvs(402)*x(25)-jvs(403)*x(26)-jvs(404)*x(28)-jvs(405)*x(31) - &
            jvs(406)*x(32)-jvs(407)*x(33)-jvs(408)*x(34)-jvs(409)*x(35) - &
            jvs(410)*x(37)-jvs(411)*x(38)-jvs(412)*x(39)-jvs(413)*x(40) - &
            jvs(414)*x(41)-jvs(415)*x(42)-jvs(416)*x(43)-jvs(417)*x(44) - &
            jvs(418)*x(45)-jvs(419)*x(46)-jvs(420)*x(47)-jvs(421)*x(48) - &
            jvs(422)*x(49)-jvs(423)*x(50)-jvs(424)*x(51)
    x(53) = x(53)-jvs(432)*x(25)-jvs(433)*x(27)-jvs(434)*x(31) - &
            jvs(435)*x(35)-jvs(436)*x(37)-jvs(437)*x(38)-jvs(438)*x(40) - &
            jvs(439)*x(47)-jvs(440)*x(52)
    x(54) = x(54)-jvs(447)*x(8)-jvs(448)*x(9)-jvs(449)*x(10) - &
            jvs(450)*x(11)-jvs(451)*x(12)-jvs(452)*x(13)-jvs(453)*x(14) - &
            jvs(454)*x(16)-jvs(455)*x(17)-jvs(456)*x(18)-jvs(457)*x(20) - &
            jvs(458)*x(21)-jvs(459)*x(22)-jvs(460)*x(23)-jvs(461)*x(25) - &
            jvs(462)*x(26)-jvs(463)*x(28)-jvs(464)*x(29)-jvs(465)*x(30) - &
            jvs(466)*x(31)-jvs(467)*x(32)-jvs(468)*x(33)-jvs(469)*x(34) - &
            jvs(470)*x(35)-jvs(471)*x(36)-jvs(472)*x(37)-jvs(473)*x(38) - &
            jvs(474)*x(39)-jvs(475)*x(40)-jvs(476)*x(42)-jvs(477)*x(43) - &
            jvs(478)*x(44)-jvs(479)*x(45)-jvs(480)*x(46)-jvs(481)*x(47) - &
            jvs(482)*x(48)-jvs(483)*x(49)-jvs(484)*x(50)-jvs(485)*x(51) - &
            jvs(486)*x(52)-jvs(487)*x(53)
    x(55) = x(55)-jvs(493)*x(19)-jvs(494)*x(21)-jvs(495)*x(27) - &
            jvs(496)*x(32)-jvs(497)*x(33)-jvs(498)*x(34)-jvs(499)*x(35) - &
            jvs(500)*x(38)-jvs(501)*x(40)-jvs(502)*x(41)-jvs(503)*x(42) - &
            jvs(504)*x(43)-jvs(505)*x(44)-jvs(506)*x(46)-jvs(507)*x(47) - &
            jvs(508)*x(48)-jvs(509)*x(49)-jvs(510)*x(50)-jvs(511)*x(51) - &
            jvs(512)*x(52)-jvs(513)*x(53)-jvs(514)*x(54)
    x(56) = x(56)-jvs(519)*x(7)-jvs(520)*x(15)-jvs(521)*x(17) - &
            jvs(522)*x(19)-jvs(523)*x(21)-jvs(524)*x(24)-jvs(525)*x(26) - &
            jvs(526)*x(27)-jvs(527)*x(29)-jvs(528)*x(32)-jvs(529)*x(33) - &
            jvs(530)*x(34)-jvs(531)*x(35)-jvs(532)*x(38)-jvs(533)*x(39) - &
            jvs(534)*x(40)-jvs(535)*x(41)-jvs(536)*x(42)-jvs(537)*x(43) - &
            jvs(538)*x(44)-jvs(539)*x(45)-jvs(540)*x(46)-jvs(541)*x(47) - &
            jvs(542)*x(48)-jvs(543)*x(49)-jvs(544)*x(50)-jvs(545)*x(51) - &
            jvs(546)*x(52)-jvs(547)*x(53)-jvs(548)*x(54)-jvs(549)*x(55)
    x(57) = x(57)-jvs(553)*x(16)-jvs(554)*x(24)-jvs(555)*x(26) - &
            jvs(556)*x(27)-jvs(557)*x(29)-jvs(558)*x(35)-jvs(559)*x(37) - &
            jvs(560)*x(38)-jvs(561)*x(39)-jvs(562)*x(40)-jvs(563)*x(41) - &
            jvs(564)*x(42)-jvs(565)*x(43)-jvs(566)*x(44)-jvs(567)*x(45) - &
            jvs(568)*x(46)-jvs(569)*x(47)-jvs(570)*x(48)-jvs(571)*x(49) - &
            jvs(572)*x(50)-jvs(573)*x(51)-jvs(574)*x(52)-jvs(575)*x(53) - &
            jvs(576)*x(54)-jvs(577)*x(55)-jvs(578)*x(56)
    x(58) = x(58)-jvs(581)*x(7)-jvs(582)*x(31)-jvs(583)*x(36) - &
            jvs(584)*x(37)-jvs(585)*x(38)-jvs(586)*x(40)-jvs(587)*x(42) - &
            jvs(588)*x(45)-jvs(589)*x(47)-jvs(590)*x(48)-jvs(591)*x(49) - &
            jvs(592)*x(50)-jvs(593)*x(51)-jvs(594)*x(52)-jvs(595)*x(53) - &
            jvs(596)*x(54)-jvs(597)*x(55)-jvs(598)*x(56)-jvs(599)*x(57)

    x(58) = x(58)/jvs(600)
    x(57) = (x(57)-jvs(580)*x(58))/(jvs(579))
    x(56) = (x(56)-jvs(551)*x(57)-jvs(552)*x(58))/(jvs(550))
    x(55) = (x(55)-jvs(516)*x(56)-jvs(517)*x(57)-jvs(518)*x(58))/(jvs(515))
    x(54) = (x(54)-jvs(489)*x(55)-jvs(490)*x(56)-jvs(491)*x(57) - &
            jvs(492)*x(58))/(jvs(488))
    x(53) = (x(53)-jvs(442)*x(54)-jvs(443)*x(55)-jvs(444)*x(56) - &
            jvs(445)*x(57)-jvs(446)*x(58))/(jvs(441))
    x(52) = (x(52)-jvs(426)*x(53)-jvs(427)*x(54)-jvs(428)*x(55) - &
            jvs(429)*x(56)-jvs(430)*x(57)-jvs(431)*x(58))/(jvs(425))
    x(51) = (x(51)-jvs(385)*x(52)-jvs(386)*x(53)-jvs(387)*x(54) - &
            jvs(388)*x(55)-jvs(389)*x(56)-jvs(390)*x(57))/(jvs(384))
    x(50) = (x(50)-jvs(369)*x(51)-jvs(370)*x(52)-jvs(371)*x(53) - &
            jvs(372)*x(54)-jvs(373)*x(55)-jvs(374)*x(57))/(jvs(368))
    x(49) = (x(49)-jvs(352)*x(50)-jvs(353)*x(51)-jvs(354)*x(52) - &
            jvs(355)*x(53)-jvs(356)*x(54)-jvs(357)*x(55) - &
            jvs(358)*x(57))/(jvs(351))
    x(48) = (x(48)-jvs(338)*x(49)-jvs(339)*x(50)-jvs(340)*x(51) - &
            jvs(341)*x(52)-jvs(342)*x(53)-jvs(343)*x(54)-jvs(344)*x(55) - &
            jvs(345)*x(57))/(jvs(337))
    x(47) = (x(47)-jvs(329)*x(52)-jvs(330)*x(53)-jvs(331)*x(54) - &
            jvs(332)*x(55)-jvs(333)*x(57))/(jvs(328))
    x(46) = (x(46)-jvs(315)*x(47)-jvs(316)*x(49)-jvs(317)*x(50) - &
            jvs(318)*x(51)-jvs(319)*x(52)-jvs(320)*x(53)-jvs(321)*x(54) - &
            jvs(322)*x(55)-jvs(323)*x(57)-jvs(324)*x(58))/(jvs(314))
    x(45) = (x(45)-jvs(299)*x(47)-jvs(300)*x(49)-jvs(301)*x(50) - &
            jvs(302)*x(51)-jvs(303)*x(52)-jvs(304)*x(53)-jvs(305)*x(54) - &
            jvs(306)*x(55)-jvs(307)*x(57))/(jvs(298))
    x(44) = (x(44)-jvs(282)*x(51)-jvs(283)*x(52)-jvs(284)*x(53) - &
            jvs(285)*x(54)-jvs(286)*x(55)-jvs(287)*x(57))/(jvs(281))
    x(43) = (x(43)-jvs(271)*x(49)-jvs(272)*x(50)-jvs(273)*x(51) - &
            jvs(274)*x(52)-jvs(275)*x(53)-jvs(276)*x(54)-jvs(277)*x(55) - &
            jvs(278)*x(57))/(jvs(270))
    x(42) = (x(42)-jvs(259)*x(47)-jvs(260)*x(49)-jvs(261)*x(52) - &
            jvs(262)*x(53)-jvs(263)*x(54)-jvs(264)*x(55) - &
            jvs(265)*x(57))/(jvs(258))
    x(41) = (x(41)-jvs(243)*x(42)-jvs(244)*x(47)-jvs(245)*x(49) - &
            jvs(246)*x(50)-jvs(247)*x(51)-jvs(248)*x(52)-jvs(249)*x(53) - &
            jvs(250)*x(54)-jvs(251)*x(55)-jvs(252)*x(57))/(jvs(242))
    x(40) = (x(40)-jvs(231)*x(53)-jvs(232)*x(54)-jvs(233)*x(57))/(jvs(230))
    x(39) = (x(39)-jvs(220)*x(40)-jvs(221)*x(44)-jvs(222)*x(46) - &
            jvs(223)*x(47)-jvs(224)*x(48)-jvs(225)*x(52)-jvs(226)*x(53) - &
            jvs(227)*x(54)-jvs(228)*x(55)-jvs(229)*x(57))/(jvs(219))
    x(38) = (x(38)-jvs(208)*x(53)-jvs(209)*x(54)-jvs(210)*x(57))/(jvs(207))
    x(37) = (x(37)-jvs(204)*x(53)-jvs(205)*x(54)-jvs(206)*x(57))/(jvs(203))
    x(36) = (x(36)-jvs(193)*x(37)-jvs(194)*x(47)-jvs(195)*x(49) - &
            jvs(196)*x(50)-jvs(197)*x(51)-jvs(198)*x(52)-jvs(199)*x(53) - &
            jvs(200)*x(54)-jvs(201)*x(55)-jvs(202)*x(57))/(jvs(192))
    x(35) = (x(35)-jvs(185)*x(40)-jvs(186)*x(52)-jvs(187)*x(53) - &
            jvs(188)*x(54)-jvs(189)*x(56)-jvs(190)*x(57))/(jvs(184))
    x(34) = (x(34)-jvs(177)*x(47)-jvs(178)*x(52)-jvs(179)*x(54) - &
            jvs(180)*x(55))/(jvs(176))
    x(33) = (x(33)-jvs(172)*x(38)-jvs(173)*x(52)-jvs(174)*x(54) - &
            jvs(175)*x(55))/(jvs(171))
    x(32) = (x(32)-jvs(167)*x(38)-jvs(168)*x(52)-jvs(169)*x(55) - &
            jvs(170)*x(57))/(jvs(166))
    x(31) = (x(31)-jvs(162)*x(53)-jvs(163)*x(54)-jvs(164)*x(55) - &
            jvs(165)*x(57))/(jvs(161))
    x(30) = (x(30)-jvs(145)*x(32)-jvs(146)*x(33)-jvs(147)*x(37) - &
            jvs(148)*x(40)-jvs(149)*x(44)-jvs(150)*x(47)-jvs(151)*x(49) - &
            jvs(152)*x(50)-jvs(153)*x(51)-jvs(154)*x(52)-jvs(155)*x(53) - &
            jvs(156)*x(54)-jvs(157)*x(55)-jvs(158)*x(57))/(jvs(144))
    x(29) = (x(29)-jvs(134)*x(35)-jvs(135)*x(39)-jvs(136)*x(42) - &
            jvs(137)*x(45)-jvs(138)*x(47)-jvs(139)*x(52)-jvs(140)*x(54) - &
            jvs(141)*x(56)-jvs(142)*x(57))/(jvs(133))
    x(28) = (x(28)-jvs(117)*x(31)-jvs(118)*x(34)-jvs(119)*x(37) - &
            jvs(120)*x(38)-jvs(121)*x(39)-jvs(122)*x(40)-jvs(123)*x(42) - &
            jvs(124)*x(45)-jvs(125)*x(47)-jvs(126)*x(53)-jvs(127)*x(54) - &
            jvs(128)*x(55)-jvs(129)*x(57))/(jvs(116))
    x(27) = (x(27)-jvs(110)*x(35)-jvs(111)*x(53)-jvs(112)*x(55) - &
            jvs(113)*x(56)-jvs(114)*x(57))/(jvs(109))
    x(26) = (x(26)-jvs(106)*x(54)-jvs(107)*x(57))/(jvs(105))
    x(25) = (x(25)-jvs(101)*x(53)-jvs(102)*x(54))/(jvs(100))
    x(24) = (x(24)-jvs(97)*x(35)-jvs(98)*x(56)-jvs(99)*x(57))/(jvs(96))
    x(23) = (x(23)-jvs(93)*x(43)-jvs(94)*x(52)-jvs(95)*x(54))/(jvs(92))
    x(22) = (x(22)-jvs(89)*x(46)-jvs(90)*x(52)-jvs(91)*x(54))/(jvs(88))
    x(21) = (x(21)-jvs(84)*x(52)-jvs(85)*x(54)-jvs(86)*x(55) - &
            jvs(87)*x(56))/(jvs(83))
    x(20) = (x(20)-jvs(79)*x(37)-jvs(80)*x(40)-jvs(81)*x(53) - &
            jvs(82)*x(54))/(jvs(78))
    x(19) = (x(19)-jvs(76)*x(54)-jvs(77)*x(55))/(jvs(75))
    x(18) = (x(18)-jvs(70)*x(40)-jvs(71)*x(53)-jvs(72)*x(54))/(jvs(69))
    x(17) = (x(17)-jvs(66)*x(52)-jvs(67)*x(54)-jvs(68)*x(56))/(jvs(65))
    x(16) = (x(16)-jvs(63)*x(54)-jvs(64)*x(57))/(jvs(62))
    x(15) = (x(15)-jvs(58)*x(26)-jvs(59)*x(54)-jvs(60)*x(56) - &
            jvs(61)*x(57))/(jvs(57))
    x(14) = (x(14)-jvs(53)*x(37)-jvs(54)*x(40)-jvs(55)*x(53) - &
            jvs(56)*x(54))/(jvs(52))
    x(13) = (x(13)-jvs(48)*x(37)-jvs(49)*x(40)-jvs(50)*x(53) - &
            jvs(51)*x(54))/(jvs(47))
    x(12) = (x(12)-jvs(46)*x(54))/(jvs(45))
    x(11) = (x(11)-jvs(42)*x(16)-jvs(43)*x(54)-jvs(44)*x(57))/(jvs(41))
    x(10) = (x(10)-jvs(38)*x(35)-jvs(39)*x(52)-jvs(40)*x(54))/(jvs(37))
    x(9) = (x(9)-jvs(35)*x(35)-jvs(36)*x(53))/(jvs(34))
    x(8) = (x(8)-jvs(33)*x(54))/(jvs(32))
    x(7) = (x(7)-jvs(30)*x(56)-jvs(31)*x(58))/(jvs(29))
    x(6) = (x(6)-jvs(27)*x(41)-jvs(28)*x(52))/(jvs(26))
    x(5) = (x(5)-jvs(24)*x(16)-jvs(25)*x(54))/(jvs(23))
    x(4) = (x(4)-jvs(16)*x(37)-jvs(17)*x(38)-jvs(18)*x(40) - &
           jvs(19)*x(47)-jvs(20)*x(52)-jvs(21)*x(53)-jvs(22)*x(58))/(jvs(15))
    x(3) = (x(3)-jvs(12)*x(25)-jvs(13)*x(40)-jvs(14)*x(53))/(jvs(11))
    x(2) = (x(2)-jvs(9)*x(11)-jvs(10)*x(54))/(jvs(8))
    x(1) = (x(1)-jvs(2)*x(25)-jvs(3)*x(37)-jvs(4)*x(40)-jvs(5)*x(53) - &
           jvs(6)*x(55)-jvs(7)*x(58))/(jvs(1))
  end subroutine kppsolve

end module mod_cbmz_linearalgebra

! vim: tabstop=8 expandtab shiftwidth=2 softtabstop=2
