! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!
! Main Program File
!
! Generated by KPP-2.2 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
!
! File                 : gasphs_Main.f90
! Time                 : Wed Aug 20 11:07:49 2008
! Working directory    : /scratch/ASHALABY/KPP/COMPARE_DMS/lsode_CBMZ
! Equation file        : gasphs.kpp
! Output root filename : gasphs
!
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!
! MAIN - Main program - driver routine
!   Arguments :
!
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

module mod_cbmz_main1
  use mod_cbmz_model
  use mod_cbmz_global
  use mod_cbmz_parameters

  public :: chemmain

  contains

  subroutine chemmain(jday,dtche)
    use mod_cbmz_model
    use mod_cbmz_global
    use mod_cbmz_parameters
    use mod_cbmz_jval1
    use mod_cbmz_hvread
    implicit none

    real(kind=dp) , intent(in) :: jday , dtche
    real(kind=dp) :: t
    real(kind=dp) :: rstate(20)
    integer :: i

    !------------------Declaration part for jval----------

    real(kind=dp) , dimension(22) :: jparam
    real(kind=dp) , dimension(56) :: jval

    !integer , parameter :: jO2       = 1
    integer , parameter :: jO31D     = 2
    integer , parameter :: jO33P     = 3
    integer , parameter :: jNO2      = 4
    integer , parameter :: jNO3a     = 5
    integer , parameter :: jNO3b     = 6
    !integer , parameter :: jN2O5a    = 7
    integer , parameter :: jN2O5b    = 8
    !integer , parameter :: jN2O      = 9
    !integer , parameter :: jHO2      = 10
    integer , parameter :: jH2O2     = 11
    integer , parameter :: jHNO2     = 12
    integer , parameter :: jHNO3     = 13
    integer , parameter :: jHNO4     = 14
    integer , parameter :: jCH2Oa    = 15
    integer , parameter :: jCH2Ob    = 16
    integer , parameter :: jCH3CHOa  = 17
    !integer , parameter :: jCH3CHOb  = 18
    !integer , parameter :: jCH3CHOc  = 19
    integer , parameter :: jC2H5CHO  = 20
    integer , parameter :: jCHOCHO   = 21
    !integer , parameter :: jCH3COCHO = 22
    integer , parameter :: jCH3COCH3 = 23
    !integer , parameter :: jCH3OOH   = 24
    !integer , parameter :: jCH3ONO2  = 25
    integer , parameter :: jPAN      = 26

    !~~~> Initialization

    var => c(1:nvar)
    fix => c(nvar+1:)

    stepmin = 0.0_dp
    stepmax = 0.0_dp

    do i = 1 , nvar
      rtol(i) = 0.1_dp
      atol(i) = 0.1_dp
    end do
    fix(1) = (0.22_dp)*C_M
    fix(2) = (0.78_dp)*C_M

    call loadperoxyparameters

    ! constant rate coefficients
    rconst(11) = 2.2e-10_dp
    rconst(24) = 2.2e-11_dp
    rconst(34) = 5e-16_dp
    rconst(40) = 3.5e-12_dp
    rconst(41) = 2e-21_dp
    rconst(48) = 8.1e-13_dp
    rconst(52) = 1e-11_dp
    rconst(60) = 1.7e-11_dp
    rconst(69) = 2.5e-12_dp
    rconst(72) = 8.1e-12_dp
    rconst(73) = 4.1e-11_dp
    rconst(74) = 2.2e-11_dp
    rconst(75) = 1.4e-11_dp
    rconst(76) = 3e-11_dp
    rconst(82) = 3.3e-11_dp
    rconst(83) = 7e-18_dp
    rconst(85) = 1e-15_dp
    rconst(98) = 4e-12_dp
    rconst(100) = 4e-12_dp
    rconst(101) = 4e-12_dp
    rconst(102) = 4e-12_dp
    rconst(103) = 4e-12_dp
    rconst(104) = 4e-12_dp
    rconst(105) = 4e-12_dp
    rconst(106) = 1.1e-12_dp
    rconst(107) = 2.5e-12_dp
    rconst(108) = 2.5e-12_dp
    rconst(109) = 4e-12_dp
    rconst(110) = 1.2e-12_dp
    rconst(111) = 4e-12_dp
    rconst(112) = 2.5e-12_dp

    tstart = 0.0_dp*3600.0_dp
    dt = dtche

    do i = 1 , nvar
      var(i)  = xrin(i)
    end do
    t = tstart
    tend = tstart+dtche

    time = t
    jparam(1) = zenith
    jparam(2) = altmid
    jparam(3) = 330._dp
    jparam(4) = 0.1_dp
    jparam(5) = 0.1_dp
    jparam(6) = 0.38_dp
    jparam(7) = 0.85_dp
    jparam(8) = 0.1_dp
    jparam(9) = deptha
    jparam(10)= depthb
    jparam(11)= altabove
    jparam(12)= altbelow
    jparam(13)= temp
    jparam(20)= jday

    call jvalpro(c_nhv,c_hvmat,c_jarray,jparam,jval)

    jval_O31D     =  jval(jO31D)
    jval_O33P     =  jval(jO33P)
    jval_NO2      =  jval(jNO2)
    jval_H2O2     =  jval(jH2O2)
    jval_CH2Oa    =  jval(jCH2Oa)
    jval_CH2Ob    =  jval(jCH2Ob)
    jval_HNO3     =  jval(jHNO3)
    jval_HNO2     =  jval(jHNO2)
    jval_HNO4     =  jval(jHNO4)
    jval_NO3b     =  jval(jNO3b)
    jval_NO3a     =  jval(jNO3a)
    jval_N2O5b    =  jval(jN2O5b)
    jval_CH3CHOa  =  jval(jCH3CHOa)
    jval_PAN      =  jval(jPAN)
    jval_C2H5CHO  =  jval(jC2H5CHO)
    jval_CH3COCH3 =  jval(jCH3COCH3)
    jval_CHOCHO   =  jval(jCHOCHO)
    c_jval(1,:)   = jval(:)

    call reset_integrate()
    kron: &
    do while (t < tend)
      call update_rconst()
      call integrate( tin = t, tout = t+dt, rstatus_u = rstate, &
               icntrl_u = (/ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 /))
      t = rstate(1)
    end do kron

    do i = 1 , nvar
      xrout(i) = var(i)
    end do

  end subroutine chemmain

end module  mod_cbmz_main1

! vim: tabstop=8 expandtab shiftwidth=2 softtabstop=2
