! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!
! Parameter Module File
!
! Generated by KPP-2.2.3 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
!
! File                 : mod_cbmz_Parameters.f90
! Time                 : Mon Nov 25 13:41:15 2013
! Working directory    : /scratch/ashalaby/kpp-2.2.3/compare/CBMZ
! Equation file        : mod_cbmz.kpp
! Output root filename : mod_cbmz
!
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

module mod_cbmz_parameters
  use mod_cbmz_precision
  public
  save

  ! nvar - number of variable species
  integer, parameter :: nvar = 58
  ! nvaract - number of active species
  integer, parameter :: nvaract = 52
  ! nfix - number of fixed species
  integer, parameter :: nfix = 2
  ! nreact - number of reactions
  integer, parameter :: nreact = 124
  ! nvarst - starting of variables in conc. vect.
  integer, parameter :: nvarst = 1
  ! nfixst - starting of fixed in conc. vect.
  integer, parameter :: nfixst = 59
  ! nonzero - number of nonzero entries in jacobian
  integer, parameter :: nonzero = 531
  ! lu_nonzero - number of nonzero entries in lu factoriz. of jacobian
  integer, parameter :: lu_nonzero = 600
  ! cnvar - (nvar+1) number of elements in compressed row format
  integer, parameter :: cnvar = 59
  ! nlookat - number of species to look at
  integer, parameter :: nlookat = 4
  ! nmonitor - number of species to monitor
  integer, parameter :: nmonitor = 2
  ! nmass - number of atoms to check mass balance
  integer, parameter :: nmass = 1

  ! index declaration for variable species in c and var
  !   var(ind_spc) = c(ind_spc)

  integer, parameter :: indv_co2 = 1
  integer, parameter :: indv_h2so4 = 2
  integer, parameter :: indv_hcooh = 3
  integer, parameter :: indv_rcooh = 4
  integer, parameter :: indv_msa = 5
  integer, parameter :: indv_dummy = 6
  integer, parameter :: indv_pan = 7
  integer, parameter :: indv_tol = 8
  integer, parameter :: indv_o1d = 9
  integer, parameter :: indv_h2o2 = 10
  integer, parameter :: indv_so2 = 11
  integer, parameter :: indv_xyl = 12
  integer, parameter :: indv_ch4 = 13
  integer, parameter :: indv_c2h6 = 14
  integer, parameter :: indv_cro = 15
  integer, parameter :: indv_dms = 16
  integer, parameter :: indv_hno4 = 17
  integer, parameter :: indv_h2 = 18
  integer, parameter :: indv_to2 = 19
  integer, parameter :: indv_ch3oh = 20
  integer, parameter :: indv_hno2 = 21
  integer, parameter :: indv_ch3ooh = 22
  integer, parameter :: indv_ethooh = 23
  integer, parameter :: indv_n2o5 = 24
  integer, parameter :: indv_eth = 25
  integer, parameter :: indv_cres = 26
  integer, parameter :: indv_o3p = 27
  integer, parameter :: indv_co = 28
  integer, parameter :: indv_hno3 = 29
  integer, parameter :: indv_par = 30
  integer, parameter :: indv_open = 31
  integer, parameter :: indv_isopn = 32
  integer, parameter :: indv_isopp = 33
  integer, parameter :: indv_isopo2 = 34
  integer, parameter :: indv_h2o = 35
  integer, parameter :: indv_aone = 36
  integer, parameter :: indv_olei = 37
  integer, parameter :: indv_isop = 38
  integer, parameter :: indv_hcho = 39
  integer, parameter :: indv_olet = 40
  integer, parameter :: indv_xo2 = 41
  integer, parameter :: indv_mgly = 42
  integer, parameter :: indv_ethp = 43
  integer, parameter :: indv_nap = 44
  integer, parameter :: indv_ald2 = 45
  integer, parameter :: indv_ch3o2 = 46
  integer, parameter :: indv_isoprd = 47
  integer, parameter :: indv_ano2 = 48
  integer, parameter :: indv_rooh = 49
  integer, parameter :: indv_ro2 = 50
  integer, parameter :: indv_onit = 51
  integer, parameter :: indv_ho2 = 52
  integer, parameter :: indv_o3 = 53
  integer, parameter :: indv_oh = 54
  integer, parameter :: indv_no = 55
  integer, parameter :: indv_no2 = 56
  integer, parameter :: indv_no3 = 57
  integer, parameter :: indv_c2o3 = 58

  ! index declaration for fixed species in c
  !   c(ind_spc)

  integer, parameter :: indv_o2 = 59
  integer, parameter :: indv_n2 = 60

  ! index declaration for fixed species in fix
  ! fix(indf_spc) = c(ind_spc) = c(nvar+indf_spc)

  integer, parameter :: indf_o2 = 1
  integer, parameter :: indf_n2 = 2

end module mod_cbmz_parameters

! vim: tabstop=8 expandtab shiftwidth=2 softtabstop=2
