! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! The ODE Jacobian of Chemical Model File
! 
! Generated by KPP-2.2.3 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : cb6_Jacobian.f90
! Time                 : Mon Jun 20 12:52:55 2016
! Working directory    : /home/regcm/Code/kpp-2.2.3/Workspace/GAS_CB6r2_new
! Equation file        : cb6.kpp
! Output root filename : cb6
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE mod_cb6_Jacobian

  USE mod_cb6_Parameters
  USE mod_cb6_JacobianSP

  IMPLICIT NONE

CONTAINS


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Jac_SP - the Jacobian of Variables in sparse matrix representation
!   Arguments :
!      V         - Concentrations of variable species (local)
!      F         - Concentrations of fixed species (local)
!      RCT       - Rate constants (local)
!      JVS       - sparse Jacobian of variables
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE Jac_SP ( V, F, RCT, JVS )

! V - Concentrations of variable species (local)
  REAL(kind=dp) :: V(NVAR_CB6)
! F - Concentrations of fixed species (local)
  REAL(kind=dp) :: F(NFIX_CB6)
! RCT - Rate constants (local)
  REAL(kind=dp) :: RCT(NREACT)
! JVS - sparse Jacobian of variables
  REAL(kind=dp) :: JVS(LU_NONZERO)


! Local variables
! B - Temporary array
  REAL(kind=dp) :: B(389)

! B(1) = dA(1)/dV(76)
  B(1) = RCT(1)
! B(2) = dA(2)/dV(74)
  B(2) = RCT(2)*F(3)*F(5)
! B(5) = dA(3)/dV(67)
  B(5) = RCT(3)*V(75)
! B(6) = dA(3)/dV(75)
  B(6) = RCT(3)*V(67)
! B(7) = dA(4)/dV(74)
  B(7) = RCT(4)*V(75)*F(5)
! B(8) = dA(4)/dV(75)
  B(8) = RCT(4)*V(74)*F(5)
! B(10) = dA(5)/dV(74)
  B(10) = RCT(5)*V(76)
! B(11) = dA(5)/dV(76)
  B(11) = RCT(5)*V(74)
! B(12) = dA(6)/dV(74)
  B(12) = RCT(6)*V(76)
! B(13) = dA(6)/dV(76)
  B(13) = RCT(6)*V(74)
! B(14) = dA(7)/dV(67)
  B(14) = RCT(7)*V(74)
! B(15) = dA(7)/dV(74)
  B(15) = RCT(7)*V(67)
! B(16) = dA(8)/dV(67)
  B(16) = RCT(8)
! B(17) = dA(9)/dV(67)
  B(17) = RCT(9)
! B(18) = dA(10)/dV(4)
  B(18) = RCT(10)*F(5)
! B(20) = dA(11)/dV(4)
  B(20) = RCT(11)*F(1)
! B(22) = dA(12)/dV(67)
  B(22) = RCT(12)*V(69)
! B(23) = dA(12)/dV(69)
  B(23) = RCT(12)*V(67)
! B(24) = dA(13)/dV(67)
  B(24) = RCT(13)*V(70)
! B(25) = dA(13)/dV(70)
  B(25) = RCT(13)*V(67)
! B(26) = dA(14)/dV(69)
  B(26) = RCT(14)*V(74)
! B(27) = dA(14)/dV(74)
  B(27) = RCT(14)*V(69)
! B(28) = dA(15)/dV(70)
  B(28) = RCT(15)*V(74)
! B(29) = dA(15)/dV(74)
  B(29) = RCT(15)*V(70)
! B(30) = dA(16)/dV(69)
  B(30) = RCT(16)*2*V(69)
! B(31) = dA(17)/dV(69)
  B(31) = RCT(17)*2*V(69)
! B(32) = dA(18)/dV(69)
  B(32) = RCT(18)*V(70)
! B(33) = dA(18)/dV(70)
  B(33) = RCT(18)*V(69)
! B(34) = dA(19)/dV(70)
  B(34) = RCT(19)*2*V(70)
! B(35) = dA(20)/dV(70)
  B(35) = RCT(20)*2*V(70)*F(1)
! B(37) = dA(21)/dV(26)
  B(37) = RCT(21)
! B(38) = dA(22)/dV(26)
  B(38) = RCT(22)*V(69)
! B(39) = dA(22)/dV(69)
  B(39) = RCT(22)*V(26)
! B(40) = dA(23)/dV(26)
  B(40) = RCT(23)*V(74)
! B(41) = dA(23)/dV(74)
  B(41) = RCT(23)*V(26)
! B(42) = dA(24)/dV(75)
  B(42) = RCT(24)*2*V(75)*F(3)
! B(44) = dA(25)/dV(70)
  B(44) = RCT(25)*V(75)
! B(45) = dA(25)/dV(75)
  B(45) = RCT(25)*V(70)
! B(46) = dA(26)/dV(67)
  B(46) = RCT(26)*V(76)
! B(47) = dA(26)/dV(76)
  B(47) = RCT(26)*V(67)
! B(48) = dA(27)/dV(72)
  B(48) = RCT(27)
! B(49) = dA(28)/dV(72)
  B(49) = RCT(28)
! B(50) = dA(29)/dV(72)
  B(50) = RCT(29)*V(75)
! B(51) = dA(29)/dV(75)
  B(51) = RCT(29)*V(72)
! B(52) = dA(30)/dV(72)
  B(52) = RCT(30)*V(76)
! B(53) = dA(30)/dV(76)
  B(53) = RCT(30)*V(72)
! B(54) = dA(31)/dV(72)
  B(54) = RCT(31)*V(74)
! B(55) = dA(31)/dV(74)
  B(55) = RCT(31)*V(72)
! B(56) = dA(32)/dV(69)
  B(56) = RCT(32)*V(72)
! B(57) = dA(32)/dV(72)
  B(57) = RCT(32)*V(69)
! B(58) = dA(33)/dV(70)
  B(58) = RCT(33)*V(72)
! B(59) = dA(33)/dV(72)
  B(59) = RCT(33)*V(70)
! B(60) = dA(34)/dV(67)
  B(60) = RCT(34)*V(72)
! B(61) = dA(34)/dV(72)
  B(61) = RCT(34)*V(67)
! B(62) = dA(35)/dV(72)
  B(62) = RCT(35)*2*V(72)
! B(63) = dA(36)/dV(72)
  B(63) = RCT(36)*V(76)
! B(64) = dA(36)/dV(76)
  B(64) = RCT(36)*V(72)
! B(65) = dA(37)/dV(8)
  B(65) = RCT(37)
! B(66) = dA(38)/dV(8)
  B(66) = RCT(38)
! B(67) = dA(39)/dV(8)
  B(67) = RCT(39)*F(1)
! B(69) = dA(40)/dV(69)
  B(69) = RCT(40)*V(75)
! B(70) = dA(40)/dV(75)
  B(70) = RCT(40)*V(69)
! B(71) = dA(41)/dV(75)
  B(71) = RCT(41)*V(76)*F(1)
! B(72) = dA(41)/dV(76)
  B(72) = RCT(41)*V(75)*F(1)
! B(74) = dA(42)/dV(22)
  B(74) = RCT(42)*2*V(22)
! B(75) = dA(43)/dV(22)
  B(75) = RCT(43)
! B(76) = dA(44)/dV(22)
  B(76) = RCT(44)*V(69)
! B(77) = dA(44)/dV(69)
  B(77) = RCT(44)*V(22)
! B(78) = dA(45)/dV(69)
  B(78) = RCT(45)*V(76)
! B(79) = dA(45)/dV(76)
  B(79) = RCT(45)*V(69)
! B(80) = dA(46)/dV(48)
  B(80) = RCT(46)*V(69)
! B(81) = dA(46)/dV(69)
  B(81) = RCT(46)*V(48)
! B(82) = dA(47)/dV(48)
  B(82) = RCT(47)
! B(83) = dA(48)/dV(70)
  B(83) = RCT(48)*V(76)
! B(84) = dA(48)/dV(76)
  B(84) = RCT(48)*V(70)
! B(85) = dA(49)/dV(20)
  B(85) = RCT(49)
! B(86) = dA(50)/dV(20)
  B(86) = RCT(50)
! B(87) = dA(51)/dV(20)
  B(87) = RCT(51)*V(69)
! B(88) = dA(51)/dV(69)
  B(88) = RCT(51)*V(20)
! B(89) = dA(52)/dV(3)
  B(89) = RCT(52)*V(69)
! B(90) = dA(52)/dV(69)
  B(90) = RCT(52)*V(3)
! B(91) = dA(53)/dV(73)
  B(91) = RCT(53)*V(75)
! B(92) = dA(53)/dV(75)
  B(92) = RCT(53)*V(73)
! B(93) = dA(54)/dV(73)
  B(93) = RCT(54)*V(76)
! B(94) = dA(54)/dV(76)
  B(94) = RCT(54)*V(73)
! B(95) = dA(55)/dV(17)
  B(95) = RCT(55)
! B(96) = dA(56)/dV(17)
  B(96) = RCT(56)
! B(97) = dA(57)/dV(70)
  B(97) = RCT(57)*V(73)
! B(98) = dA(57)/dV(73)
  B(98) = RCT(57)*V(70)
! B(99) = dA(58)/dV(68)
  B(99) = RCT(58)*V(73)
! B(100) = dA(58)/dV(73)
  B(100) = RCT(58)*V(68)
! B(101) = dA(59)/dV(73)
  B(101) = RCT(59)*2*V(73)
! B(102) = dA(60)/dV(71)
  B(102) = RCT(60)*V(73)
! B(103) = dA(60)/dV(73)
  B(103) = RCT(60)*V(71)
! B(104) = dA(61)/dV(71)
  B(104) = RCT(61)*V(75)
! B(105) = dA(61)/dV(75)
  B(105) = RCT(61)*V(71)
! B(106) = dA(62)/dV(71)
  B(106) = RCT(62)*V(76)
! B(107) = dA(62)/dV(76)
  B(107) = RCT(62)*V(71)
! B(108) = dA(63)/dV(29)
  B(108) = RCT(63)
! B(109) = dA(64)/dV(29)
  B(109) = RCT(64)
! B(110) = dA(65)/dV(70)
  B(110) = RCT(65)*V(71)
! B(111) = dA(65)/dV(71)
  B(111) = RCT(65)*V(70)
! B(112) = dA(66)/dV(68)
  B(112) = RCT(66)*V(71)
! B(113) = dA(66)/dV(71)
  B(113) = RCT(66)*V(68)
! B(114) = dA(67)/dV(71)
  B(114) = RCT(67)*2*V(71)
! B(115) = dA(68)/dV(68)
  B(115) = RCT(68)*V(75)
! B(116) = dA(68)/dV(75)
  B(116) = RCT(68)*V(68)
! B(117) = dA(69)/dV(68)
  B(117) = RCT(69)*V(70)
! B(118) = dA(69)/dV(70)
  B(118) = RCT(69)*V(68)
! B(119) = dA(70)/dV(68)
  B(119) = RCT(70)*2*V(68)
! B(120) = dA(71)/dV(64)
  B(120) = RCT(71)*V(75)
! B(121) = dA(71)/dV(75)
  B(121) = RCT(71)*V(64)
! B(122) = dA(72)/dV(64)
  B(122) = RCT(72)*V(70)
! B(123) = dA(72)/dV(70)
  B(123) = RCT(72)*V(64)
! B(124) = dA(73)/dV(64)
  B(124) = RCT(73)*V(73)
! B(125) = dA(73)/dV(73)
  B(125) = RCT(73)*V(64)
! B(126) = dA(74)/dV(64)
  B(126) = RCT(74)*V(68)
! B(127) = dA(74)/dV(68)
  B(127) = RCT(74)*V(64)
! B(128) = dA(75)/dV(62)
  B(128) = RCT(75)*V(75)
! B(129) = dA(75)/dV(75)
  B(129) = RCT(75)*V(62)
! B(130) = dA(76)/dV(62)
  B(130) = RCT(76)*V(70)
! B(131) = dA(76)/dV(70)
  B(131) = RCT(76)*V(62)
! B(132) = dA(77)/dV(62)
  B(132) = RCT(77)*V(73)
! B(133) = dA(77)/dV(73)
  B(133) = RCT(77)*V(62)
! B(134) = dA(78)/dV(62)
  B(134) = RCT(78)*V(68)
! B(135) = dA(78)/dV(68)
  B(135) = RCT(78)*V(62)
! B(136) = dA(79)/dV(58)
  B(136) = RCT(79)*V(75)
! B(137) = dA(79)/dV(75)
  B(137) = RCT(79)*V(58)
! B(138) = dA(80)/dV(58)
  B(138) = RCT(80)*V(70)
! B(139) = dA(80)/dV(70)
  B(139) = RCT(80)*V(58)
! B(140) = dA(81)/dV(58)
  B(140) = RCT(81)*V(73)
! B(141) = dA(81)/dV(73)
  B(141) = RCT(81)*V(58)
! B(142) = dA(82)/dV(58)
  B(142) = RCT(82)*V(68)
! B(143) = dA(82)/dV(68)
  B(143) = RCT(82)*V(58)
! B(144) = dA(83)/dV(60)
  B(144) = RCT(83)*V(75)
! B(145) = dA(83)/dV(75)
  B(145) = RCT(83)*V(60)
! B(146) = dA(84)/dV(60)
  B(146) = RCT(84)*V(70)
! B(147) = dA(84)/dV(70)
  B(147) = RCT(84)*V(60)
! B(148) = dA(85)/dV(60)
  B(148) = RCT(85)*V(73)
! B(149) = dA(85)/dV(73)
  B(149) = RCT(85)*V(60)
! B(150) = dA(86)/dV(60)
  B(150) = RCT(86)*V(68)
! B(151) = dA(86)/dV(68)
  B(151) = RCT(86)*V(60)
! B(152) = dA(87)/dV(23)
  B(152) = RCT(87)*V(69)
! B(153) = dA(87)/dV(69)
  B(153) = RCT(87)*V(23)
! B(154) = dA(88)/dV(23)
  B(154) = RCT(88)
! B(155) = dA(89)/dV(32)
  B(155) = RCT(89)*V(69)
! B(156) = dA(89)/dV(69)
  B(156) = RCT(89)*V(32)
! B(157) = dA(90)/dV(32)
  B(157) = RCT(90)
! B(158) = dA(91)/dV(33)
  B(158) = RCT(91)*V(69)
! B(159) = dA(91)/dV(69)
  B(159) = RCT(91)*V(33)
! B(160) = dA(92)/dV(33)
  B(160) = RCT(92)
! B(161) = dA(93)/dV(28)
  B(161) = RCT(93)*V(69)
! B(162) = dA(93)/dV(69)
  B(162) = RCT(93)*V(28)
! B(163) = dA(94)/dV(38)
  B(163) = RCT(94)*V(69)
! B(164) = dA(94)/dV(69)
  B(164) = RCT(94)*V(38)
! B(165) = dA(95)/dV(18)
  B(165) = RCT(95)*V(69)
! B(166) = dA(95)/dV(69)
  B(166) = RCT(95)*V(18)
! B(167) = dA(96)/dV(55)
  B(167) = RCT(96)*V(69)
! B(168) = dA(96)/dV(69)
  B(168) = RCT(96)*V(55)
! B(169) = dA(97)/dV(55)
  B(169) = RCT(97)
! B(170) = dA(98)/dV(55)
  B(170) = RCT(98)
! B(171) = dA(99)/dV(55)
  B(171) = RCT(99)*V(74)
! B(172) = dA(99)/dV(74)
  B(172) = RCT(99)*V(55)
! B(173) = dA(100)/dV(55)
  B(173) = RCT(100)*V(72)
! B(174) = dA(100)/dV(72)
  B(174) = RCT(100)*V(55)
! B(175) = dA(101)/dV(55)
  B(175) = RCT(101)*V(70)
! B(176) = dA(101)/dV(70)
  B(176) = RCT(101)*V(55)
! B(177) = dA(102)/dV(30)
  B(177) = RCT(102)
! B(178) = dA(103)/dV(30)
  B(178) = RCT(103)*V(75)
! B(179) = dA(103)/dV(75)
  B(179) = RCT(103)*V(30)
! B(180) = dA(104)/dV(30)
  B(180) = RCT(104)*V(70)
! B(181) = dA(104)/dV(70)
  B(181) = RCT(104)*V(30)
! B(182) = dA(105)/dV(57)
  B(182) = RCT(105)*V(74)
! B(183) = dA(105)/dV(74)
  B(183) = RCT(105)*V(57)
! B(184) = dA(106)/dV(57)
  B(184) = RCT(106)*V(69)
! B(185) = dA(106)/dV(69)
  B(185) = RCT(106)*V(57)
! B(186) = dA(107)/dV(57)
  B(186) = RCT(107)*V(72)
! B(187) = dA(107)/dV(72)
  B(187) = RCT(107)*V(57)
! B(188) = dA(108)/dV(57)
  B(188) = RCT(108)
! B(189) = dA(109)/dV(65)
  B(189) = RCT(109)*V(74)
! B(190) = dA(109)/dV(74)
  B(190) = RCT(109)*V(65)
! B(191) = dA(110)/dV(65)
  B(191) = RCT(110)*V(69)
! B(192) = dA(110)/dV(69)
  B(192) = RCT(110)*V(65)
! B(193) = dA(111)/dV(65)
  B(193) = RCT(111)*V(72)
! B(194) = dA(111)/dV(72)
  B(194) = RCT(111)*V(65)
! B(195) = dA(112)/dV(65)
  B(195) = RCT(112)
! B(196) = dA(113)/dV(49)
  B(196) = RCT(113)*V(69)
! B(197) = dA(113)/dV(69)
  B(197) = RCT(113)*V(49)
! B(198) = dA(114)/dV(49)
  B(198) = RCT(114)
! B(199) = dA(115)/dV(49)
  B(199) = RCT(115)*V(72)
! B(200) = dA(115)/dV(72)
  B(200) = RCT(115)*V(49)
! B(201) = dA(116)/dV(50)
  B(201) = RCT(116)*V(69)
! B(202) = dA(116)/dV(69)
  B(202) = RCT(116)*V(50)
! B(203) = dA(117)/dV(50)
  B(203) = RCT(117)
! B(204) = dA(118)/dV(50)
  B(204) = RCT(118)*V(72)
! B(205) = dA(118)/dV(72)
  B(205) = RCT(118)*V(50)
! B(206) = dA(119)/dV(52)
  B(206) = RCT(119)
! B(207) = dA(120)/dV(52)
  B(207) = RCT(120)*V(72)
! B(208) = dA(120)/dV(72)
  B(208) = RCT(120)*V(52)
! B(209) = dA(121)/dV(52)
  B(209) = RCT(121)*V(69)
! B(210) = dA(121)/dV(69)
  B(210) = RCT(121)*V(52)
! B(211) = dA(122)/dV(69)
  B(211) = RCT(122)*F(2)
! B(213) = dA(123)/dV(42)
  B(213) = RCT(123)*V(69)
! B(214) = dA(123)/dV(69)
  B(214) = RCT(123)*V(42)
! B(215) = dA(124)/dV(69)
  B(215) = RCT(124)*F(4)
! B(217) = dA(125)/dV(6)
  B(217) = RCT(125)*V(69)
! B(218) = dA(125)/dV(69)
  B(218) = RCT(125)*V(6)
! B(219) = dA(126)/dV(21)
  B(219) = RCT(126)*V(69)
! B(220) = dA(126)/dV(69)
  B(220) = RCT(126)*V(21)
! B(221) = dA(127)/dV(11)
  B(221) = RCT(127)*V(69)
! B(222) = dA(127)/dV(69)
  B(222) = RCT(127)*V(11)
! B(223) = dA(128)/dV(13)
  B(223) = RCT(128)
! B(224) = dA(129)/dV(34)
  B(224) = RCT(129)
! B(225) = dA(130)/dV(34)
  B(225) = RCT(130)*V(69)
! B(226) = dA(130)/dV(69)
  B(226) = RCT(130)*V(34)
! B(227) = dA(131)/dV(12)
  B(227) = RCT(131)*V(69)
! B(228) = dA(131)/dV(69)
  B(228) = RCT(131)*V(12)
! B(229) = dA(132)/dV(66)
  B(229) = RCT(132)*V(69)
! B(230) = dA(132)/dV(69)
  B(230) = RCT(132)*V(66)
! B(231) = dA(133)/dV(39)
  B(231) = RCT(133)
! B(232) = dA(134)/dV(39)
  B(232) = RCT(134)*F(3)
! B(234) = dA(135)/dV(39)
  B(234) = RCT(135)*V(76)
! B(235) = dA(135)/dV(76)
  B(235) = RCT(135)*V(39)
! B(236) = dA(136)/dV(7)
  B(236) = RCT(136)*V(69)
! B(237) = dA(136)/dV(69)
  B(237) = RCT(136)*V(7)
! B(238) = dA(137)/dV(41)
  B(238) = RCT(137)*V(74)
! B(239) = dA(137)/dV(74)
  B(239) = RCT(137)*V(41)
! B(240) = dA(138)/dV(41)
  B(240) = RCT(138)*V(69)
! B(241) = dA(138)/dV(69)
  B(241) = RCT(138)*V(41)
! B(242) = dA(139)/dV(41)
  B(242) = RCT(139)*V(67)
! B(243) = dA(139)/dV(67)
  B(243) = RCT(139)*V(41)
! B(244) = dA(140)/dV(41)
  B(244) = RCT(140)*V(72)
! B(245) = dA(140)/dV(72)
  B(245) = RCT(140)*V(41)
! B(246) = dA(141)/dV(56)
  B(246) = RCT(141)*V(74)
! B(247) = dA(141)/dV(74)
  B(247) = RCT(141)*V(56)
! B(248) = dA(142)/dV(56)
  B(248) = RCT(142)*V(69)
! B(249) = dA(142)/dV(69)
  B(249) = RCT(142)*V(56)
! B(250) = dA(143)/dV(56)
  B(250) = RCT(143)*V(67)
! B(251) = dA(143)/dV(67)
  B(251) = RCT(143)*V(56)
! B(252) = dA(144)/dV(56)
  B(252) = RCT(144)*V(72)
! B(253) = dA(144)/dV(72)
  B(253) = RCT(144)*V(56)
! B(254) = dA(145)/dV(54)
  B(254) = RCT(145)*V(74)
! B(255) = dA(145)/dV(74)
  B(255) = RCT(145)*V(54)
! B(256) = dA(146)/dV(54)
  B(256) = RCT(146)*V(69)
! B(257) = dA(146)/dV(69)
  B(257) = RCT(146)*V(54)
! B(258) = dA(147)/dV(54)
  B(258) = RCT(147)*V(67)
! B(259) = dA(147)/dV(67)
  B(259) = RCT(147)*V(54)
! B(260) = dA(148)/dV(54)
  B(260) = RCT(148)*V(72)
! B(261) = dA(148)/dV(72)
  B(261) = RCT(148)*V(54)
! B(262) = dA(149)/dV(46)
  B(262) = RCT(149)*V(69)
! B(263) = dA(149)/dV(69)
  B(263) = RCT(149)*V(46)
! B(264) = dA(150)/dV(46)
  B(264) = RCT(150)*V(74)
! B(265) = dA(150)/dV(74)
  B(265) = RCT(150)*V(46)
! B(266) = dA(151)/dV(61)
  B(266) = RCT(151)*V(75)
! B(267) = dA(151)/dV(75)
  B(267) = RCT(151)*V(61)
! B(268) = dA(152)/dV(61)
  B(268) = RCT(152)*V(70)
! B(269) = dA(152)/dV(70)
  B(269) = RCT(152)*V(61)
! B(270) = dA(153)/dV(61)
  B(270) = RCT(153)*V(73)
! B(271) = dA(153)/dV(73)
  B(271) = RCT(153)*V(61)
! B(272) = dA(154)/dV(61)
  B(272) = RCT(154)*V(68)
! B(273) = dA(154)/dV(68)
  B(273) = RCT(154)*V(61)
! B(274) = dA(155)/dV(61)
  B(274) = RCT(155)
! B(275) = dA(156)/dV(46)
  B(275) = RCT(156)*V(67)
! B(276) = dA(156)/dV(67)
  B(276) = RCT(156)*V(46)
! B(277) = dA(157)/dV(46)
  B(277) = RCT(157)*V(72)
! B(278) = dA(157)/dV(72)
  B(278) = RCT(157)*V(46)
! B(279) = dA(158)/dV(63)
  B(279) = RCT(158)*V(69)
! B(280) = dA(158)/dV(69)
  B(280) = RCT(158)*V(63)
! B(281) = dA(159)/dV(63)
  B(281) = RCT(159)*V(67)
! B(282) = dA(159)/dV(67)
  B(282) = RCT(159)*V(63)
! B(283) = dA(160)/dV(63)
  B(283) = RCT(160)*V(72)
! B(284) = dA(160)/dV(72)
  B(284) = RCT(160)*V(63)
! B(285) = dA(161)/dV(63)
  B(285) = RCT(161)
! B(286) = dA(162)/dV(27)
  B(286) = RCT(162)*V(69)
! B(287) = dA(162)/dV(69)
  B(287) = RCT(162)*V(27)
! B(288) = dA(163)/dV(16)
  B(288) = RCT(163)
! B(289) = dA(164)/dV(16)
  B(289) = RCT(164)*V(72)
! B(290) = dA(164)/dV(72)
  B(290) = RCT(164)*V(16)
! B(291) = dA(165)/dV(10)
  B(291) = RCT(165)*V(69)
! B(292) = dA(165)/dV(69)
  B(292) = RCT(165)*V(10)
! B(293) = dA(166)/dV(47)
  B(293) = RCT(166)*V(70)
! B(294) = dA(166)/dV(70)
  B(294) = RCT(166)*V(47)
! B(295) = dA(167)/dV(47)
  B(295) = RCT(167)*V(75)
! B(296) = dA(167)/dV(75)
  B(296) = RCT(167)*V(47)
! B(297) = dA(168)/dV(47)
  B(297) = RCT(168)*V(73)
! B(298) = dA(168)/dV(73)
  B(298) = RCT(168)*V(47)
! B(299) = dA(169)/dV(47)
  B(299) = RCT(169)*V(68)
! B(300) = dA(169)/dV(68)
  B(300) = RCT(169)*V(47)
! B(301) = dA(170)/dV(35)
  B(301) = RCT(170)*V(69)
! B(302) = dA(170)/dV(69)
  B(302) = RCT(170)*V(35)
! B(303) = dA(171)/dV(44)
  B(303) = RCT(171)*V(74)
! B(304) = dA(171)/dV(74)
  B(304) = RCT(171)*V(44)
! B(305) = dA(172)/dV(44)
  B(305) = RCT(172)*V(69)
! B(306) = dA(172)/dV(69)
  B(306) = RCT(172)*V(44)
! B(307) = dA(173)/dV(44)
  B(307) = RCT(173)*V(67)
! B(308) = dA(173)/dV(67)
  B(308) = RCT(173)*V(44)
! B(309) = dA(174)/dV(44)
  B(309) = RCT(174)*V(72)
! B(310) = dA(174)/dV(72)
  B(310) = RCT(174)*V(44)
! B(311) = dA(175)/dV(9)
  B(311) = RCT(175)*V(69)
! B(312) = dA(175)/dV(69)
  B(312) = RCT(175)*V(9)
! B(313) = dA(176)/dV(36)
  B(313) = RCT(176)*V(75)
! B(314) = dA(176)/dV(75)
  B(314) = RCT(176)*V(36)
! B(315) = dA(177)/dV(36)
  B(315) = RCT(177)*V(73)
! B(316) = dA(177)/dV(73)
  B(316) = RCT(177)*V(36)
! B(317) = dA(178)/dV(36)
  B(317) = RCT(178)*V(70)
! B(318) = dA(178)/dV(70)
  B(318) = RCT(178)*V(36)
! B(319) = dA(179)/dV(36)
  B(319) = RCT(179)*V(68)
! B(320) = dA(179)/dV(68)
  B(320) = RCT(179)*V(36)
! B(321) = dA(180)/dV(14)
  B(321) = RCT(180)*V(69)
! B(322) = dA(180)/dV(69)
  B(322) = RCT(180)*V(14)
! B(323) = dA(181)/dV(40)
  B(323) = RCT(181)*V(75)
! B(324) = dA(181)/dV(75)
  B(324) = RCT(181)*V(40)
! B(325) = dA(182)/dV(40)
  B(325) = RCT(182)*V(73)
! B(326) = dA(182)/dV(73)
  B(326) = RCT(182)*V(40)
! B(327) = dA(183)/dV(40)
  B(327) = RCT(183)*V(70)
! B(328) = dA(183)/dV(70)
  B(328) = RCT(183)*V(40)
! B(329) = dA(184)/dV(40)
  B(329) = RCT(184)*V(68)
! B(330) = dA(184)/dV(68)
  B(330) = RCT(184)*V(40)
! B(331) = dA(185)/dV(15)
  B(331) = RCT(185)*V(69)
! B(332) = dA(185)/dV(69)
  B(332) = RCT(185)*V(15)
! B(333) = dA(186)/dV(43)
  B(333) = RCT(186)*V(75)
! B(334) = dA(186)/dV(75)
  B(334) = RCT(186)*V(43)
! B(335) = dA(187)/dV(43)
  B(335) = RCT(187)*V(70)
! B(336) = dA(187)/dV(70)
  B(336) = RCT(187)*V(43)
! B(337) = dA(188)/dV(43)
  B(337) = RCT(188)*V(73)
! B(338) = dA(188)/dV(73)
  B(338) = RCT(188)*V(43)
! B(339) = dA(189)/dV(43)
  B(339) = RCT(189)*V(68)
! B(340) = dA(189)/dV(68)
  B(340) = RCT(189)*V(43)
! B(341) = dA(190)/dV(45)
  B(341) = RCT(190)*V(69)
! B(342) = dA(190)/dV(69)
  B(342) = RCT(190)*V(45)
! B(343) = dA(191)/dV(45)
  B(343) = RCT(191)*V(72)
! B(344) = dA(191)/dV(72)
  B(344) = RCT(191)*V(45)
! B(345) = dA(192)/dV(31)
  B(345) = RCT(192)*V(76)
! B(346) = dA(192)/dV(76)
  B(346) = RCT(192)*V(31)
! B(347) = dA(193)/dV(31)
  B(347) = RCT(193)*V(70)
! B(348) = dA(193)/dV(70)
  B(348) = RCT(193)*V(31)
! B(349) = dA(194)/dV(37)
  B(349) = RCT(194)*V(69)
! B(350) = dA(194)/dV(69)
  B(350) = RCT(194)*V(37)
! B(351) = dA(195)/dV(37)
  B(351) = RCT(195)*V(72)
! B(352) = dA(195)/dV(72)
  B(352) = RCT(195)*V(37)
! B(353) = dA(196)/dV(37)
  B(353) = RCT(196)
! B(354) = dA(197)/dV(51)
  B(354) = RCT(197)
! B(355) = dA(198)/dV(51)
  B(355) = RCT(198)*V(69)
! B(356) = dA(198)/dV(69)
  B(356) = RCT(198)*V(51)
! B(357) = dA(199)/dV(51)
  B(357) = RCT(199)*V(67)
! B(358) = dA(199)/dV(67)
  B(358) = RCT(199)*V(51)
! B(359) = dA(200)/dV(51)
  B(359) = RCT(200)*V(72)
! B(360) = dA(200)/dV(72)
  B(360) = RCT(200)*V(51)
! B(361) = dA(201)/dV(53)
  B(361) = RCT(201)
! B(362) = dA(202)/dV(53)
  B(362) = RCT(202)*V(69)
! B(363) = dA(202)/dV(69)
  B(363) = RCT(202)*V(53)
! B(364) = dA(203)/dV(53)
  B(364) = RCT(203)*V(67)
! B(365) = dA(203)/dV(67)
  B(365) = RCT(203)*V(53)
! B(366) = dA(204)/dV(53)
  B(366) = RCT(204)*V(72)
! B(367) = dA(204)/dV(72)
  B(367) = RCT(204)*V(53)
! B(368) = dA(205)/dV(25)
  B(368) = RCT(205)*V(69)
! B(369) = dA(205)/dV(69)
  B(369) = RCT(205)*V(25)
! B(370) = dA(206)/dV(25)
  B(370) = RCT(206)*V(72)
! B(371) = dA(206)/dV(72)
  B(371) = RCT(206)*V(25)
! B(372) = dA(207)/dV(59)
  B(372) = RCT(207)*V(75)
! B(373) = dA(207)/dV(75)
  B(373) = RCT(207)*V(59)
! B(374) = dA(208)/dV(59)
  B(374) = RCT(208)*V(76)
! B(375) = dA(208)/dV(76)
  B(375) = RCT(208)*V(59)
! B(376) = dA(209)/dV(24)
  B(376) = RCT(209)
! B(377) = dA(210)/dV(59)
  B(377) = RCT(210)*V(70)
! B(378) = dA(210)/dV(70)
  B(378) = RCT(210)*V(59)
! B(379) = dA(211)/dV(59)
  B(379) = RCT(211)*V(73)
! B(380) = dA(211)/dV(73)
  B(380) = RCT(211)*V(59)
! B(381) = dA(212)/dV(59)
  B(381) = RCT(212)*V(68)
! B(382) = dA(212)/dV(68)
  B(382) = RCT(212)*V(59)
! B(383) = dA(213)/dV(24)
  B(383) = RCT(213)*V(69)
! B(384) = dA(213)/dV(69)
  B(384) = RCT(213)*V(24)
! B(385) = dA(214)/dV(29)
  B(385) = RCT(214)*V(69)
! B(386) = dA(214)/dV(69)
  B(386) = RCT(214)*V(29)
! B(387) = dA(215)/dV(19)
  B(387) = RCT(215)
! B(388) = dA(216)/dV(5)
  B(388) = RCT(216)*V(69)
! B(389) = dA(216)/dV(69)
  B(389) = RCT(216)*V(5)

! Construct the Jacobian terms from B's
! JVS(1) = Jac_FULL(1,1)
  JVS(1) = 0
! JVS(2) = Jac_FULL(1,35)
  JVS(2) = 0.266*B(301)
! JVS(3) = Jac_FULL(1,36)
  JVS(3) = 0.082*B(313)
! JVS(4) = Jac_FULL(1,40)
  JVS(4) = 0.14*B(323)
! JVS(5) = Jac_FULL(1,44)
  JVS(5) = 0.53*B(309)
! JVS(6) = Jac_FULL(1,69)
  JVS(6) = 0.266*B(302)
! JVS(7) = Jac_FULL(1,72)
  JVS(7) = 0.53*B(310)
! JVS(8) = Jac_FULL(1,75)
  JVS(8) = 0.082*B(314)+0.14*B(324)
! JVS(9) = Jac_FULL(2,2)
  JVS(9) = 0
! JVS(10) = Jac_FULL(2,3)
  JVS(10) = B(89)
! JVS(11) = Jac_FULL(2,69)
  JVS(11) = B(90)
! JVS(12) = Jac_FULL(3,3)
  JVS(12) = -B(89)
! JVS(13) = Jac_FULL(3,69)
  JVS(13) = -B(90)
! JVS(14) = Jac_FULL(4,4)
  JVS(14) = -B(18)-B(20)
! JVS(15) = Jac_FULL(4,67)
  JVS(15) = B(17)
! JVS(16) = Jac_FULL(5,5)
  JVS(16) = -B(388)
! JVS(17) = Jac_FULL(5,69)
  JVS(17) = -B(389)
! JVS(18) = Jac_FULL(6,6)
  JVS(18) = -B(217)
! JVS(19) = Jac_FULL(6,69)
  JVS(19) = -B(218)
! JVS(20) = Jac_FULL(7,7)
  JVS(20) = -B(236)
! JVS(21) = Jac_FULL(7,69)
  JVS(21) = -B(237)
! JVS(22) = Jac_FULL(8,8)
  JVS(22) = -B(65)-B(66)-B(67)
! JVS(23) = Jac_FULL(8,72)
  JVS(23) = B(63)
! JVS(24) = Jac_FULL(8,76)
  JVS(24) = B(64)
! JVS(25) = Jac_FULL(9,9)
  JVS(25) = -B(311)
! JVS(26) = Jac_FULL(9,69)
  JVS(26) = -B(312)
! JVS(27) = Jac_FULL(10,10)
  JVS(27) = -B(291)
! JVS(28) = Jac_FULL(10,27)
  JVS(28) = 0.904*B(286)
! JVS(29) = Jac_FULL(10,69)
  JVS(29) = 0.904*B(287)-B(292)
! JVS(30) = Jac_FULL(11,11)
  JVS(30) = -B(221)
! JVS(31) = Jac_FULL(11,69)
  JVS(31) = -B(222)
! JVS(32) = Jac_FULL(12,12)
  JVS(32) = -B(227)
! JVS(33) = Jac_FULL(12,69)
  JVS(33) = -B(228)
! JVS(34) = Jac_FULL(13,13)
  JVS(34) = -B(223)
! JVS(35) = Jac_FULL(13,39)
  JVS(35) = 0.2*B(231)+B(232)
! JVS(36) = Jac_FULL(14,14)
  JVS(36) = -B(321)
! JVS(37) = Jac_FULL(14,69)
  JVS(37) = -B(322)
! JVS(38) = Jac_FULL(15,15)
  JVS(38) = -B(331)
! JVS(39) = Jac_FULL(15,69)
  JVS(39) = -B(332)
! JVS(40) = Jac_FULL(16,16)
  JVS(40) = -B(288)-B(289)
! JVS(41) = Jac_FULL(16,61)
  JVS(41) = B(274)
! JVS(42) = Jac_FULL(16,72)
  JVS(42) = -B(290)
! JVS(43) = Jac_FULL(17,17)
  JVS(43) = -B(95)-B(96)
! JVS(44) = Jac_FULL(17,73)
  JVS(44) = B(93)
! JVS(45) = Jac_FULL(17,76)
  JVS(45) = B(94)
! JVS(46) = Jac_FULL(18,18)
  JVS(46) = -B(165)
! JVS(47) = Jac_FULL(18,59)
  JVS(47) = 0.41*B(377)
! JVS(48) = Jac_FULL(18,69)
  JVS(48) = -B(166)
! JVS(49) = Jac_FULL(18,70)
  JVS(49) = 0.41*B(97)+0.41*B(110)+0.41*B(378)
! JVS(50) = Jac_FULL(18,71)
  JVS(50) = 0.41*B(111)
! JVS(51) = Jac_FULL(18,73)
  JVS(51) = 0.41*B(98)
! JVS(52) = Jac_FULL(19,19)
  JVS(52) = -B(387)
! JVS(53) = Jac_FULL(19,24)
  JVS(53) = 0.5*B(383)
! JVS(54) = Jac_FULL(19,33)
  JVS(54) = B(158)
! JVS(55) = Jac_FULL(19,37)
  JVS(55) = B(349)+B(351)
! JVS(56) = Jac_FULL(19,43)
  JVS(56) = 0.14*B(333)
! JVS(57) = Jac_FULL(19,46)
  JVS(57) = 0.65*B(277)
! JVS(58) = Jac_FULL(19,51)
  JVS(58) = 0.5*B(359)
! JVS(59) = Jac_FULL(19,60)
  JVS(59) = 0.5*B(144)
! JVS(60) = Jac_FULL(19,63)
  JVS(60) = 0.142*B(283)
! JVS(61) = Jac_FULL(19,69)
  JVS(61) = B(159)+B(350)+0.5*B(384)
! JVS(62) = Jac_FULL(19,72)
  JVS(62) = 0.65*B(278)+0.142*B(284)+B(352)+0.5*B(360)
! JVS(63) = Jac_FULL(19,75)
  JVS(63) = 0.5*B(145)+0.14*B(334)
! JVS(64) = Jac_FULL(20,20)
  JVS(64) = -B(85)-B(86)-B(87)
! JVS(65) = Jac_FULL(20,69)
  JVS(65) = -B(88)
! JVS(66) = Jac_FULL(20,70)
  JVS(66) = B(83)
! JVS(67) = Jac_FULL(20,76)
  JVS(67) = B(84)
! JVS(68) = Jac_FULL(21,21)
  JVS(68) = -B(219)
! JVS(69) = Jac_FULL(21,49)
  JVS(69) = 0.15*B(198)
! JVS(70) = Jac_FULL(21,64)
  JVS(70) = 0.315*B(126)
! JVS(71) = Jac_FULL(21,68)
  JVS(71) = 0.315*B(127)
! JVS(72) = Jac_FULL(21,69)
  JVS(72) = -B(220)
! JVS(73) = Jac_FULL(22,22)
  JVS(73) = -2*B(74)-B(75)-B(76)
! JVS(74) = Jac_FULL(22,37)
  JVS(74) = B(353)
! JVS(75) = Jac_FULL(22,69)
  JVS(75) = B(69)-B(77)
! JVS(76) = Jac_FULL(22,75)
  JVS(76) = B(70)+2*B(71)
! JVS(77) = Jac_FULL(22,76)
  JVS(77) = 2*B(72)
! JVS(78) = Jac_FULL(23,23)
  JVS(78) = -B(152)-B(154)
! JVS(79) = Jac_FULL(23,30)
  JVS(79) = 0.5*B(180)
! JVS(80) = Jac_FULL(23,64)
  JVS(80) = 0.9*B(122)
! JVS(81) = Jac_FULL(23,69)
  JVS(81) = -B(153)
! JVS(82) = Jac_FULL(23,70)
  JVS(82) = 0.9*B(123)+0.5*B(181)
! JVS(83) = Jac_FULL(24,24)
  JVS(83) = -B(376)-B(383)
! JVS(84) = Jac_FULL(24,59)
  JVS(84) = B(374)
! JVS(85) = Jac_FULL(24,69)
  JVS(85) = -B(384)
! JVS(86) = Jac_FULL(24,76)
  JVS(86) = B(375)
! JVS(87) = Jac_FULL(25,25)
  JVS(87) = -B(368)-B(370)
! JVS(88) = Jac_FULL(25,45)
  JVS(88) = 0.732*B(341)
! JVS(89) = Jac_FULL(25,69)
  JVS(89) = 0.732*B(342)-B(369)
! JVS(90) = Jac_FULL(25,72)
  JVS(90) = -B(371)
! JVS(91) = Jac_FULL(26,26)
  JVS(91) = -B(37)-B(38)-B(40)
! JVS(92) = Jac_FULL(26,54)
  JVS(92) = 0.08*B(258)
! JVS(93) = Jac_FULL(26,56)
  JVS(93) = 0.04*B(250)
! JVS(94) = Jac_FULL(26,67)
  JVS(94) = 0.04*B(251)+0.08*B(259)
! JVS(95) = Jac_FULL(26,69)
  JVS(95) = B(31)-B(39)
! JVS(96) = Jac_FULL(26,70)
  JVS(96) = B(34)+B(35)
! JVS(97) = Jac_FULL(26,74)
  JVS(97) = -B(41)
! JVS(98) = Jac_FULL(27,27)
  JVS(98) = -B(286)
! JVS(99) = Jac_FULL(27,61)
  JVS(99) = 0.88*B(268)
! JVS(100) = Jac_FULL(27,69)
  JVS(100) = -B(287)
! JVS(101) = Jac_FULL(27,70)
  JVS(101) = 0.88*B(269)
! JVS(102) = Jac_FULL(28,7)
  JVS(102) = 0.3*B(236)
! JVS(103) = Jac_FULL(28,28)
  JVS(103) = -B(161)
! JVS(104) = Jac_FULL(28,30)
  JVS(104) = B(178)+0.5*B(180)
! JVS(105) = Jac_FULL(28,35)
  JVS(105) = 0.185*B(301)
! JVS(106) = Jac_FULL(28,41)
  JVS(106) = 0.37*B(242)
! JVS(107) = Jac_FULL(28,47)
  JVS(107) = 0.074*B(293)
! JVS(108) = Jac_FULL(28,56)
  JVS(108) = 0.09*B(250)
! JVS(109) = Jac_FULL(28,63)
  JVS(109) = 0.15*B(281)
! JVS(110) = Jac_FULL(28,67)
  JVS(110) = 0.37*B(243)+0.09*B(251)+0.15*B(282)
! JVS(111) = Jac_FULL(28,69)
  JVS(111) = -B(162)+0.3*B(237)+0.185*B(302)
! JVS(112) = Jac_FULL(28,70)
  JVS(112) = 0.5*B(181)+0.074*B(294)
! JVS(113) = Jac_FULL(28,75)
  JVS(113) = B(179)
! JVS(114) = Jac_FULL(29,29)
  JVS(114) = -B(108)-B(109)-B(385)
! JVS(115) = Jac_FULL(29,69)
  JVS(115) = -B(386)
! JVS(116) = Jac_FULL(29,71)
  JVS(116) = B(106)
! JVS(117) = Jac_FULL(29,76)
  JVS(117) = B(107)
! JVS(118) = Jac_FULL(30,30)
  JVS(118) = -B(177)-B(178)-B(180)
! JVS(119) = Jac_FULL(30,55)
  JVS(119) = B(175)
! JVS(120) = Jac_FULL(30,70)
  JVS(120) = B(176)-B(181)
! JVS(121) = Jac_FULL(30,75)
  JVS(121) = -B(179)
! JVS(122) = Jac_FULL(31,25)
  JVS(122) = 0.5*B(368)+B(370)
! JVS(123) = Jac_FULL(31,31)
  JVS(123) = -B(345)-B(347)
! JVS(124) = Jac_FULL(31,37)
  JVS(124) = 0.5*B(349)+0.5*B(351)
! JVS(125) = Jac_FULL(31,45)
  JVS(125) = 0.06*B(341)+0.3*B(343)
! JVS(126) = Jac_FULL(31,69)
  JVS(126) = 0.06*B(342)+0.5*B(350)+0.5*B(369)
! JVS(127) = Jac_FULL(31,70)
  JVS(127) = -B(348)
! JVS(128) = Jac_FULL(31,72)
  JVS(128) = 0.3*B(344)+0.5*B(352)+B(371)
! JVS(129) = Jac_FULL(31,76)
  JVS(129) = -B(346)
! JVS(130) = Jac_FULL(32,32)
  JVS(130) = -B(155)-B(157)
! JVS(131) = Jac_FULL(32,58)
  JVS(131) = B(138)
! JVS(132) = Jac_FULL(32,60)
  JVS(132) = B(146)
! JVS(133) = Jac_FULL(32,62)
  JVS(133) = B(130)
! JVS(134) = Jac_FULL(32,69)
  JVS(134) = -B(156)
! JVS(135) = Jac_FULL(32,70)
  JVS(135) = B(131)+B(139)+B(147)
! JVS(136) = Jac_FULL(33,33)
  JVS(136) = -B(158)-B(160)
! JVS(137) = Jac_FULL(33,39)
  JVS(137) = B(234)
! JVS(138) = Jac_FULL(33,41)
  JVS(138) = 0.5*B(244)
! JVS(139) = Jac_FULL(33,54)
  JVS(139) = 0.5*B(260)
! JVS(140) = Jac_FULL(33,56)
  JVS(140) = 0.5*B(252)
! JVS(141) = Jac_FULL(33,60)
  JVS(141) = 0.5*B(144)
! JVS(142) = Jac_FULL(33,69)
  JVS(142) = -B(159)
! JVS(143) = Jac_FULL(33,72)
  JVS(143) = 0.5*B(245)+0.5*B(253)+0.5*B(261)
! JVS(144) = Jac_FULL(33,75)
  JVS(144) = 0.5*B(145)
! JVS(145) = Jac_FULL(33,76)
  JVS(145) = B(235)
! JVS(146) = Jac_FULL(34,12)
  JVS(146) = 0.71*B(227)
! JVS(147) = Jac_FULL(34,34)
  JVS(147) = -B(224)-B(225)
! JVS(148) = Jac_FULL(34,39)
  JVS(148) = 0.42*B(231)
! JVS(149) = Jac_FULL(34,63)
  JVS(149) = 0.137*B(279)+0.17*B(281)+0.17*B(285)
! JVS(150) = Jac_FULL(34,67)
  JVS(150) = 0.17*B(282)
! JVS(151) = Jac_FULL(34,69)
  JVS(151) = -B(226)+0.71*B(228)+0.137*B(280)
! JVS(152) = Jac_FULL(35,35)
  JVS(152) = -0.896*B(301)
! JVS(153) = Jac_FULL(35,61)
  JVS(153) = 0.1*B(266)
! JVS(154) = Jac_FULL(35,69)
  JVS(154) = -0.896*B(302)
! JVS(155) = Jac_FULL(35,75)
  JVS(155) = 0.1*B(267)
! JVS(156) = Jac_FULL(36,9)
  JVS(156) = 0.352*B(311)
! JVS(157) = Jac_FULL(36,36)
  JVS(157) = -B(313)-B(315)-B(317)-B(319)
! JVS(158) = Jac_FULL(36,68)
  JVS(158) = -B(320)
! JVS(159) = Jac_FULL(36,69)
  JVS(159) = 0.352*B(312)
! JVS(160) = Jac_FULL(36,70)
  JVS(160) = -B(318)
! JVS(161) = Jac_FULL(36,73)
  JVS(161) = -B(316)
! JVS(162) = Jac_FULL(36,75)
  JVS(162) = -B(314)
! JVS(163) = Jac_FULL(37,31)
  JVS(163) = B(345)
! JVS(164) = Jac_FULL(37,37)
  JVS(164) = -B(349)-B(351)-B(353)
! JVS(165) = Jac_FULL(37,45)
  JVS(165) = 0
! JVS(166) = Jac_FULL(37,69)
  JVS(166) = -B(350)
! JVS(167) = Jac_FULL(37,70)
  JVS(167) = 0
! JVS(168) = Jac_FULL(37,72)
  JVS(168) = -B(352)
! JVS(169) = Jac_FULL(37,76)
  JVS(169) = B(346)
! JVS(170) = Jac_FULL(38,38)
  JVS(170) = -B(163)
! JVS(171) = Jac_FULL(38,47)
  JVS(171) = 0.2*B(297)
! JVS(172) = Jac_FULL(38,54)
  JVS(172) = 0.08*B(258)
! JVS(173) = Jac_FULL(38,56)
  JVS(173) = 0.13*B(250)
! JVS(174) = Jac_FULL(38,58)
  JVS(174) = 0.2*B(140)
! JVS(175) = Jac_FULL(38,59)
  JVS(175) = 0.15*B(377)+0.2*B(381)
! JVS(176) = Jac_FULL(38,60)
  JVS(176) = 0.2*B(148)
! JVS(177) = Jac_FULL(38,61)
  JVS(177) = 0.2*B(270)
! JVS(178) = Jac_FULL(38,62)
  JVS(178) = 0.2*B(132)
! JVS(179) = Jac_FULL(38,64)
  JVS(179) = 0.1*B(124)
! JVS(180) = Jac_FULL(38,67)
  JVS(180) = 0.13*B(251)+0.08*B(259)
! JVS(181) = Jac_FULL(38,68)
  JVS(181) = 0.2*B(382)
! JVS(182) = Jac_FULL(38,69)
  JVS(182) = -B(164)
! JVS(183) = Jac_FULL(38,70)
  JVS(183) = 0.15*B(97)+0.15*B(110)+0.15*B(378)
! JVS(184) = Jac_FULL(38,71)
  JVS(184) = 0.15*B(111)
! JVS(185) = Jac_FULL(38,73)
  JVS(185) = 0.15*B(98)+0.1*B(125)+0.2*B(133)+0.2*B(141)+0.2*B(149)+0.2*B(271)+0.2*B(298)
! JVS(186) = Jac_FULL(39,39)
  JVS(186) = -0.98*B(231)-B(232)-B(234)
! JVS(187) = Jac_FULL(39,66)
  JVS(187) = 0.76*B(229)
! JVS(188) = Jac_FULL(39,69)
  JVS(188) = 0.76*B(230)
! JVS(189) = Jac_FULL(39,76)
  JVS(189) = -B(235)
! JVS(190) = Jac_FULL(40,14)
  JVS(190) = 0.65*B(321)
! JVS(191) = Jac_FULL(40,40)
  JVS(191) = -B(323)-B(325)-B(327)-B(329)
! JVS(192) = Jac_FULL(40,68)
  JVS(192) = -B(330)
! JVS(193) = Jac_FULL(40,69)
  JVS(193) = 0.65*B(322)
! JVS(194) = Jac_FULL(40,70)
  JVS(194) = -B(328)
! JVS(195) = Jac_FULL(40,73)
  JVS(195) = -B(326)
! JVS(196) = Jac_FULL(40,75)
  JVS(196) = -B(324)
! JVS(197) = Jac_FULL(41,41)
  JVS(197) = -B(238)-B(240)-B(242)-B(244)
! JVS(198) = Jac_FULL(41,67)
  JVS(198) = -B(243)
! JVS(199) = Jac_FULL(41,69)
  JVS(199) = -B(241)
! JVS(200) = Jac_FULL(41,72)
  JVS(200) = -B(245)
! JVS(201) = Jac_FULL(41,74)
  JVS(201) = -B(239)
! JVS(202) = Jac_FULL(42,7)
  JVS(202) = 0.3*B(236)
! JVS(203) = Jac_FULL(42,24)
  JVS(203) = B(383)
! JVS(204) = Jac_FULL(42,34)
  JVS(204) = 0.38*B(224)
! JVS(205) = Jac_FULL(42,39)
  JVS(205) = 0
! JVS(206) = Jac_FULL(42,41)
  JVS(206) = B(238)+0.51*B(242)
! JVS(207) = Jac_FULL(42,42)
  JVS(207) = -B(213)
! JVS(208) = Jac_FULL(42,44)
  JVS(208) = 0.001*B(307)
! JVS(209) = Jac_FULL(42,45)
  JVS(209) = 0.06*B(341)
! JVS(210) = Jac_FULL(42,46)
  JVS(210) = 0.066*B(275)
! JVS(211) = Jac_FULL(42,47)
  JVS(211) = 0.251*B(293)+0.251*B(295)+0.2*B(297)+0.251*B(299)
! JVS(212) = Jac_FULL(42,49)
  JVS(212) = 0.89*B(198)
! JVS(213) = Jac_FULL(42,50)
  JVS(213) = 1.8*B(201)+2*B(203)+1.5*B(204)
! JVS(214) = Jac_FULL(42,51)
  JVS(214) = 0.7*B(354)+0.5*B(357)
! JVS(215) = Jac_FULL(42,52)
  JVS(215) = B(206)+B(209)
! JVS(216) = Jac_FULL(42,53)
  JVS(216) = B(361)+1.98*B(364)
! JVS(217) = Jac_FULL(42,54)
  JVS(217) = 0.1*B(254)+0.245*B(258)
! JVS(218) = Jac_FULL(42,55)
  JVS(218) = B(167)+B(169)+B(170)+B(171)+B(173)
! JVS(219) = Jac_FULL(42,56)
  JVS(219) = 0.2*B(246)+0.378*B(250)
! JVS(220) = Jac_FULL(42,57)
  JVS(220) = B(188)
! JVS(221) = Jac_FULL(42,59)
  JVS(221) = 0.5*B(372)
! JVS(222) = Jac_FULL(42,63)
  JVS(222) = 0.137*B(279)+0.543*B(281)
! JVS(223) = Jac_FULL(42,65)
  JVS(223) = B(195)
! JVS(224) = Jac_FULL(42,66)
  JVS(224) = 0
! JVS(225) = Jac_FULL(42,67)
  JVS(225) = 0.51*B(243)+0.378*B(251)+0.245*B(259)+0.066*B(276)+0.543*B(282)+0.001*B(308)+0.5*B(358)+1.98*B(365)
! JVS(226) = Jac_FULL(42,68)
  JVS(226) = 0.251*B(300)
! JVS(227) = Jac_FULL(42,69)
  JVS(227) = B(168)+1.8*B(202)+B(210)-B(214)+0.3*B(237)+0.137*B(280)+0.06*B(342)+B(384)
! JVS(228) = Jac_FULL(42,70)
  JVS(228) = 0.251*B(294)
! JVS(229) = Jac_FULL(42,72)
  JVS(229) = B(174)+1.5*B(205)
! JVS(230) = Jac_FULL(42,73)
  JVS(230) = 0.2*B(298)
! JVS(231) = Jac_FULL(42,74)
  JVS(231) = B(172)+B(239)+0.2*B(247)+0.1*B(255)
! JVS(232) = Jac_FULL(42,75)
  JVS(232) = 0.251*B(296)+0.5*B(373)
! JVS(233) = Jac_FULL(42,76)
  JVS(233) = 0
! JVS(234) = Jac_FULL(43,15)
  JVS(234) = 0.544*B(331)
! JVS(235) = Jac_FULL(43,43)
  JVS(235) = -B(333)-B(335)-B(337)-B(339)
! JVS(236) = Jac_FULL(43,68)
  JVS(236) = -B(340)
! JVS(237) = Jac_FULL(43,69)
  JVS(237) = 0.544*B(332)
! JVS(238) = Jac_FULL(43,70)
  JVS(238) = -B(336)
! JVS(239) = Jac_FULL(43,73)
  JVS(239) = -B(338)
! JVS(240) = Jac_FULL(43,75)
  JVS(240) = -B(334)
! JVS(241) = Jac_FULL(44,44)
  JVS(241) = -B(303)-B(305)-B(307)-B(309)
! JVS(242) = Jac_FULL(44,67)
  JVS(242) = -B(308)
! JVS(243) = Jac_FULL(44,69)
  JVS(243) = -B(306)
! JVS(244) = Jac_FULL(44,72)
  JVS(244) = -B(310)
! JVS(245) = Jac_FULL(44,74)
  JVS(245) = -B(304)
! JVS(246) = Jac_FULL(45,9)
  JVS(246) = 0.53*B(311)
! JVS(247) = Jac_FULL(45,14)
  JVS(247) = 0.18*B(321)
! JVS(248) = Jac_FULL(45,15)
  JVS(248) = 0.155*B(331)
! JVS(249) = Jac_FULL(45,31)
  JVS(249) = B(347)
! JVS(250) = Jac_FULL(45,37)
  JVS(250) = 0
! JVS(251) = Jac_FULL(45,45)
  JVS(251) = -B(341)-B(343)
! JVS(252) = Jac_FULL(45,69)
  JVS(252) = 0.53*B(312)+0.18*B(322)+0.155*B(332)-B(342)
! JVS(253) = Jac_FULL(45,70)
  JVS(253) = B(348)
! JVS(254) = Jac_FULL(45,72)
  JVS(254) = -B(344)
! JVS(255) = Jac_FULL(45,76)
  JVS(255) = 0
! JVS(256) = Jac_FULL(46,46)
  JVS(256) = -B(262)-B(264)-B(275)-B(277)
! JVS(257) = Jac_FULL(46,67)
  JVS(257) = -B(276)
! JVS(258) = Jac_FULL(46,69)
  JVS(258) = -B(263)
! JVS(259) = Jac_FULL(46,72)
  JVS(259) = -B(278)
! JVS(260) = Jac_FULL(46,74)
  JVS(260) = -B(265)
! JVS(261) = Jac_FULL(47,10)
  JVS(261) = B(291)
! JVS(262) = Jac_FULL(47,27)
  JVS(262) = 0
! JVS(263) = Jac_FULL(47,47)
  JVS(263) = -B(293)-B(295)-B(297)-B(299)
! JVS(264) = Jac_FULL(47,61)
  JVS(264) = 0
! JVS(265) = Jac_FULL(47,68)
  JVS(265) = -B(300)
! JVS(266) = Jac_FULL(47,69)
  JVS(266) = B(292)
! JVS(267) = Jac_FULL(47,70)
  JVS(267) = -B(294)
! JVS(268) = Jac_FULL(47,73)
  JVS(268) = -B(298)
! JVS(269) = Jac_FULL(47,75)
  JVS(269) = -B(296)
! JVS(270) = Jac_FULL(48,8)
  JVS(270) = 2*B(67)
! JVS(271) = Jac_FULL(48,16)
  JVS(271) = B(289)
! JVS(272) = Jac_FULL(48,19)
  JVS(272) = B(387)
! JVS(273) = Jac_FULL(48,24)
  JVS(273) = 0
! JVS(274) = Jac_FULL(48,25)
  JVS(274) = B(370)
! JVS(275) = Jac_FULL(48,33)
  JVS(275) = 0
! JVS(276) = Jac_FULL(48,37)
  JVS(276) = B(351)
! JVS(277) = Jac_FULL(48,39)
  JVS(277) = 0
! JVS(278) = Jac_FULL(48,41)
  JVS(278) = 0
! JVS(279) = Jac_FULL(48,43)
  JVS(279) = 0
! JVS(280) = Jac_FULL(48,45)
  JVS(280) = B(343)
! JVS(281) = Jac_FULL(48,46)
  JVS(281) = 0
! JVS(282) = Jac_FULL(48,48)
  JVS(282) = -B(80)-B(82)
! JVS(283) = Jac_FULL(48,49)
  JVS(283) = B(199)
! JVS(284) = Jac_FULL(48,50)
  JVS(284) = B(204)
! JVS(285) = Jac_FULL(48,51)
  JVS(285) = 0
! JVS(286) = Jac_FULL(48,52)
  JVS(286) = B(207)
! JVS(287) = Jac_FULL(48,53)
  JVS(287) = B(366)
! JVS(288) = Jac_FULL(48,54)
  JVS(288) = 0
! JVS(289) = Jac_FULL(48,55)
  JVS(289) = B(173)
! JVS(290) = Jac_FULL(48,56)
  JVS(290) = 0
! JVS(291) = Jac_FULL(48,57)
  JVS(291) = B(186)
! JVS(292) = Jac_FULL(48,59)
  JVS(292) = 0
! JVS(293) = Jac_FULL(48,60)
  JVS(293) = 0
! JVS(294) = Jac_FULL(48,61)
  JVS(294) = 0
! JVS(295) = Jac_FULL(48,63)
  JVS(295) = 0.717*B(283)
! JVS(296) = Jac_FULL(48,65)
  JVS(296) = B(193)
! JVS(297) = Jac_FULL(48,66)
  JVS(297) = 0
! JVS(298) = Jac_FULL(48,67)
  JVS(298) = 0
! JVS(299) = Jac_FULL(48,68)
  JVS(299) = 0
! JVS(300) = Jac_FULL(48,69)
  JVS(300) = B(78)-B(81)
! JVS(301) = Jac_FULL(48,70)
  JVS(301) = 0
! JVS(302) = Jac_FULL(48,72)
  JVS(302) = B(174)+B(187)+B(194)+B(200)+B(205)+B(208)+0.717*B(284)+B(290)+B(344)+B(352)+B(367)+B(371)
! JVS(303) = Jac_FULL(48,73)
  JVS(303) = 0
! JVS(304) = Jac_FULL(48,74)
  JVS(304) = 0
! JVS(305) = Jac_FULL(48,75)
  JVS(305) = 0
! JVS(306) = Jac_FULL(48,76)
  JVS(306) = B(79)
! JVS(307) = Jac_FULL(49,11)
  JVS(307) = 0.011*B(221)
! JVS(308) = Jac_FULL(49,35)
  JVS(308) = 0.331*B(301)
! JVS(309) = Jac_FULL(49,41)
  JVS(309) = 0.22*B(240)
! JVS(310) = Jac_FULL(49,47)
  JVS(310) = 0.275*B(293)+0.275*B(295)+0.22*B(297)+0.275*B(299)
! JVS(311) = Jac_FULL(49,49)
  JVS(311) = -B(196)-B(198)-B(199)
! JVS(312) = Jac_FULL(49,61)
  JVS(312) = 0
! JVS(313) = Jac_FULL(49,63)
  JVS(313) = 0.269*B(279)+0.113*B(283)+0.128*B(285)
! JVS(314) = Jac_FULL(49,67)
  JVS(314) = 0
! JVS(315) = Jac_FULL(49,68)
  JVS(315) = 0.275*B(300)
! JVS(316) = Jac_FULL(49,69)
  JVS(316) = -B(197)+0.011*B(222)+0.22*B(241)+0.269*B(280)+0.331*B(302)
! JVS(317) = Jac_FULL(49,70)
  JVS(317) = 0.275*B(294)
! JVS(318) = Jac_FULL(49,72)
  JVS(318) = -B(200)+0.113*B(284)
! JVS(319) = Jac_FULL(49,73)
  JVS(319) = 0.22*B(298)
! JVS(320) = Jac_FULL(49,74)
  JVS(320) = 0
! JVS(321) = Jac_FULL(49,75)
  JVS(321) = 0.275*B(296)
! JVS(322) = Jac_FULL(50,7)
  JVS(322) = 0.7*B(236)
! JVS(323) = Jac_FULL(50,24)
  JVS(323) = 0.5*B(383)
! JVS(324) = Jac_FULL(50,36)
  JVS(324) = 0.918*B(313)+B(315)+B(319)
! JVS(325) = Jac_FULL(50,40)
  JVS(325) = 0.417*B(323)+0.48*B(325)+0.48*B(329)
! JVS(326) = Jac_FULL(50,43)
  JVS(326) = 0.221*B(333)+0.26*B(337)+0.26*B(339)
! JVS(327) = Jac_FULL(50,45)
  JVS(327) = 0.24*B(343)
! JVS(328) = Jac_FULL(50,47)
  JVS(328) = 0.275*B(293)+0.275*B(295)+0.22*B(297)+0.275*B(299)
! JVS(329) = Jac_FULL(50,49)
  JVS(329) = 0.2*B(196)+0.11*B(198)
! JVS(330) = Jac_FULL(50,50)
  JVS(330) = -B(201)-B(203)-B(204)
! JVS(331) = Jac_FULL(50,51)
  JVS(331) = 0.4*B(354)+0.4*B(355)
! JVS(332) = Jac_FULL(50,53)
  JVS(332) = 0.4*B(362)+1.4*B(364)
! JVS(333) = Jac_FULL(50,54)
  JVS(333) = 0.24*B(258)
! JVS(334) = Jac_FULL(50,56)
  JVS(334) = 0.075*B(250)
! JVS(335) = Jac_FULL(50,59)
  JVS(335) = 0.5*B(372)
! JVS(336) = Jac_FULL(50,61)
  JVS(336) = 0
! JVS(337) = Jac_FULL(50,63)
  JVS(337) = 0.17*B(281)
! JVS(338) = Jac_FULL(50,67)
  JVS(338) = 0.075*B(251)+0.24*B(259)+0.17*B(282)+1.4*B(365)
! JVS(339) = Jac_FULL(50,68)
  JVS(339) = 0.275*B(300)+B(320)+0.48*B(330)+0.26*B(340)
! JVS(340) = Jac_FULL(50,69)
  JVS(340) = 0.2*B(197)-B(202)+0.7*B(237)+0.4*B(356)+0.4*B(363)+0.5*B(384)
! JVS(341) = Jac_FULL(50,70)
  JVS(341) = 0.275*B(294)
! JVS(342) = Jac_FULL(50,72)
  JVS(342) = -B(205)+0.24*B(344)
! JVS(343) = Jac_FULL(50,73)
  JVS(343) = 0.22*B(298)+B(316)+0.48*B(326)+0.26*B(338)
! JVS(344) = Jac_FULL(50,74)
  JVS(344) = 0
! JVS(345) = Jac_FULL(50,75)
  JVS(345) = 0.275*B(296)+0.918*B(314)+0.417*B(324)+0.221*B(334)+0.5*B(373)
! JVS(346) = Jac_FULL(50,76)
  JVS(346) = 0
! JVS(347) = Jac_FULL(51,15)
  JVS(347) = 0.244*B(331)
! JVS(348) = Jac_FULL(51,40)
  JVS(348) = 0.2*B(323)+0.23*B(325)+0.23*B(329)
! JVS(349) = Jac_FULL(51,43)
  JVS(349) = 0.56*B(333)+0.65*B(337)+0.65*B(339)
! JVS(350) = Jac_FULL(51,51)
  JVS(350) = -B(354)-B(355)-B(357)-B(359)
! JVS(351) = Jac_FULL(51,67)
  JVS(351) = -B(358)
! JVS(352) = Jac_FULL(51,68)
  JVS(352) = 0.23*B(330)+0.65*B(340)
! JVS(353) = Jac_FULL(51,69)
  JVS(353) = 0.244*B(332)-B(356)
! JVS(354) = Jac_FULL(51,70)
  JVS(354) = 0
! JVS(355) = Jac_FULL(51,72)
  JVS(355) = -B(360)
! JVS(356) = Jac_FULL(51,73)
  JVS(356) = 0.23*B(326)+0.65*B(338)
! JVS(357) = Jac_FULL(51,75)
  JVS(357) = 0.2*B(324)+0.56*B(334)
! JVS(358) = Jac_FULL(52,40)
  JVS(358) = 0.443*B(323)+0.52*B(325)+0.52*B(329)
! JVS(359) = Jac_FULL(52,43)
  JVS(359) = 0.675*B(333)+0.77*B(337)+0.77*B(339)
! JVS(360) = Jac_FULL(52,45)
  JVS(360) = 0.24*B(343)
! JVS(361) = Jac_FULL(52,47)
  JVS(361) = 0.275*B(293)+0.275*B(295)+0.22*B(297)+0.275*B(299)
! JVS(362) = Jac_FULL(52,51)
  JVS(362) = B(355)+1.2*B(357)+0.25*B(359)
! JVS(363) = Jac_FULL(52,52)
  JVS(363) = -B(206)-B(207)-B(209)
! JVS(364) = Jac_FULL(52,53)
  JVS(364) = 0.24*B(364)
! JVS(365) = Jac_FULL(52,54)
  JVS(365) = 0.06*B(258)
! JVS(366) = Jac_FULL(52,56)
  JVS(366) = 0.075*B(250)
! JVS(367) = Jac_FULL(52,61)
  JVS(367) = 0
! JVS(368) = Jac_FULL(52,63)
  JVS(368) = 0.115*B(279)+0.531*B(281)+0.113*B(283)
! JVS(369) = Jac_FULL(52,67)
  JVS(369) = 0.075*B(251)+0.06*B(259)+0.531*B(282)+1.2*B(358)+0.24*B(365)
! JVS(370) = Jac_FULL(52,68)
  JVS(370) = 0.275*B(300)+0.52*B(330)+0.77*B(340)
! JVS(371) = Jac_FULL(52,69)
  JVS(371) = -B(210)+0.115*B(280)+B(356)
! JVS(372) = Jac_FULL(52,70)
  JVS(372) = 0.275*B(294)
! JVS(373) = Jac_FULL(52,72)
  JVS(373) = -B(208)+0.113*B(284)+0.24*B(344)+0.25*B(360)
! JVS(374) = Jac_FULL(52,73)
  JVS(374) = 0.22*B(298)+0.52*B(326)+0.77*B(338)
! JVS(375) = Jac_FULL(52,75)
  JVS(375) = 0.275*B(296)+0.443*B(324)+0.675*B(334)
! JVS(376) = Jac_FULL(52,76)
  JVS(376) = 0
! JVS(377) = Jac_FULL(53,9)
  JVS(377) = 0.118*B(311)
! JVS(378) = Jac_FULL(53,14)
  JVS(378) = 0.1*B(321)
! JVS(379) = Jac_FULL(53,36)
  JVS(379) = 0.918*B(313)+B(315)+B(319)
! JVS(380) = Jac_FULL(53,37)
  JVS(380) = B(353)
! JVS(381) = Jac_FULL(53,40)
  JVS(381) = 0.66*B(323)+0.77*B(325)+0.77*B(329)
! JVS(382) = Jac_FULL(53,43)
  JVS(382) = 0.3*B(333)+0.35*B(337)+0.35*B(339)
! JVS(383) = Jac_FULL(53,45)
  JVS(383) = 0.13*B(341)
! JVS(384) = Jac_FULL(53,51)
  JVS(384) = 0.25*B(359)
! JVS(385) = Jac_FULL(53,53)
  JVS(385) = -B(361)-B(362)-B(364)-B(366)
! JVS(386) = Jac_FULL(53,67)
  JVS(386) = -B(365)
! JVS(387) = Jac_FULL(53,68)
  JVS(387) = B(320)+0.77*B(330)+0.35*B(340)
! JVS(388) = Jac_FULL(53,69)
  JVS(388) = 0.118*B(312)+0.1*B(322)+0.13*B(342)-B(363)
! JVS(389) = Jac_FULL(53,70)
  JVS(389) = 0
! JVS(390) = Jac_FULL(53,72)
  JVS(390) = 0.25*B(360)-B(367)
! JVS(391) = Jac_FULL(53,73)
  JVS(391) = B(316)+0.77*B(326)+0.35*B(338)
! JVS(392) = Jac_FULL(53,75)
  JVS(392) = 0.918*B(314)+0.66*B(324)+0.3*B(334)
! JVS(393) = Jac_FULL(53,76)
  JVS(393) = 0
! JVS(394) = Jac_FULL(54,27)
  JVS(394) = 0.029*B(286)
! JVS(395) = Jac_FULL(54,54)
  JVS(395) = -B(254)-B(256)-B(258)-B(260)
! JVS(396) = Jac_FULL(54,61)
  JVS(396) = 0
! JVS(397) = Jac_FULL(54,67)
  JVS(397) = -B(259)
! JVS(398) = Jac_FULL(54,69)
  JVS(398) = -B(257)+0.029*B(287)
! JVS(399) = Jac_FULL(54,70)
  JVS(399) = 0
! JVS(400) = Jac_FULL(54,72)
  JVS(400) = -B(261)
! JVS(401) = Jac_FULL(54,74)
  JVS(401) = -B(255)
! JVS(402) = Jac_FULL(55,11)
  JVS(402) = 0.078*B(221)
! JVS(403) = Jac_FULL(55,21)
  JVS(403) = B(219)
! JVS(404) = Jac_FULL(55,23)
  JVS(404) = 0.4*B(152)
! JVS(405) = Jac_FULL(55,25)
  JVS(405) = 0.14*B(368)
! JVS(406) = Jac_FULL(55,30)
  JVS(406) = B(177)
! JVS(407) = Jac_FULL(55,34)
  JVS(407) = B(225)
! JVS(408) = Jac_FULL(55,35)
  JVS(408) = 0.592*B(301)
! JVS(409) = Jac_FULL(55,37)
  JVS(409) = B(353)
! JVS(410) = Jac_FULL(55,39)
  JVS(410) = 0
! JVS(411) = Jac_FULL(55,41)
  JVS(411) = B(238)+1.56*B(240)+B(242)+1.125*B(244)
! JVS(412) = Jac_FULL(55,44)
  JVS(412) = 0.28*B(305)+0.24*B(307)
! JVS(413) = Jac_FULL(55,45)
  JVS(413) = 0.06*B(341)
! JVS(414) = Jac_FULL(55,46)
  JVS(414) = 0.5*B(264)+0.6*B(275)+0.35*B(277)
! JVS(415) = Jac_FULL(55,47)
  JVS(415) = 0.375*B(293)+0.375*B(295)+0.3*B(297)+0.375*B(299)
! JVS(416) = Jac_FULL(55,49)
  JVS(416) = 0.74*B(198)
! JVS(417) = Jac_FULL(55,53)
  JVS(417) = 0.08*B(364)
! JVS(418) = Jac_FULL(55,54)
  JVS(418) = 0.128*B(258)
! JVS(419) = Jac_FULL(55,55)
  JVS(419) = -B(167)-B(169)-B(170)-B(171)-B(173)-B(175)
! JVS(420) = Jac_FULL(55,56)
  JVS(420) = 0.2*B(246)+0.781*B(248)+0.555*B(250)+0.5*B(252)
! JVS(421) = Jac_FULL(55,61)
  JVS(421) = 0.673*B(266)+0.12*B(268)+0.598*B(270)+0.598*B(272)
! JVS(422) = Jac_FULL(55,63)
  JVS(422) = 0.231*B(281)+0.26*B(285)
! JVS(423) = Jac_FULL(55,64)
  JVS(423) = B(120)+0.1*B(122)+B(124)+0.685*B(126)
! JVS(424) = Jac_FULL(55,66)
  JVS(424) = 0
! JVS(425) = Jac_FULL(55,67)
  JVS(425) = B(243)+0.555*B(251)+0.128*B(259)+0.6*B(276)+0.231*B(282)+0.24*B(308)+0.08*B(365)
! JVS(426) = Jac_FULL(55,68)
  JVS(426) = 0.685*B(127)+0.598*B(273)+0.375*B(300)
! JVS(427) = Jac_FULL(55,69)
  JVS(427) = 0.4*B(153)-B(168)+B(220)+0.078*B(222)+B(226)+1.56*B(241)+0.781*B(249)+0.592*B(302)+0.28*B(306)+0.06*B(342)&
               &+0.14*B(369)
! JVS(428) = Jac_FULL(55,70)
  JVS(428) = 0.1*B(123)-B(176)+0.12*B(269)+0.375*B(294)
! JVS(429) = Jac_FULL(55,72)
  JVS(429) = -B(174)+1.125*B(245)+0.5*B(253)+0.35*B(278)
! JVS(430) = Jac_FULL(55,73)
  JVS(430) = B(125)+0.598*B(271)+0.3*B(298)
! JVS(431) = Jac_FULL(55,74)
  JVS(431) = -B(172)+B(239)+0.2*B(247)+0.5*B(265)
! JVS(432) = Jac_FULL(55,75)
  JVS(432) = B(121)+0.673*B(267)+0.375*B(296)
! JVS(433) = Jac_FULL(55,76)
  JVS(433) = 0
! JVS(434) = Jac_FULL(56,35)
  JVS(434) = 0.098*B(301)
! JVS(435) = Jac_FULL(56,56)
  JVS(435) = -B(246)-B(248)-B(250)-B(252)
! JVS(436) = Jac_FULL(56,61)
  JVS(436) = 0
! JVS(437) = Jac_FULL(56,63)
  JVS(437) = 0.24*B(285)
! JVS(438) = Jac_FULL(56,67)
  JVS(438) = -B(251)
! JVS(439) = Jac_FULL(56,69)
  JVS(439) = -B(249)+0.098*B(302)
! JVS(440) = Jac_FULL(56,72)
  JVS(440) = -B(253)
! JVS(441) = Jac_FULL(56,74)
  JVS(441) = -B(247)
! JVS(442) = Jac_FULL(56,75)
  JVS(442) = 0
! JVS(443) = Jac_FULL(57,6)
  JVS(443) = 0.991*B(217)
! JVS(444) = Jac_FULL(57,11)
  JVS(444) = 0.95*B(221)
! JVS(445) = Jac_FULL(57,13)
  JVS(445) = 0.5*B(223)
! JVS(446) = Jac_FULL(57,29)
  JVS(446) = 0.4*B(109)+B(385)
! JVS(447) = Jac_FULL(57,39)
  JVS(447) = 0.74*B(231)
! JVS(448) = Jac_FULL(57,51)
  JVS(448) = 0.1*B(357)
! JVS(449) = Jac_FULL(57,53)
  JVS(449) = 0.02*B(364)
! JVS(450) = Jac_FULL(57,54)
  JVS(450) = 1.24*B(254)+1.3*B(256)+0.732*B(258)+0.5*B(260)
! JVS(451) = Jac_FULL(57,56)
  JVS(451) = 0.2*B(246)+0.488*B(248)+0.295*B(250)+0.25*B(252)
! JVS(452) = Jac_FULL(57,57)
  JVS(452) = -B(182)-B(184)-B(186)-B(188)
! JVS(453) = Jac_FULL(57,61)
  JVS(453) = 0
! JVS(454) = Jac_FULL(57,63)
  JVS(454) = 0.04*B(281)
! JVS(455) = Jac_FULL(57,65)
  JVS(455) = B(195)
! JVS(456) = Jac_FULL(57,66)
  JVS(456) = 0
! JVS(457) = Jac_FULL(57,67)
  JVS(457) = 0.295*B(251)+0.732*B(259)+0.04*B(282)+0.1*B(358)+0.02*B(365)
! JVS(458) = Jac_FULL(57,68)
  JVS(458) = 0.8*B(112)
! JVS(459) = Jac_FULL(57,69)
  JVS(459) = -B(185)+0.991*B(218)+0.95*B(222)+0.488*B(249)+1.3*B(257)+B(386)
! JVS(460) = Jac_FULL(57,70)
  JVS(460) = 0.44*B(110)
! JVS(461) = Jac_FULL(57,71)
  JVS(461) = B(102)+B(104)+0.44*B(111)+0.8*B(113)+2*B(114)
! JVS(462) = Jac_FULL(57,72)
  JVS(462) = -B(187)+0.25*B(253)+0.5*B(261)
! JVS(463) = Jac_FULL(57,73)
  JVS(463) = B(103)
! JVS(464) = Jac_FULL(57,74)
  JVS(464) = -B(183)+0.2*B(247)+1.24*B(255)
! JVS(465) = Jac_FULL(57,75)
  JVS(465) = B(105)
! JVS(466) = Jac_FULL(57,76)
  JVS(466) = 0
! JVS(467) = Jac_FULL(58,34)
  JVS(467) = B(225)
! JVS(468) = Jac_FULL(58,35)
  JVS(468) = 0.63*B(301)
! JVS(469) = Jac_FULL(58,39)
  JVS(469) = 0
! JVS(470) = Jac_FULL(58,41)
  JVS(470) = 0.5*B(244)
! JVS(471) = Jac_FULL(58,44)
  JVS(471) = 0.5*B(305)+0.69*B(307)+0.75*B(309)
! JVS(472) = Jac_FULL(58,45)
  JVS(472) = 0.48*B(343)
! JVS(473) = Jac_FULL(58,46)
  JVS(473) = 0.25*B(264)+0.2*B(275)+0.33*B(277)
! JVS(474) = Jac_FULL(58,50)
  JVS(474) = 0.2*B(201)+0.5*B(204)
! JVS(475) = Jac_FULL(58,51)
  JVS(475) = 0.9*B(359)
! JVS(476) = Jac_FULL(58,52)
  JVS(476) = B(207)
! JVS(477) = Jac_FULL(58,53)
  JVS(477) = 0
! JVS(478) = Jac_FULL(58,54)
  JVS(478) = 0.48*B(260)
! JVS(479) = Jac_FULL(58,56)
  JVS(479) = 0.195*B(248)+0.48*B(252)
! JVS(480) = Jac_FULL(58,58)
  JVS(480) = -B(136)-B(138)-B(140)-B(142)
! JVS(481) = Jac_FULL(58,59)
  JVS(481) = B(379)
! JVS(482) = Jac_FULL(58,61)
  JVS(482) = 0
! JVS(483) = Jac_FULL(58,63)
  JVS(483) = 1.042*B(279)+0.142*B(283)+0.16*B(285)
! JVS(484) = Jac_FULL(58,66)
  JVS(484) = 0.76*B(229)
! JVS(485) = Jac_FULL(58,67)
  JVS(485) = 0.2*B(276)+0.69*B(308)
! JVS(486) = Jac_FULL(58,68)
  JVS(486) = -B(143)
! JVS(487) = Jac_FULL(58,69)
  JVS(487) = 0.2*B(202)+B(226)+0.76*B(230)+0.195*B(249)+1.042*B(280)+0.63*B(302)+0.5*B(306)
! JVS(488) = Jac_FULL(58,70)
  JVS(488) = -B(139)
! JVS(489) = Jac_FULL(58,72)
  JVS(489) = 0.5*B(205)+B(208)+0.5*B(245)+0.48*B(253)+0.48*B(261)+0.33*B(278)+0.142*B(284)+0.75*B(310)+0.48*B(344)+0.9&
               &*B(360)
! JVS(490) = Jac_FULL(58,73)
  JVS(490) = -B(141)+B(380)
! JVS(491) = Jac_FULL(58,74)
  JVS(491) = 0.25*B(265)
! JVS(492) = Jac_FULL(58,75)
  JVS(492) = -B(137)
! JVS(493) = Jac_FULL(58,76)
  JVS(493) = 0
! JVS(494) = Jac_FULL(59,24)
  JVS(494) = B(376)
! JVS(495) = Jac_FULL(59,45)
  JVS(495) = 0.48*B(343)
! JVS(496) = Jac_FULL(59,53)
  JVS(496) = B(361)+0.6*B(362)+B(366)
! JVS(497) = Jac_FULL(59,59)
  JVS(497) = -B(372)-B(374)-B(377)-B(379)-B(381)
! JVS(498) = Jac_FULL(59,63)
  JVS(498) = 0.457*B(279)
! JVS(499) = Jac_FULL(59,67)
  JVS(499) = 0
! JVS(500) = Jac_FULL(59,68)
  JVS(500) = -B(382)
! JVS(501) = Jac_FULL(59,69)
  JVS(501) = 0.457*B(280)+0.6*B(363)
! JVS(502) = Jac_FULL(59,70)
  JVS(502) = -B(378)
! JVS(503) = Jac_FULL(59,72)
  JVS(503) = 0.48*B(344)+B(367)
! JVS(504) = Jac_FULL(59,73)
  JVS(504) = -B(380)
! JVS(505) = Jac_FULL(59,75)
  JVS(505) = -B(373)
! JVS(506) = Jac_FULL(59,76)
  JVS(506) = -B(375)
! JVS(507) = Jac_FULL(60,6)
  JVS(507) = 0.009*B(217)
! JVS(508) = Jac_FULL(60,12)
  JVS(508) = 0.03*B(227)
! JVS(509) = Jac_FULL(60,32)
  JVS(509) = 0.06*B(155)
! JVS(510) = Jac_FULL(60,39)
  JVS(510) = 0.04*B(231)
! JVS(511) = Jac_FULL(60,44)
  JVS(511) = 0.25*B(305)+0.18*B(307)+0.25*B(309)
! JVS(512) = Jac_FULL(60,45)
  JVS(512) = 0.06*B(341)+0.1*B(343)
! JVS(513) = Jac_FULL(60,46)
  JVS(513) = 0.03*B(277)
! JVS(514) = Jac_FULL(60,51)
  JVS(514) = 0.1*B(359)
! JVS(515) = Jac_FULL(60,54)
  JVS(515) = 0.04*B(260)
! JVS(516) = Jac_FULL(60,56)
  JVS(516) = 0.01*B(246)+0.024*B(248)+0.04*B(252)
! JVS(517) = Jac_FULL(60,58)
  JVS(517) = 0
! JVS(518) = Jac_FULL(60,59)
  JVS(518) = 0
! JVS(519) = Jac_FULL(60,60)
  JVS(519) = -B(144)-B(146)-B(148)-B(150)
! JVS(520) = Jac_FULL(60,61)
  JVS(520) = 0
! JVS(521) = Jac_FULL(60,62)
  JVS(521) = 0
! JVS(522) = Jac_FULL(60,63)
  JVS(522) = 0.022*B(279)
! JVS(523) = Jac_FULL(60,66)
  JVS(523) = 0.13*B(229)
! JVS(524) = Jac_FULL(60,67)
  JVS(524) = 0.18*B(308)
! JVS(525) = Jac_FULL(60,68)
  JVS(525) = -B(151)
! JVS(526) = Jac_FULL(60,69)
  JVS(526) = 0.06*B(156)+0.009*B(218)+0.03*B(228)+0.13*B(230)+0.024*B(249)+0.022*B(280)+0.25*B(306)+0.06*B(342)
! JVS(527) = Jac_FULL(60,70)
  JVS(527) = -B(147)
! JVS(528) = Jac_FULL(60,72)
  JVS(528) = 0.04*B(253)+0.04*B(261)+0.03*B(278)+0.25*B(310)+0.1*B(344)+0.1*B(360)
! JVS(529) = Jac_FULL(60,73)
  JVS(529) = -B(149)
! JVS(530) = Jac_FULL(60,74)
  JVS(530) = 0.01*B(247)
! JVS(531) = Jac_FULL(60,75)
  JVS(531) = -B(145)
! JVS(532) = Jac_FULL(60,76)
  JVS(532) = 0
! JVS(533) = Jac_FULL(61,27)
  JVS(533) = 0.067*B(286)
! JVS(534) = Jac_FULL(61,46)
  JVS(534) = B(262)
! JVS(535) = Jac_FULL(61,61)
  JVS(535) = -B(266)-B(268)-B(270)-B(272)-B(274)
! JVS(536) = Jac_FULL(61,67)
  JVS(536) = 0
! JVS(537) = Jac_FULL(61,68)
  JVS(537) = -B(273)
! JVS(538) = Jac_FULL(61,69)
  JVS(538) = B(263)+0.067*B(287)
! JVS(539) = Jac_FULL(61,70)
  JVS(539) = -B(269)
! JVS(540) = Jac_FULL(61,72)
  JVS(540) = 0
! JVS(541) = Jac_FULL(61,73)
  JVS(541) = -B(271)
! JVS(542) = Jac_FULL(61,74)
  JVS(542) = 0
! JVS(543) = Jac_FULL(61,75)
  JVS(543) = -B(267)
! JVS(544) = Jac_FULL(62,6)
  JVS(544) = 0.991*B(217)
! JVS(545) = Jac_FULL(62,11)
  JVS(545) = 0.1*B(221)
! JVS(546) = Jac_FULL(62,12)
  JVS(546) = 0.97*B(227)
! JVS(547) = Jac_FULL(62,13)
  JVS(547) = 0.5*B(223)
! JVS(548) = Jac_FULL(62,14)
  JVS(548) = 0.07*B(321)
! JVS(549) = Jac_FULL(62,15)
  JVS(549) = 0.058*B(331)
! JVS(550) = Jac_FULL(62,29)
  JVS(550) = 0.4*B(109)
! JVS(551) = Jac_FULL(62,32)
  JVS(551) = 0.54*B(155)
! JVS(552) = Jac_FULL(62,35)
  JVS(552) = 0.37*B(301)
! JVS(553) = Jac_FULL(62,39)
  JVS(553) = 0.94*B(231)
! JVS(554) = Jac_FULL(62,41)
  JVS(554) = 0.7*B(238)+B(240)+0.5*B(244)
! JVS(555) = Jac_FULL(62,44)
  JVS(555) = 0.75*B(305)+0.07*B(307)+0.28*B(309)
! JVS(556) = Jac_FULL(62,45)
  JVS(556) = 0.12*B(341)+0.12*B(343)
! JVS(557) = Jac_FULL(62,46)
  JVS(557) = 0.64*B(277)
! JVS(558) = Jac_FULL(62,49)
  JVS(558) = 0.11*B(198)
! JVS(559) = Jac_FULL(62,51)
  JVS(559) = B(354)+2*B(355)+0.3*B(357)+0.45*B(359)
! JVS(560) = Jac_FULL(62,53)
  JVS(560) = 0.4*B(362)
! JVS(561) = Jac_FULL(62,54)
  JVS(561) = 0.1*B(254)+B(256)+0.3*B(258)+0.48*B(260)
! JVS(562) = Jac_FULL(62,56)
  JVS(562) = 0.2*B(246)+0.976*B(248)+0.15*B(250)+0.48*B(252)
! JVS(563) = Jac_FULL(62,58)
  JVS(563) = 0
! JVS(564) = Jac_FULL(62,59)
  JVS(564) = 0.44*B(377)+0.8*B(381)
! JVS(565) = Jac_FULL(62,60)
  JVS(565) = 0
! JVS(566) = Jac_FULL(62,61)
  JVS(566) = 0.082*B(266)+0.072*B(270)+0.072*B(272)
! JVS(567) = Jac_FULL(62,62)
  JVS(567) = -B(128)-B(130)-B(132)-B(134)
! JVS(568) = Jac_FULL(62,63)
  JVS(568) = 0.142*B(283)+0.34*B(285)
! JVS(569) = Jac_FULL(62,65)
  JVS(569) = B(195)
! JVS(570) = Jac_FULL(62,66)
  JVS(570) = 0.11*B(229)
! JVS(571) = Jac_FULL(62,67)
  JVS(571) = 0.15*B(251)+0.3*B(259)+0.07*B(308)+0.3*B(358)
! JVS(572) = Jac_FULL(62,68)
  JVS(572) = 0.8*B(112)-B(135)+0.072*B(273)+0.8*B(382)
! JVS(573) = Jac_FULL(62,69)
  JVS(573) = 0.54*B(156)+0.991*B(218)+0.1*B(222)+0.97*B(228)+0.11*B(230)+B(241)+0.976*B(249)+B(257)+0.37*B(302)+0.75&
               &*B(306)+0.07*B(322)+0.058*B(332)+0.12*B(342)+2*B(356)+0.4*B(363)
! JVS(574) = Jac_FULL(62,70)
  JVS(574) = 0.44*B(110)-B(131)+0.44*B(378)
! JVS(575) = Jac_FULL(62,71)
  JVS(575) = B(102)+B(104)+0.44*B(111)+0.8*B(113)+2*B(114)
! JVS(576) = Jac_FULL(62,72)
  JVS(576) = 0.5*B(245)+0.48*B(253)+0.48*B(261)+0.64*B(278)+0.142*B(284)+0.28*B(310)+0.12*B(344)+0.45*B(360)
! JVS(577) = Jac_FULL(62,73)
  JVS(577) = B(103)-B(133)+0.072*B(271)
! JVS(578) = Jac_FULL(62,74)
  JVS(578) = 0.7*B(239)+0.2*B(247)+0.1*B(255)
! JVS(579) = Jac_FULL(62,75)
  JVS(579) = B(105)-B(129)+0.082*B(267)
! JVS(580) = Jac_FULL(62,76)
  JVS(580) = 0
! JVS(581) = Jac_FULL(63,16)
  JVS(581) = B(288)+B(289)
! JVS(582) = Jac_FULL(63,46)
  JVS(582) = 0.75*B(264)+0.65*B(275)+0.35*B(277)
! JVS(583) = Jac_FULL(63,61)
  JVS(583) = 0.9*B(266)+0.12*B(268)+B(270)+B(272)
! JVS(584) = Jac_FULL(63,63)
  JVS(584) = -B(279)-B(281)-B(283)-B(285)
! JVS(585) = Jac_FULL(63,67)
  JVS(585) = 0.65*B(276)-B(282)
! JVS(586) = Jac_FULL(63,68)
  JVS(586) = B(273)
! JVS(587) = Jac_FULL(63,69)
  JVS(587) = -B(280)
! JVS(588) = Jac_FULL(63,70)
  JVS(588) = 0.12*B(269)
! JVS(589) = Jac_FULL(63,72)
  JVS(589) = 0.35*B(278)-B(284)+B(290)
! JVS(590) = Jac_FULL(63,73)
  JVS(590) = B(271)
! JVS(591) = Jac_FULL(63,74)
  JVS(591) = 0.75*B(265)
! JVS(592) = Jac_FULL(63,75)
  JVS(592) = 0.9*B(267)
! JVS(593) = Jac_FULL(64,5)
  JVS(593) = B(388)
! JVS(594) = Jac_FULL(64,13)
  JVS(594) = 0.5*B(223)
! JVS(595) = Jac_FULL(64,17)
  JVS(595) = 0.4*B(96)
! JVS(596) = Jac_FULL(64,23)
  JVS(596) = 0.6*B(152)+B(154)
! JVS(597) = Jac_FULL(64,30)
  JVS(597) = 0
! JVS(598) = Jac_FULL(64,34)
  JVS(598) = 1.38*B(224)
! JVS(599) = Jac_FULL(64,36)
  JVS(599) = B(315)
! JVS(600) = Jac_FULL(64,38)
  JVS(600) = B(163)
! JVS(601) = Jac_FULL(64,39)
  JVS(601) = 0
! JVS(602) = Jac_FULL(64,40)
  JVS(602) = B(325)
! JVS(603) = Jac_FULL(64,43)
  JVS(603) = B(337)
! JVS(604) = Jac_FULL(64,47)
  JVS(604) = 0.8*B(297)
! JVS(605) = Jac_FULL(64,54)
  JVS(605) = 0
! JVS(606) = Jac_FULL(64,55)
  JVS(606) = 0
! JVS(607) = Jac_FULL(64,56)
  JVS(607) = 0
! JVS(608) = Jac_FULL(64,57)
  JVS(608) = B(188)
! JVS(609) = Jac_FULL(64,58)
  JVS(609) = 0.8*B(140)
! JVS(610) = Jac_FULL(64,59)
  JVS(610) = B(379)
! JVS(611) = Jac_FULL(64,60)
  JVS(611) = 0.8*B(148)
! JVS(612) = Jac_FULL(64,61)
  JVS(612) = 0.8*B(270)
! JVS(613) = Jac_FULL(64,62)
  JVS(613) = 0.8*B(132)
! JVS(614) = Jac_FULL(64,63)
  JVS(614) = 0.115*B(279)+0.34*B(285)
! JVS(615) = Jac_FULL(64,64)
  JVS(615) = -B(120)-B(122)-0.1*B(124)-B(126)
! JVS(616) = Jac_FULL(64,65)
  JVS(616) = 0
! JVS(617) = Jac_FULL(64,66)
  JVS(617) = 0
! JVS(618) = Jac_FULL(64,67)
  JVS(618) = 0
! JVS(619) = Jac_FULL(64,68)
  JVS(619) = -B(127)
! JVS(620) = Jac_FULL(64,69)
  JVS(620) = 0.6*B(153)+B(164)+B(215)+0.115*B(280)+B(389)
! JVS(621) = Jac_FULL(64,70)
  JVS(621) = 0.44*B(97)-B(123)
! JVS(622) = Jac_FULL(64,71)
  JVS(622) = B(102)
! JVS(623) = Jac_FULL(64,72)
  JVS(623) = 0
! JVS(624) = Jac_FULL(64,73)
  JVS(624) = B(91)+0.44*B(98)+2*B(101)+B(103)-0.1*B(125)+0.8*B(133)+0.8*B(141)+0.8*B(149)+0.8*B(271)+0.8*B(298)+B(316)&
               &+B(326)+B(338)+B(380)
! JVS(625) = Jac_FULL(64,74)
  JVS(625) = 0
! JVS(626) = Jac_FULL(64,75)
  JVS(626) = B(92)-B(121)
! JVS(627) = Jac_FULL(64,76)
  JVS(627) = 0
! JVS(628) = Jac_FULL(65,12)
  JVS(628) = 0.26*B(227)
! JVS(629) = Jac_FULL(65,27)
  JVS(629) = 0.029*B(286)
! JVS(630) = Jac_FULL(65,35)
  JVS(630) = 0.078*B(301)
! JVS(631) = Jac_FULL(65,39)
  JVS(631) = 0.37*B(231)
! JVS(632) = Jac_FULL(65,44)
  JVS(632) = 0.15*B(303)+0.47*B(305)+0.21*B(307)+0.47*B(309)
! JVS(633) = Jac_FULL(65,46)
  JVS(633) = 0.15*B(275)
! JVS(634) = Jac_FULL(65,54)
  JVS(634) = 0.66*B(254)+0.7*B(256)+0.442*B(258)+0.625*B(260)
! JVS(635) = Jac_FULL(65,56)
  JVS(635) = 0.3*B(246)+0.488*B(248)+0.27*B(250)+0.375*B(252)
! JVS(636) = Jac_FULL(65,59)
  JVS(636) = 0.44*B(377)+B(379)+0.8*B(381)
! JVS(637) = Jac_FULL(65,61)
  JVS(637) = 0
! JVS(638) = Jac_FULL(65,63)
  JVS(638) = 0
! JVS(639) = Jac_FULL(65,65)
  JVS(639) = -B(189)-B(191)-B(193)-B(195)
! JVS(640) = Jac_FULL(65,66)
  JVS(640) = 0.11*B(229)
! JVS(641) = Jac_FULL(65,67)
  JVS(641) = 0.27*B(251)+0.442*B(259)+0.15*B(276)+0.21*B(308)
! JVS(642) = Jac_FULL(65,68)
  JVS(642) = 0.8*B(382)
! JVS(643) = Jac_FULL(65,69)
  JVS(643) = -B(192)+0.26*B(228)+0.11*B(230)+0.488*B(249)+0.7*B(257)+0.029*B(287)+0.078*B(302)+0.47*B(306)
! JVS(644) = Jac_FULL(65,70)
  JVS(644) = 0.44*B(378)
! JVS(645) = Jac_FULL(65,72)
  JVS(645) = -B(194)+0.375*B(253)+0.625*B(261)+0.47*B(310)
! JVS(646) = Jac_FULL(65,73)
  JVS(646) = B(380)
! JVS(647) = Jac_FULL(65,74)
  JVS(647) = -B(190)+0.3*B(247)+0.66*B(255)+0.15*B(304)
! JVS(648) = Jac_FULL(65,75)
  JVS(648) = 0
! JVS(649) = Jac_FULL(65,76)
  JVS(649) = 0
! JVS(650) = Jac_FULL(66,12)
  JVS(650) = 0.26*B(227)
! JVS(651) = Jac_FULL(66,13)
  JVS(651) = -2.5*B(223)
! JVS(652) = Jac_FULL(66,35)
  JVS(652) = 2.7*B(301)
! JVS(653) = Jac_FULL(66,39)
  JVS(653) = -2.7*B(231)
! JVS(654) = Jac_FULL(66,44)
  JVS(654) = 5.12*B(303)+1.66*B(305)+7*B(307)
! JVS(655) = Jac_FULL(66,46)
  JVS(655) = 0.25*B(264)+0.35*B(275)
! JVS(656) = Jac_FULL(66,47)
  JVS(656) = 2.175*B(293)+2.175*B(295)+1.74*B(297)+2.175*B(299)
! JVS(657) = Jac_FULL(66,54)
  JVS(657) = 0.1*B(254)+0.29*B(258)+B(260)
! JVS(658) = Jac_FULL(66,56)
  JVS(658) = 0.2*B(246)-0.73*B(248)-0.79*B(250)-B(252)
! JVS(659) = Jac_FULL(66,61)
  JVS(659) = 0
! JVS(660) = Jac_FULL(66,63)
  JVS(660) = 0.117*B(279)+0.717*B(283)+0.24*B(285)
! JVS(661) = Jac_FULL(66,66)
  JVS(661) = -1.11*B(229)
! JVS(662) = Jac_FULL(66,67)
  JVS(662) = -0.79*B(251)+0.29*B(259)+0.35*B(276)+7*B(308)
! JVS(663) = Jac_FULL(66,68)
  JVS(663) = 2.175*B(300)
! JVS(664) = Jac_FULL(66,69)
  JVS(664) = 0.26*B(228)-1.11*B(230)-0.73*B(249)+0.117*B(280)+2.7*B(302)+1.66*B(306)
! JVS(665) = Jac_FULL(66,70)
  JVS(665) = 2.175*B(294)
! JVS(666) = Jac_FULL(66,72)
  JVS(666) = -B(253)+B(261)+0.717*B(284)
! JVS(667) = Jac_FULL(66,73)
  JVS(667) = 1.74*B(298)
! JVS(668) = Jac_FULL(66,74)
  JVS(668) = 0.2*B(247)+0.1*B(255)+0.25*B(265)+5.12*B(304)
! JVS(669) = Jac_FULL(66,75)
  JVS(669) = 2.175*B(296)
! JVS(670) = Jac_FULL(66,76)
  JVS(670) = 0
! JVS(671) = Jac_FULL(67,41)
  JVS(671) = -B(242)
! JVS(672) = Jac_FULL(67,44)
  JVS(672) = -B(307)
! JVS(673) = Jac_FULL(67,46)
  JVS(673) = -B(275)
! JVS(674) = Jac_FULL(67,51)
  JVS(674) = -B(357)
! JVS(675) = Jac_FULL(67,53)
  JVS(675) = -B(364)
! JVS(676) = Jac_FULL(67,54)
  JVS(676) = -B(258)
! JVS(677) = Jac_FULL(67,56)
  JVS(677) = -B(250)
! JVS(678) = Jac_FULL(67,59)
  JVS(678) = 0.15*B(377)
! JVS(679) = Jac_FULL(67,61)
  JVS(679) = 0
! JVS(680) = Jac_FULL(67,63)
  JVS(680) = -B(281)
! JVS(681) = Jac_FULL(67,67)
  JVS(681) = -B(5)-B(14)-B(16)-B(17)-B(22)-B(24)-B(46)-B(60)-B(243)-B(251)-B(259)-B(276)-B(282)-B(308)-B(358)-B(365)
! JVS(682) = Jac_FULL(67,68)
  JVS(682) = 0
! JVS(683) = Jac_FULL(67,69)
  JVS(683) = -B(23)
! JVS(684) = Jac_FULL(67,70)
  JVS(684) = -B(25)+0.15*B(97)+0.15*B(110)+0.15*B(378)
! JVS(685) = Jac_FULL(67,71)
  JVS(685) = 0.15*B(111)
! JVS(686) = Jac_FULL(67,72)
  JVS(686) = -B(61)
! JVS(687) = Jac_FULL(67,73)
  JVS(687) = 0.15*B(98)
! JVS(688) = Jac_FULL(67,74)
  JVS(688) = B(2)-B(15)
! JVS(689) = Jac_FULL(67,75)
  JVS(689) = -B(6)
! JVS(690) = Jac_FULL(67,76)
  JVS(690) = -B(47)
! JVS(691) = Jac_FULL(68,5)
  JVS(691) = B(388)
! JVS(692) = Jac_FULL(68,6)
  JVS(692) = B(217)
! JVS(693) = Jac_FULL(68,9)
  JVS(693) = 0.352*B(311)
! JVS(694) = Jac_FULL(68,10)
  JVS(694) = B(291)
! JVS(695) = Jac_FULL(68,11)
  JVS(695) = 0.1*B(221)
! JVS(696) = Jac_FULL(68,12)
  JVS(696) = B(227)
! JVS(697) = Jac_FULL(68,13)
  JVS(697) = B(223)
! JVS(698) = Jac_FULL(68,14)
  JVS(698) = 0.72*B(321)
! JVS(699) = Jac_FULL(68,15)
  JVS(699) = 0.602*B(331)
! JVS(700) = Jac_FULL(68,17)
  JVS(700) = 0.4*B(96)
! JVS(701) = Jac_FULL(68,23)
  JVS(701) = 0.6*B(152)+B(154)
! JVS(702) = Jac_FULL(68,27)
  JVS(702) = 0.067*B(286)
! JVS(703) = Jac_FULL(68,29)
  JVS(703) = 0.4*B(109)
! JVS(704) = Jac_FULL(68,30)
  JVS(704) = 0
! JVS(705) = Jac_FULL(68,32)
  JVS(705) = 0.6*B(155)
! JVS(706) = Jac_FULL(68,34)
  JVS(706) = 1.38*B(224)+B(225)
! JVS(707) = Jac_FULL(68,35)
  JVS(707) = B(301)
! JVS(708) = Jac_FULL(68,36)
  JVS(708) = B(315)
! JVS(709) = Jac_FULL(68,38)
  JVS(709) = B(163)
! JVS(710) = Jac_FULL(68,39)
  JVS(710) = 0.98*B(231)
! JVS(711) = Jac_FULL(68,40)
  JVS(711) = B(325)
! JVS(712) = Jac_FULL(68,41)
  JVS(712) = 0.7*B(238)+B(240)+B(244)
! JVS(713) = Jac_FULL(68,43)
  JVS(713) = B(337)
! JVS(714) = Jac_FULL(68,44)
  JVS(714) = 1.5*B(305)+0.94*B(307)+1.28*B(309)
! JVS(715) = Jac_FULL(68,45)
  JVS(715) = 0.18*B(341)+0.7*B(343)
! JVS(716) = Jac_FULL(68,46)
  JVS(716) = B(262)+0.25*B(264)+0.2*B(275)+B(277)
! JVS(717) = Jac_FULL(68,47)
  JVS(717) = 0.8*B(297)
! JVS(718) = Jac_FULL(68,49)
  JVS(718) = 0.11*B(198)
! JVS(719) = Jac_FULL(68,50)
  JVS(719) = 0.2*B(201)+0.5*B(204)
! JVS(720) = Jac_FULL(68,51)
  JVS(720) = 2*B(355)+0.3*B(357)+B(359)
! JVS(721) = Jac_FULL(68,52)
  JVS(721) = B(207)
! JVS(722) = Jac_FULL(68,53)
  JVS(722) = 0.4*B(362)
! JVS(723) = Jac_FULL(68,54)
  JVS(723) = 0.1*B(254)+B(256)+0.3*B(258)+B(260)
! JVS(724) = Jac_FULL(68,55)
  JVS(724) = 0
! JVS(725) = Jac_FULL(68,56)
  JVS(725) = 0.21*B(246)+1.195*B(248)+0.15*B(250)+B(252)
! JVS(726) = Jac_FULL(68,57)
  JVS(726) = B(188)
! JVS(727) = Jac_FULL(68,58)
  JVS(727) = 0.8*B(140)
! JVS(728) = Jac_FULL(68,59)
  JVS(728) = 0.44*B(377)+2*B(379)+0.8*B(381)
! JVS(729) = Jac_FULL(68,60)
  JVS(729) = 0.8*B(148)
! JVS(730) = Jac_FULL(68,61)
  JVS(730) = 0.082*B(266)+0.872*B(270)-0.928*B(272)
! JVS(731) = Jac_FULL(68,62)
  JVS(731) = 0.8*B(132)
! JVS(732) = Jac_FULL(68,63)
  JVS(732) = 0.658*B(279)+0.284*B(283)+0.84*B(285)
! JVS(733) = Jac_FULL(68,64)
  JVS(733) = 0.9*B(124)
! JVS(734) = Jac_FULL(68,65)
  JVS(734) = B(195)
! JVS(735) = Jac_FULL(68,66)
  JVS(735) = B(229)
! JVS(736) = Jac_FULL(68,67)
  JVS(736) = 0.15*B(251)+0.3*B(259)+0.2*B(276)+0.94*B(308)+0.3*B(358)
! JVS(737) = Jac_FULL(68,68)
  JVS(737) = -B(99)-0.2*B(112)-B(115)-B(117)-2*B(119)-0.928*B(273)+0.8*B(382)
! JVS(738) = Jac_FULL(68,69)
  JVS(738) = 0.6*B(153)+0.6*B(156)+B(164)+0.2*B(202)+B(215)+B(218)+0.1*B(222)+B(226)+B(228)+B(230)+B(241)+1.195*B(249)&
               &+B(257)+B(263)+0.658*B(280)+0.067*B(287)+B(292)+B(302)+1.5*B(306)+0.352*B(312)+0.72*B(322)+0.602*B(332)+0.18&
               &*B(342)+2*B(356)+0.4*B(363)+B(389)
! JVS(739) = Jac_FULL(68,70)
  JVS(739) = 0.44*B(97)+0.44*B(110)-B(118)+0.44*B(378)
! JVS(740) = Jac_FULL(68,71)
  JVS(740) = 2*B(102)+B(104)+0.44*B(111)-0.2*B(113)+2*B(114)
! JVS(741) = Jac_FULL(68,72)
  JVS(741) = 0.5*B(205)+B(208)+B(245)+B(253)+B(261)+B(278)+0.284*B(284)+1.28*B(310)+0.7*B(344)+B(360)
! JVS(742) = Jac_FULL(68,73)
  JVS(742) = B(91)+0.44*B(98)-B(100)+2*B(101)+2*B(103)+0.9*B(125)+0.8*B(133)+0.8*B(141)+0.8*B(149)+0.872*B(271)+0.8&
               &*B(298)+B(316)+B(326)+B(338)+2*B(380)
! JVS(743) = Jac_FULL(68,74)
  JVS(743) = 0.7*B(239)+0.21*B(247)+0.1*B(255)+0.25*B(265)
! JVS(744) = Jac_FULL(68,75)
  JVS(744) = B(92)+B(105)-B(116)+0.082*B(267)
! JVS(745) = Jac_FULL(68,76)
  JVS(745) = 0
! JVS(746) = Jac_FULL(69,3)
  JVS(746) = -B(89)
! JVS(747) = Jac_FULL(69,4)
  JVS(747) = 2*B(20)
! JVS(748) = Jac_FULL(69,5)
  JVS(748) = -B(388)
! JVS(749) = Jac_FULL(69,6)
  JVS(749) = -B(217)
! JVS(750) = Jac_FULL(69,7)
  JVS(750) = -0.3*B(236)
! JVS(751) = Jac_FULL(69,9)
  JVS(751) = -0.882*B(311)
! JVS(752) = Jac_FULL(69,10)
  JVS(752) = -B(291)
! JVS(753) = Jac_FULL(69,11)
  JVS(753) = -B(221)
! JVS(754) = Jac_FULL(69,12)
  JVS(754) = -B(227)
! JVS(755) = Jac_FULL(69,14)
  JVS(755) = -0.9*B(321)
! JVS(756) = Jac_FULL(69,15)
  JVS(756) = -0.756*B(331)
! JVS(757) = Jac_FULL(69,16)
  JVS(757) = B(288)
! JVS(758) = Jac_FULL(69,18)
  JVS(758) = -B(165)
! JVS(759) = Jac_FULL(69,20)
  JVS(759) = 0.41*B(86)-B(87)
! JVS(760) = Jac_FULL(69,21)
  JVS(760) = -B(219)
! JVS(761) = Jac_FULL(69,22)
  JVS(761) = B(75)-B(76)
! JVS(762) = Jac_FULL(69,23)
  JVS(762) = -0.6*B(152)+B(154)
! JVS(763) = Jac_FULL(69,24)
  JVS(763) = -B(383)
! JVS(764) = Jac_FULL(69,25)
  JVS(764) = -B(368)
! JVS(765) = Jac_FULL(69,26)
  JVS(765) = 2*B(37)-B(38)+B(40)
! JVS(766) = Jac_FULL(69,27)
  JVS(766) = -0.067*B(286)
! JVS(767) = Jac_FULL(69,28)
  JVS(767) = -B(161)
! JVS(768) = Jac_FULL(69,29)
  JVS(768) = -B(385)
! JVS(769) = Jac_FULL(69,30)
  JVS(769) = 0.2*B(180)
! JVS(770) = Jac_FULL(69,32)
  JVS(770) = -0.6*B(155)+B(157)
! JVS(771) = Jac_FULL(69,33)
  JVS(771) = -B(158)
! JVS(772) = Jac_FULL(69,34)
  JVS(772) = -B(225)
! JVS(773) = Jac_FULL(69,35)
  JVS(773) = -B(301)
! JVS(774) = Jac_FULL(69,37)
  JVS(774) = -B(349)
! JVS(775) = Jac_FULL(69,38)
  JVS(775) = -B(163)
! JVS(776) = Jac_FULL(69,39)
  JVS(776) = 0
! JVS(777) = Jac_FULL(69,41)
  JVS(777) = 0.3*B(238)-B(240)+0.16*B(242)
! JVS(778) = Jac_FULL(69,42)
  JVS(778) = -B(213)
! JVS(779) = Jac_FULL(69,44)
  JVS(779) = -B(305)+0.57*B(307)
! JVS(780) = Jac_FULL(69,45)
  JVS(780) = -B(341)
! JVS(781) = Jac_FULL(69,46)
  JVS(781) = -B(262)+0.266*B(275)
! JVS(782) = Jac_FULL(69,47)
  JVS(782) = 1.125*B(293)+0.125*B(295)+0.1*B(297)+0.125*B(299)
! JVS(783) = Jac_FULL(69,48)
  JVS(783) = -B(80)+B(82)
! JVS(784) = Jac_FULL(69,49)
  JVS(784) = -B(196)+0.19*B(198)
! JVS(785) = Jac_FULL(69,50)
  JVS(785) = -B(201)
! JVS(786) = Jac_FULL(69,51)
  JVS(786) = -B(355)+0.5*B(357)
! JVS(787) = Jac_FULL(69,52)
  JVS(787) = -B(209)
! JVS(788) = Jac_FULL(69,53)
  JVS(788) = -B(362)+0.5*B(364)
! JVS(789) = Jac_FULL(69,54)
  JVS(789) = -B(256)+0.5*B(258)
! JVS(790) = Jac_FULL(69,55)
  JVS(790) = -B(167)+B(171)
! JVS(791) = Jac_FULL(69,56)
  JVS(791) = 0.1*B(246)-B(248)+0.334*B(250)
! JVS(792) = Jac_FULL(69,57)
  JVS(792) = B(182)-B(184)
! JVS(793) = Jac_FULL(69,58)
  JVS(793) = 0
! JVS(794) = Jac_FULL(69,59)
  JVS(794) = 0.44*B(377)
! JVS(795) = Jac_FULL(69,60)
  JVS(795) = 0
! JVS(796) = Jac_FULL(69,61)
  JVS(796) = 0.12*B(268)
! JVS(797) = Jac_FULL(69,62)
  JVS(797) = 0
! JVS(798) = Jac_FULL(69,63)
  JVS(798) = -B(279)+0.461*B(281)
! JVS(799) = Jac_FULL(69,64)
  JVS(799) = 0
! JVS(800) = Jac_FULL(69,65)
  JVS(800) = B(189)-B(191)
! JVS(801) = Jac_FULL(69,66)
  JVS(801) = -B(229)
! JVS(802) = Jac_FULL(69,67)
  JVS(802) = -B(22)+B(24)+0.16*B(243)+0.334*B(251)+0.5*B(259)+0.266*B(276)+0.461*B(282)+0.57*B(308)+0.5*B(358)+0.5&
               &*B(365)
! JVS(803) = Jac_FULL(69,68)
  JVS(803) = 0.125*B(300)
! JVS(804) = Jac_FULL(69,69)
  JVS(804) = -B(23)-B(26)-2*B(30)-2*B(31)-B(32)-B(39)-B(56)-B(69)-B(77)-B(78)-B(81)-B(88)-B(90)-0.6*B(153)-0.6*B(156)&
               &-B(159)-B(162)-B(164)-B(166)-B(168)-B(185)-B(192)-B(197)-B(202)-B(210)-B(211)-B(214)-B(215)-B(218)-B(220)&
               &-B(222)-B(226)-B(228)-B(230)-0.3*B(237)-B(241)-B(249)-B(257)-B(263)-B(280)-0.067*B(287)-B(292)-B(302)-B(306)&
               &-0.882*B(312)-0.9*B(322)-0.756*B(332)-B(342)-B(350)-B(356)-B(363)-B(369)-B(384)-B(386)-B(389)
! JVS(805) = Jac_FULL(69,70)
  JVS(805) = B(25)+B(28)-B(33)+B(44)+B(58)+0.44*B(97)+0.44*B(110)+0.2*B(181)+0.12*B(269)+1.125*B(294)+0.44*B(378)
! JVS(806) = Jac_FULL(69,71)
  JVS(806) = 0.44*B(111)
! JVS(807) = Jac_FULL(69,72)
  JVS(807) = -B(57)+B(59)
! JVS(808) = Jac_FULL(69,73)
  JVS(808) = 0.44*B(98)+0.1*B(298)
! JVS(809) = Jac_FULL(69,74)
  JVS(809) = -B(27)+B(29)+B(41)+B(172)+B(183)+B(190)+0.3*B(239)+0.1*B(247)
! JVS(810) = Jac_FULL(69,75)
  JVS(810) = B(45)-B(70)+0.125*B(296)
! JVS(811) = Jac_FULL(69,76)
  JVS(811) = -B(79)
! JVS(812) = Jac_FULL(70,3)
  JVS(812) = B(89)
! JVS(813) = Jac_FULL(70,7)
  JVS(813) = 0.3*B(236)
! JVS(814) = Jac_FULL(70,9)
  JVS(814) = 0.53*B(311)
! JVS(815) = Jac_FULL(70,11)
  JVS(815) = 0.9*B(221)
! JVS(816) = Jac_FULL(70,14)
  JVS(816) = 0.18*B(321)
! JVS(817) = Jac_FULL(70,15)
  JVS(817) = 0.155*B(331)
! JVS(818) = Jac_FULL(70,20)
  JVS(818) = B(85)+0.59*B(86)
! JVS(819) = Jac_FULL(70,21)
  JVS(819) = B(219)
! JVS(820) = Jac_FULL(70,25)
  JVS(820) = 0.2*B(368)
! JVS(821) = Jac_FULL(70,26)
  JVS(821) = B(38)+B(40)
! JVS(822) = Jac_FULL(70,28)
  JVS(822) = B(161)
! JVS(823) = Jac_FULL(70,30)
  JVS(823) = B(177)+B(178)-0.8*B(180)
! JVS(824) = Jac_FULL(70,31)
  JVS(824) = -B(347)
! JVS(825) = Jac_FULL(70,32)
  JVS(825) = B(157)
! JVS(826) = Jac_FULL(70,35)
  JVS(826) = 0
! JVS(827) = Jac_FULL(70,36)
  JVS(827) = 0.918*B(313)+B(315)-B(317)+B(319)
! JVS(828) = Jac_FULL(70,37)
  JVS(828) = B(353)
! JVS(829) = Jac_FULL(70,39)
  JVS(829) = B(232)
! JVS(830) = Jac_FULL(70,40)
  JVS(830) = 0.86*B(323)+B(325)-B(327)+B(329)
! JVS(831) = Jac_FULL(70,41)
  JVS(831) = B(238)+0.16*B(242)
! JVS(832) = Jac_FULL(70,42)
  JVS(832) = B(213)
! JVS(833) = Jac_FULL(70,43)
  JVS(833) = 0.86*B(333)-B(335)+B(337)+B(339)
! JVS(834) = Jac_FULL(70,44)
  JVS(834) = 0
! JVS(835) = Jac_FULL(70,45)
  JVS(835) = B(341)
! JVS(836) = Jac_FULL(70,46)
  JVS(836) = 0.25*B(264)+0.066*B(275)
! JVS(837) = Jac_FULL(70,47)
  JVS(837) = -0.175*B(293)+0.825*B(295)+0.66*B(297)+0.825*B(299)
! JVS(838) = Jac_FULL(70,49)
  JVS(838) = 0.2*B(196)+1.4*B(198)
! JVS(839) = Jac_FULL(70,50)
  JVS(839) = B(201)+2*B(203)+B(204)
! JVS(840) = Jac_FULL(70,51)
  JVS(840) = 0.7*B(354)
! JVS(841) = Jac_FULL(70,52)
  JVS(841) = B(206)
! JVS(842) = Jac_FULL(70,53)
  JVS(842) = B(361)+0.56*B(364)
! JVS(843) = Jac_FULL(70,54)
  JVS(843) = 0
! JVS(844) = Jac_FULL(70,55)
  JVS(844) = B(167)+2*B(169)+B(171)+B(173)-B(175)
! JVS(845) = Jac_FULL(70,56)
  JVS(845) = 0.1*B(246)+0.08*B(250)
! JVS(846) = Jac_FULL(70,57)
  JVS(846) = B(188)
! JVS(847) = Jac_FULL(70,58)
  JVS(847) = -B(138)
! JVS(848) = Jac_FULL(70,59)
  JVS(848) = 0.8*B(372)-B(377)
! JVS(849) = Jac_FULL(70,60)
  JVS(849) = -B(146)+0.8*B(148)
! JVS(850) = Jac_FULL(70,61)
  JVS(850) = 0.818*B(266)-0.88*B(268)+0.728*B(270)+0.728*B(272)+B(274)
! JVS(851) = Jac_FULL(70,62)
  JVS(851) = B(128)-B(130)+0.8*B(132)+0.6*B(134)
! JVS(852) = Jac_FULL(70,63)
  JVS(852) = 0.137*B(279)+0.398*B(281)+0.76*B(285)
! JVS(853) = Jac_FULL(70,64)
  JVS(853) = B(120)-B(122)+0.9*B(124)+0.37*B(126)
! JVS(854) = Jac_FULL(70,65)
  JVS(854) = B(195)
! JVS(855) = Jac_FULL(70,66)
  JVS(855) = 0
! JVS(856) = Jac_FULL(70,67)
  JVS(856) = B(22)-B(24)+0.16*B(243)+0.08*B(251)+0.066*B(276)+0.398*B(282)+0.56*B(365)
! JVS(857) = Jac_FULL(70,68)
  JVS(857) = 0.37*B(127)+0.6*B(135)+0.728*B(273)+0.825*B(300)+B(320)+B(330)+B(340)
! JVS(858) = Jac_FULL(70,69)
  JVS(858) = B(23)+B(26)-B(32)+B(39)+B(56)+B(90)+B(162)+B(168)+0.2*B(197)+B(202)+B(211)+B(214)+B(220)+0.9*B(222)+0.3&
               &*B(237)+0.137*B(280)+0.53*B(312)+0.18*B(322)+0.155*B(332)+B(342)+0.2*B(369)
! JVS(859) = Jac_FULL(70,70)
  JVS(859) = -B(25)-B(28)-B(33)-2*B(34)-2*B(35)-B(44)-B(58)-B(83)-B(97)-B(110)-B(123)-B(131)-B(139)-B(147)-B(176)-0.8&
               &*B(181)-0.88*B(269)-0.175*B(294)-B(318)-B(328)-B(336)-B(348)-B(378)
! JVS(860) = Jac_FULL(70,71)
  JVS(860) = -B(111)
! JVS(861) = Jac_FULL(70,72)
  JVS(861) = B(57)-B(59)+B(174)+B(205)
! JVS(862) = Jac_FULL(70,73)
  JVS(862) = -B(98)+0.9*B(125)+0.8*B(133)+0.8*B(149)+0.728*B(271)+0.66*B(298)+B(316)+B(326)+B(338)
! JVS(863) = Jac_FULL(70,74)
  JVS(863) = B(27)-B(29)+B(41)+B(172)+B(239)+0.1*B(247)+0.25*B(265)
! JVS(864) = Jac_FULL(70,75)
  JVS(864) = -B(45)+B(121)+B(129)+B(179)+0.818*B(267)+0.825*B(296)+0.918*B(314)+0.86*B(324)+0.86*B(334)+0.8*B(373)
! JVS(865) = Jac_FULL(70,76)
  JVS(865) = -B(84)
! JVS(866) = Jac_FULL(71,13)
  JVS(866) = 0.5*B(223)
! JVS(867) = Jac_FULL(71,29)
  JVS(867) = B(108)+0.6*B(109)
! JVS(868) = Jac_FULL(71,39)
  JVS(868) = 0
! JVS(869) = Jac_FULL(71,44)
  JVS(869) = 0.39*B(307)
! JVS(870) = Jac_FULL(71,46)
  JVS(870) = 0.25*B(264)+0.2*B(275)
! JVS(871) = Jac_FULL(71,59)
  JVS(871) = 0.2*B(372)
! JVS(872) = Jac_FULL(71,63)
  JVS(872) = 0.717*B(283)
! JVS(873) = Jac_FULL(71,65)
  JVS(873) = B(189)+B(191)+B(193)
! JVS(874) = Jac_FULL(71,66)
  JVS(874) = 0
! JVS(875) = Jac_FULL(71,67)
  JVS(875) = 0.2*B(276)+0.39*B(308)
! JVS(876) = Jac_FULL(71,68)
  JVS(876) = -B(112)
! JVS(877) = Jac_FULL(71,69)
  JVS(877) = B(192)
! JVS(878) = Jac_FULL(71,70)
  JVS(878) = -B(110)
! JVS(879) = Jac_FULL(71,71)
  JVS(879) = -B(102)-B(104)-B(106)-B(111)-B(113)-2*B(114)
! JVS(880) = Jac_FULL(71,72)
  JVS(880) = B(194)+0.717*B(284)
! JVS(881) = Jac_FULL(71,73)
  JVS(881) = -B(103)
! JVS(882) = Jac_FULL(71,74)
  JVS(882) = B(190)+0.25*B(265)
! JVS(883) = Jac_FULL(71,75)
  JVS(883) = -B(105)+0.2*B(373)
! JVS(884) = Jac_FULL(71,76)
  JVS(884) = -B(107)
! JVS(885) = Jac_FULL(72,8)
  JVS(885) = B(65)+B(66)
! JVS(886) = Jac_FULL(72,16)
  JVS(886) = -B(289)
! JVS(887) = Jac_FULL(72,17)
  JVS(887) = 0.4*B(96)
! JVS(888) = Jac_FULL(72,20)
  JVS(888) = 0.41*B(86)
! JVS(889) = Jac_FULL(72,25)
  JVS(889) = -B(370)
! JVS(890) = Jac_FULL(72,29)
  JVS(890) = 0.4*B(109)
! JVS(891) = Jac_FULL(72,35)
  JVS(891) = 0.185*B(301)
! JVS(892) = Jac_FULL(72,37)
  JVS(892) = -B(351)
! JVS(893) = Jac_FULL(72,41)
  JVS(893) = -B(244)
! JVS(894) = Jac_FULL(72,44)
  JVS(894) = -B(309)
! JVS(895) = Jac_FULL(72,45)
  JVS(895) = -B(343)
! JVS(896) = Jac_FULL(72,46)
  JVS(896) = -B(277)
! JVS(897) = Jac_FULL(72,48)
  JVS(897) = B(80)
! JVS(898) = Jac_FULL(72,49)
  JVS(898) = -B(199)
! JVS(899) = Jac_FULL(72,50)
  JVS(899) = -B(204)
! JVS(900) = Jac_FULL(72,51)
  JVS(900) = -B(359)
! JVS(901) = Jac_FULL(72,52)
  JVS(901) = -B(207)
! JVS(902) = Jac_FULL(72,53)
  JVS(902) = -B(366)
! JVS(903) = Jac_FULL(72,54)
  JVS(903) = -B(260)
! JVS(904) = Jac_FULL(72,55)
  JVS(904) = -B(173)
! JVS(905) = Jac_FULL(72,56)
  JVS(905) = -B(252)
! JVS(906) = Jac_FULL(72,57)
  JVS(906) = -B(186)
! JVS(907) = Jac_FULL(72,59)
  JVS(907) = 0
! JVS(908) = Jac_FULL(72,60)
  JVS(908) = 0
! JVS(909) = Jac_FULL(72,61)
  JVS(909) = 0
! JVS(910) = Jac_FULL(72,62)
  JVS(910) = 0
! JVS(911) = Jac_FULL(72,63)
  JVS(911) = -B(283)
! JVS(912) = Jac_FULL(72,64)
  JVS(912) = 0
! JVS(913) = Jac_FULL(72,65)
  JVS(913) = -B(193)
! JVS(914) = Jac_FULL(72,66)
  JVS(914) = 0
! JVS(915) = Jac_FULL(72,67)
  JVS(915) = B(46)-B(60)
! JVS(916) = Jac_FULL(72,68)
  JVS(916) = 0
! JVS(917) = Jac_FULL(72,69)
  JVS(917) = -B(56)+B(81)+0.185*B(302)
! JVS(918) = Jac_FULL(72,70)
  JVS(918) = -B(58)
! JVS(919) = Jac_FULL(72,71)
  JVS(919) = 0
! JVS(920) = Jac_FULL(72,72)
  JVS(920) = -B(48)-B(49)-B(50)-B(52)-B(54)-B(57)-B(59)-B(61)-2*B(62)-B(63)-B(174)-B(187)-B(194)-B(200)-B(205)-B(208)&
               &-B(245)-B(253)-B(261)-B(278)-B(284)-B(290)-B(310)-B(344)-B(352)-B(360)-B(367)-B(371)
! JVS(921) = Jac_FULL(72,73)
  JVS(921) = 0
! JVS(922) = Jac_FULL(72,74)
  JVS(922) = B(12)-B(55)
! JVS(923) = Jac_FULL(72,75)
  JVS(923) = -B(51)
! JVS(924) = Jac_FULL(72,76)
  JVS(924) = B(13)+B(47)-B(53)-B(64)
! JVS(925) = Jac_FULL(73,13)
  JVS(925) = 0.5*B(223)
! JVS(926) = Jac_FULL(73,17)
  JVS(926) = B(95)+0.6*B(96)
! JVS(927) = Jac_FULL(73,18)
  JVS(927) = B(165)
! JVS(928) = Jac_FULL(73,34)
  JVS(928) = 0.62*B(224)+B(225)
! JVS(929) = Jac_FULL(73,36)
  JVS(929) = -B(315)
! JVS(930) = Jac_FULL(73,39)
  JVS(930) = 0
! JVS(931) = Jac_FULL(73,40)
  JVS(931) = -B(325)
! JVS(932) = Jac_FULL(73,43)
  JVS(932) = -B(337)
! JVS(933) = Jac_FULL(73,47)
  JVS(933) = -B(297)
! JVS(934) = Jac_FULL(73,49)
  JVS(934) = 0.8*B(196)+B(199)
! JVS(935) = Jac_FULL(73,51)
  JVS(935) = 0.3*B(354)+0.6*B(357)
! JVS(936) = Jac_FULL(73,52)
  JVS(936) = B(206)+B(207)+B(209)
! JVS(937) = Jac_FULL(73,53)
  JVS(937) = 0.12*B(364)
! JVS(938) = Jac_FULL(73,54)
  JVS(938) = 0
! JVS(939) = Jac_FULL(73,56)
  JVS(939) = 0
! JVS(940) = Jac_FULL(73,57)
  JVS(940) = B(182)+B(184)+B(186)
! JVS(941) = Jac_FULL(73,58)
  JVS(941) = -B(140)
! JVS(942) = Jac_FULL(73,59)
  JVS(942) = -B(379)
! JVS(943) = Jac_FULL(73,60)
  JVS(943) = -B(148)
! JVS(944) = Jac_FULL(73,61)
  JVS(944) = -B(270)
! JVS(945) = Jac_FULL(73,62)
  JVS(945) = -B(132)
! JVS(946) = Jac_FULL(73,63)
  JVS(946) = 0.269*B(279)+0.143*B(281)+0.208*B(285)
! JVS(947) = Jac_FULL(73,64)
  JVS(947) = -B(124)
! JVS(948) = Jac_FULL(73,65)
  JVS(948) = 0
! JVS(949) = Jac_FULL(73,66)
  JVS(949) = 0
! JVS(950) = Jac_FULL(73,67)
  JVS(950) = 0.143*B(282)+0.6*B(358)+0.12*B(365)
! JVS(951) = Jac_FULL(73,68)
  JVS(951) = 0
! JVS(952) = Jac_FULL(73,69)
  JVS(952) = B(166)+B(185)+0.8*B(197)+B(210)+B(226)+0.269*B(280)
! JVS(953) = Jac_FULL(73,70)
  JVS(953) = -B(97)
! JVS(954) = Jac_FULL(73,71)
  JVS(954) = -B(102)
! JVS(955) = Jac_FULL(73,72)
  JVS(955) = B(187)+B(200)+B(208)
! JVS(956) = Jac_FULL(73,73)
  JVS(956) = -B(91)-B(93)-B(98)-2*B(101)-B(103)-B(125)-B(133)-B(141)-B(149)-B(271)-B(298)-B(316)-B(326)-B(338)-B(380)
! JVS(957) = Jac_FULL(73,74)
  JVS(957) = B(183)
! JVS(958) = Jac_FULL(73,75)
  JVS(958) = -B(92)
! JVS(959) = Jac_FULL(73,76)
  JVS(959) = -B(94)
! JVS(960) = Jac_FULL(74,4)
  JVS(960) = B(18)
! JVS(961) = Jac_FULL(74,26)
  JVS(961) = -B(40)
! JVS(962) = Jac_FULL(74,41)
  JVS(962) = -B(238)
! JVS(963) = Jac_FULL(74,44)
  JVS(963) = -B(303)
! JVS(964) = Jac_FULL(74,46)
  JVS(964) = -B(264)
! JVS(965) = Jac_FULL(74,54)
  JVS(965) = -B(254)
! JVS(966) = Jac_FULL(74,55)
  JVS(966) = -B(171)
! JVS(967) = Jac_FULL(74,56)
  JVS(967) = -B(246)
! JVS(968) = Jac_FULL(74,57)
  JVS(968) = -B(182)
! JVS(969) = Jac_FULL(74,61)
  JVS(969) = 0
! JVS(970) = Jac_FULL(74,63)
  JVS(970) = 0
! JVS(971) = Jac_FULL(74,64)
  JVS(971) = 0
! JVS(972) = Jac_FULL(74,65)
  JVS(972) = -B(189)
! JVS(973) = Jac_FULL(74,66)
  JVS(973) = 0
! JVS(974) = Jac_FULL(74,67)
  JVS(974) = -B(14)+B(16)
! JVS(975) = Jac_FULL(74,68)
  JVS(975) = 0
! JVS(976) = Jac_FULL(74,69)
  JVS(976) = -B(26)+B(30)
! JVS(977) = Jac_FULL(74,70)
  JVS(977) = -B(28)
! JVS(978) = Jac_FULL(74,71)
  JVS(978) = 0
! JVS(979) = Jac_FULL(74,72)
  JVS(979) = B(48)-B(54)
! JVS(980) = Jac_FULL(74,73)
  JVS(980) = 0
! JVS(981) = Jac_FULL(74,74)
  JVS(981) = -B(2)-B(7)-B(10)-B(12)-B(15)-B(27)-B(29)-B(41)-B(55)-B(172)-B(183)-B(190)-B(239)-B(247)-B(255)-B(265)&
               &-B(304)
! JVS(982) = Jac_FULL(74,75)
  JVS(982) = -B(8)
! JVS(983) = Jac_FULL(74,76)
  JVS(983) = B(1)-B(11)-B(13)
! JVS(984) = Jac_FULL(75,22)
  JVS(984) = B(74)+B(75)
! JVS(985) = Jac_FULL(75,30)
  JVS(985) = -B(178)
! JVS(986) = Jac_FULL(75,36)
  JVS(986) = -B(313)
! JVS(987) = Jac_FULL(75,37)
  JVS(987) = 0
! JVS(988) = Jac_FULL(75,40)
  JVS(988) = -B(323)
! JVS(989) = Jac_FULL(75,43)
  JVS(989) = -B(333)
! JVS(990) = Jac_FULL(75,45)
  JVS(990) = 0
! JVS(991) = Jac_FULL(75,47)
  JVS(991) = -B(295)
! JVS(992) = Jac_FULL(75,55)
  JVS(992) = 0
! JVS(993) = Jac_FULL(75,56)
  JVS(993) = 0
! JVS(994) = Jac_FULL(75,58)
  JVS(994) = -B(136)
! JVS(995) = Jac_FULL(75,59)
  JVS(995) = -B(372)
! JVS(996) = Jac_FULL(75,60)
  JVS(996) = -B(144)
! JVS(997) = Jac_FULL(75,61)
  JVS(997) = -B(266)
! JVS(998) = Jac_FULL(75,62)
  JVS(998) = -B(128)
! JVS(999) = Jac_FULL(75,63)
  JVS(999) = 0
! JVS(1000) = Jac_FULL(75,64)
  JVS(1000) = -B(120)
! JVS(1001) = Jac_FULL(75,65)
  JVS(1001) = 0
! JVS(1002) = Jac_FULL(75,66)
  JVS(1002) = 0
! JVS(1003) = Jac_FULL(75,67)
  JVS(1003) = -B(5)
! JVS(1004) = Jac_FULL(75,68)
  JVS(1004) = 0
! JVS(1005) = Jac_FULL(75,69)
  JVS(1005) = -B(69)
! JVS(1006) = Jac_FULL(75,70)
  JVS(1006) = -B(44)
! JVS(1007) = Jac_FULL(75,71)
  JVS(1007) = -B(104)
! JVS(1008) = Jac_FULL(75,72)
  JVS(1008) = B(49)-B(50)+B(52)
! JVS(1009) = Jac_FULL(75,73)
  JVS(1009) = -B(91)
! JVS(1010) = Jac_FULL(75,74)
  JVS(1010) = -B(7)+B(10)
! JVS(1011) = Jac_FULL(75,75)
  JVS(1011) = -B(6)-B(8)-2*B(42)-B(45)-B(51)-B(70)-B(71)-B(92)-B(105)-B(121)-B(129)-B(137)-B(145)-B(179)-B(267)-B(296)&
                &-B(314)-B(324)-B(334)-B(373)
! JVS(1012) = Jac_FULL(75,76)
  JVS(1012) = B(1)+B(11)+B(53)-B(72)
! JVS(1013) = Jac_FULL(76,8)
  JVS(1013) = B(65)+B(66)
! JVS(1014) = Jac_FULL(76,17)
  JVS(1014) = B(95)+0.6*B(96)
! JVS(1015) = Jac_FULL(76,20)
  JVS(1015) = B(85)+0.59*B(86)+B(87)
! JVS(1016) = Jac_FULL(76,22)
  JVS(1016) = B(74)+B(76)
! JVS(1017) = Jac_FULL(76,24)
  JVS(1017) = B(376)+0.5*B(383)
! JVS(1018) = Jac_FULL(76,29)
  JVS(1018) = B(108)+0.6*B(109)+B(385)
! JVS(1019) = Jac_FULL(76,30)
  JVS(1019) = B(178)
! JVS(1020) = Jac_FULL(76,31)
  JVS(1020) = -B(345)
! JVS(1021) = Jac_FULL(76,33)
  JVS(1021) = B(160)
! JVS(1022) = Jac_FULL(76,35)
  JVS(1022) = 0.444*B(301)
! JVS(1023) = Jac_FULL(76,36)
  JVS(1023) = 0.918*B(313)
! JVS(1024) = Jac_FULL(76,37)
  JVS(1024) = 0
! JVS(1025) = Jac_FULL(76,39)
  JVS(1025) = -B(234)
! JVS(1026) = Jac_FULL(76,40)
  JVS(1026) = 0.86*B(323)
! JVS(1027) = Jac_FULL(76,41)
  JVS(1027) = 0.5*B(244)
! JVS(1028) = Jac_FULL(76,43)
  JVS(1028) = 0.86*B(333)
! JVS(1029) = Jac_FULL(76,44)
  JVS(1029) = 0.47*B(309)
! JVS(1030) = Jac_FULL(76,45)
  JVS(1030) = 0
! JVS(1031) = Jac_FULL(76,46)
  JVS(1031) = 0.35*B(277)
! JVS(1032) = Jac_FULL(76,47)
  JVS(1032) = B(295)
! JVS(1033) = Jac_FULL(76,48)
  JVS(1033) = B(82)
! JVS(1034) = Jac_FULL(76,49)
  JVS(1034) = 0
! JVS(1035) = Jac_FULL(76,50)
  JVS(1035) = 0
! JVS(1036) = Jac_FULL(76,51)
  JVS(1036) = 0.5*B(359)
! JVS(1037) = Jac_FULL(76,52)
  JVS(1037) = 0
! JVS(1038) = Jac_FULL(76,53)
  JVS(1038) = 0
! JVS(1039) = Jac_FULL(76,54)
  JVS(1039) = 0.5*B(260)
! JVS(1040) = Jac_FULL(76,55)
  JVS(1040) = 0
! JVS(1041) = Jac_FULL(76,56)
  JVS(1041) = 0.5*B(252)
! JVS(1042) = Jac_FULL(76,57)
  JVS(1042) = 0
! JVS(1043) = Jac_FULL(76,58)
  JVS(1043) = B(136)
! JVS(1044) = Jac_FULL(76,59)
  JVS(1044) = B(372)-B(374)
! JVS(1045) = Jac_FULL(76,60)
  JVS(1045) = 0
! JVS(1046) = Jac_FULL(76,61)
  JVS(1046) = 0.9*B(266)
! JVS(1047) = Jac_FULL(76,62)
  JVS(1047) = B(128)
! JVS(1048) = Jac_FULL(76,63)
  JVS(1048) = 0.142*B(283)
! JVS(1049) = Jac_FULL(76,64)
  JVS(1049) = B(120)
! JVS(1050) = Jac_FULL(76,65)
  JVS(1050) = 0
! JVS(1051) = Jac_FULL(76,66)
  JVS(1051) = 0
! JVS(1052) = Jac_FULL(76,67)
  JVS(1052) = B(5)-B(46)+B(60)
! JVS(1053) = Jac_FULL(76,68)
  JVS(1053) = 0
! JVS(1054) = Jac_FULL(76,69)
  JVS(1054) = B(56)+B(77)-B(78)+B(88)+0.444*B(302)+0.5*B(384)+B(386)
! JVS(1055) = Jac_FULL(76,70)
  JVS(1055) = B(44)+B(58)-B(83)
! JVS(1056) = Jac_FULL(76,71)
  JVS(1056) = B(104)-B(106)
! JVS(1057) = Jac_FULL(76,72)
  JVS(1057) = B(48)+2*B(50)+B(54)+B(57)+B(59)+B(61)+2*B(62)-B(63)+0.5*B(245)+0.5*B(253)+0.5*B(261)+0.35*B(278)+0.142&
                &*B(284)+0.47*B(310)+0.5*B(360)
! JVS(1058) = Jac_FULL(76,73)
  JVS(1058) = B(91)-B(93)
! JVS(1059) = Jac_FULL(76,74)
  JVS(1059) = B(7)-B(10)-B(12)+B(55)
! JVS(1060) = Jac_FULL(76,75)
  JVS(1060) = B(6)+B(8)+2*B(42)+B(45)+2*B(51)-B(71)+B(92)+B(105)+B(121)+B(129)+B(137)+B(179)+0.9*B(267)+B(296)+0.918&
                &*B(314)+0.86*B(324)+0.86*B(334)+B(373)
! JVS(1061) = Jac_FULL(76,76)
  JVS(1061) = -B(1)-B(11)-B(13)-B(47)-B(64)-B(72)-B(79)-B(84)-B(94)-B(107)-B(235)-B(346)-B(375)
      
END SUBROUTINE Jac_SP

! End of Jac_SP function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Jac_SP_Vec - function for sparse multiplication: sparse Jacobian times vector
!   Arguments :
!      JVS       - sparse Jacobian of variables
!      UV        - User vector for variables
!      JUV       - Jacobian times user vector
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE Jac_SP_Vec ( JVS, UV, JUV )

! JVS - sparse Jacobian of variables
  REAL(kind=dp) :: JVS(LU_NONZERO)
! UV - User vector for variables
  REAL(kind=dp) :: UV(NVAR_CB6)
! JUV - Jacobian times user vector
  REAL(kind=dp) :: JUV(NVAR_CB6)

  JUV(1) = JVS(1)*UV(1)+JVS(2)*UV(35)+JVS(3)*UV(36)+JVS(4)*UV(40)+JVS(5)*UV(44)+JVS(6)*UV(69)+JVS(7)*UV(72)+JVS(8)&
             &*UV(75)
  JUV(2) = JVS(9)*UV(2)+JVS(10)*UV(3)+JVS(11)*UV(69)
  JUV(3) = JVS(12)*UV(3)+JVS(13)*UV(69)
  JUV(4) = JVS(14)*UV(4)+JVS(15)*UV(67)
  JUV(5) = JVS(16)*UV(5)+JVS(17)*UV(69)
  JUV(6) = JVS(18)*UV(6)+JVS(19)*UV(69)
  JUV(7) = JVS(20)*UV(7)+JVS(21)*UV(69)
  JUV(8) = JVS(22)*UV(8)+JVS(23)*UV(72)+JVS(24)*UV(76)
  JUV(9) = JVS(25)*UV(9)+JVS(26)*UV(69)
  JUV(10) = JVS(27)*UV(10)+JVS(28)*UV(27)+JVS(29)*UV(69)
  JUV(11) = JVS(30)*UV(11)+JVS(31)*UV(69)
  JUV(12) = JVS(32)*UV(12)+JVS(33)*UV(69)
  JUV(13) = JVS(34)*UV(13)+JVS(35)*UV(39)
  JUV(14) = JVS(36)*UV(14)+JVS(37)*UV(69)
  JUV(15) = JVS(38)*UV(15)+JVS(39)*UV(69)
  JUV(16) = JVS(40)*UV(16)+JVS(41)*UV(61)+JVS(42)*UV(72)
  JUV(17) = JVS(43)*UV(17)+JVS(44)*UV(73)+JVS(45)*UV(76)
  JUV(18) = JVS(46)*UV(18)+JVS(47)*UV(59)+JVS(48)*UV(69)+JVS(49)*UV(70)+JVS(50)*UV(71)+JVS(51)*UV(73)
  JUV(19) = JVS(52)*UV(19)+JVS(53)*UV(24)+JVS(54)*UV(33)+JVS(55)*UV(37)+JVS(56)*UV(43)+JVS(57)*UV(46)+JVS(58)*UV(51)&
              &+JVS(59)*UV(60)+JVS(60)*UV(63)+JVS(61)*UV(69)+JVS(62)*UV(72)+JVS(63)*UV(75)
  JUV(20) = JVS(64)*UV(20)+JVS(65)*UV(69)+JVS(66)*UV(70)+JVS(67)*UV(76)
  JUV(21) = JVS(68)*UV(21)+JVS(69)*UV(49)+JVS(70)*UV(64)+JVS(71)*UV(68)+JVS(72)*UV(69)
  JUV(22) = JVS(73)*UV(22)+JVS(74)*UV(37)+JVS(75)*UV(69)+JVS(76)*UV(75)+JVS(77)*UV(76)
  JUV(23) = JVS(78)*UV(23)+JVS(79)*UV(30)+JVS(80)*UV(64)+JVS(81)*UV(69)+JVS(82)*UV(70)
  JUV(24) = JVS(83)*UV(24)+JVS(84)*UV(59)+JVS(85)*UV(69)+JVS(86)*UV(76)
  JUV(25) = JVS(87)*UV(25)+JVS(88)*UV(45)+JVS(89)*UV(69)+JVS(90)*UV(72)
  JUV(26) = JVS(91)*UV(26)+JVS(92)*UV(54)+JVS(93)*UV(56)+JVS(94)*UV(67)+JVS(95)*UV(69)+JVS(96)*UV(70)+JVS(97)*UV(74)
  JUV(27) = JVS(98)*UV(27)+JVS(99)*UV(61)+JVS(100)*UV(69)+JVS(101)*UV(70)
  JUV(28) = JVS(102)*UV(7)+JVS(103)*UV(28)+JVS(104)*UV(30)+JVS(105)*UV(35)+JVS(106)*UV(41)+JVS(107)*UV(47)+JVS(108)&
              &*UV(56)+JVS(109)*UV(63)+JVS(110)*UV(67)+JVS(111)*UV(69)+JVS(112)*UV(70)+JVS(113)*UV(75)
  JUV(29) = JVS(114)*UV(29)+JVS(115)*UV(69)+JVS(116)*UV(71)+JVS(117)*UV(76)
  JUV(30) = JVS(118)*UV(30)+JVS(119)*UV(55)+JVS(120)*UV(70)+JVS(121)*UV(75)
  JUV(31) = JVS(122)*UV(25)+JVS(123)*UV(31)+JVS(124)*UV(37)+JVS(125)*UV(45)+JVS(126)*UV(69)+JVS(127)*UV(70)+JVS(128)&
              &*UV(72)+JVS(129)*UV(76)
  JUV(32) = JVS(130)*UV(32)+JVS(131)*UV(58)+JVS(132)*UV(60)+JVS(133)*UV(62)+JVS(134)*UV(69)+JVS(135)*UV(70)
  JUV(33) = JVS(136)*UV(33)+JVS(137)*UV(39)+JVS(138)*UV(41)+JVS(139)*UV(54)+JVS(140)*UV(56)+JVS(141)*UV(60)+JVS(142)&
              &*UV(69)+JVS(143)*UV(72)+JVS(144)*UV(75)+JVS(145)*UV(76)
  JUV(34) = JVS(146)*UV(12)+JVS(147)*UV(34)+JVS(148)*UV(39)+JVS(149)*UV(63)+JVS(150)*UV(67)+JVS(151)*UV(69)
  JUV(35) = JVS(152)*UV(35)+JVS(153)*UV(61)+JVS(154)*UV(69)+JVS(155)*UV(75)
  JUV(36) = JVS(156)*UV(9)+JVS(157)*UV(36)+JVS(158)*UV(68)+JVS(159)*UV(69)+JVS(160)*UV(70)+JVS(161)*UV(73)+JVS(162)&
              &*UV(75)
  JUV(37) = JVS(163)*UV(31)+JVS(164)*UV(37)+JVS(166)*UV(69)+JVS(168)*UV(72)+JVS(169)*UV(76)
  JUV(38) = JVS(170)*UV(38)+JVS(171)*UV(47)+JVS(172)*UV(54)+JVS(173)*UV(56)+JVS(174)*UV(58)+JVS(175)*UV(59)+JVS(176)&
              &*UV(60)+JVS(177)*UV(61)+JVS(178)*UV(62)+JVS(179)*UV(64)+JVS(180)*UV(67)+JVS(181)*UV(68)+JVS(182)*UV(69)&
              &+JVS(183)*UV(70)+JVS(184)*UV(71)+JVS(185)*UV(73)
  JUV(39) = JVS(186)*UV(39)+JVS(187)*UV(66)+JVS(188)*UV(69)+JVS(189)*UV(76)
  JUV(40) = JVS(190)*UV(14)+JVS(191)*UV(40)+JVS(192)*UV(68)+JVS(193)*UV(69)+JVS(194)*UV(70)+JVS(195)*UV(73)+JVS(196)&
              &*UV(75)
  JUV(41) = JVS(197)*UV(41)+JVS(198)*UV(67)+JVS(199)*UV(69)+JVS(200)*UV(72)+JVS(201)*UV(74)
  JUV(42) = JVS(202)*UV(7)+JVS(203)*UV(24)+JVS(204)*UV(34)+JVS(206)*UV(41)+JVS(207)*UV(42)+JVS(208)*UV(44)+JVS(209)&
              &*UV(45)+JVS(210)*UV(46)+JVS(211)*UV(47)+JVS(212)*UV(49)+JVS(213)*UV(50)+JVS(214)*UV(51)+JVS(215)*UV(52)&
              &+JVS(216)*UV(53)+JVS(217)*UV(54)+JVS(218)*UV(55)+JVS(219)*UV(56)+JVS(220)*UV(57)+JVS(221)*UV(59)+JVS(222)&
              &*UV(63)+JVS(223)*UV(65)+JVS(225)*UV(67)+JVS(226)*UV(68)+JVS(227)*UV(69)+JVS(228)*UV(70)+JVS(229)*UV(72)&
              &+JVS(230)*UV(73)+JVS(231)*UV(74)+JVS(232)*UV(75)
  JUV(43) = JVS(234)*UV(15)+JVS(235)*UV(43)+JVS(236)*UV(68)+JVS(237)*UV(69)+JVS(238)*UV(70)+JVS(239)*UV(73)+JVS(240)&
              &*UV(75)
  JUV(44) = JVS(241)*UV(44)+JVS(242)*UV(67)+JVS(243)*UV(69)+JVS(244)*UV(72)+JVS(245)*UV(74)
  JUV(45) = JVS(246)*UV(9)+JVS(247)*UV(14)+JVS(248)*UV(15)+JVS(249)*UV(31)+JVS(251)*UV(45)+JVS(252)*UV(69)+JVS(253)&
              &*UV(70)+JVS(254)*UV(72)
  JUV(46) = JVS(256)*UV(46)+JVS(257)*UV(67)+JVS(258)*UV(69)+JVS(259)*UV(72)+JVS(260)*UV(74)
  JUV(47) = JVS(261)*UV(10)+JVS(263)*UV(47)+JVS(265)*UV(68)+JVS(266)*UV(69)+JVS(267)*UV(70)+JVS(268)*UV(73)+JVS(269)&
              &*UV(75)
  JUV(48) = JVS(270)*UV(8)+JVS(271)*UV(16)+JVS(272)*UV(19)+JVS(274)*UV(25)+JVS(276)*UV(37)+JVS(280)*UV(45)+JVS(282)&
              &*UV(48)+JVS(283)*UV(49)+JVS(284)*UV(50)+JVS(286)*UV(52)+JVS(287)*UV(53)+JVS(289)*UV(55)+JVS(291)*UV(57)&
              &+JVS(295)*UV(63)+JVS(296)*UV(65)+JVS(300)*UV(69)+JVS(302)*UV(72)+JVS(306)*UV(76)
  JUV(49) = JVS(307)*UV(11)+JVS(308)*UV(35)+JVS(309)*UV(41)+JVS(310)*UV(47)+JVS(311)*UV(49)+JVS(313)*UV(63)+JVS(315)&
              &*UV(68)+JVS(316)*UV(69)+JVS(317)*UV(70)+JVS(318)*UV(72)+JVS(319)*UV(73)+JVS(321)*UV(75)
  JUV(50) = JVS(322)*UV(7)+JVS(323)*UV(24)+JVS(324)*UV(36)+JVS(325)*UV(40)+JVS(326)*UV(43)+JVS(327)*UV(45)+JVS(328)&
              &*UV(47)+JVS(329)*UV(49)+JVS(330)*UV(50)+JVS(331)*UV(51)+JVS(332)*UV(53)+JVS(333)*UV(54)+JVS(334)*UV(56)&
              &+JVS(335)*UV(59)+JVS(337)*UV(63)+JVS(338)*UV(67)+JVS(339)*UV(68)+JVS(340)*UV(69)+JVS(341)*UV(70)+JVS(342)&
              &*UV(72)+JVS(343)*UV(73)+JVS(345)*UV(75)
  JUV(51) = JVS(347)*UV(15)+JVS(348)*UV(40)+JVS(349)*UV(43)+JVS(350)*UV(51)+JVS(351)*UV(67)+JVS(352)*UV(68)+JVS(353)&
              &*UV(69)+JVS(355)*UV(72)+JVS(356)*UV(73)+JVS(357)*UV(75)
  JUV(52) = JVS(358)*UV(40)+JVS(359)*UV(43)+JVS(360)*UV(45)+JVS(361)*UV(47)+JVS(362)*UV(51)+JVS(363)*UV(52)+JVS(364)&
              &*UV(53)+JVS(365)*UV(54)+JVS(366)*UV(56)+JVS(368)*UV(63)+JVS(369)*UV(67)+JVS(370)*UV(68)+JVS(371)*UV(69)&
              &+JVS(372)*UV(70)+JVS(373)*UV(72)+JVS(374)*UV(73)+JVS(375)*UV(75)
  JUV(53) = JVS(377)*UV(9)+JVS(378)*UV(14)+JVS(379)*UV(36)+JVS(380)*UV(37)+JVS(381)*UV(40)+JVS(382)*UV(43)+JVS(383)&
              &*UV(45)+JVS(384)*UV(51)+JVS(385)*UV(53)+JVS(386)*UV(67)+JVS(387)*UV(68)+JVS(388)*UV(69)+JVS(390)*UV(72)&
              &+JVS(391)*UV(73)+JVS(392)*UV(75)
  JUV(54) = JVS(394)*UV(27)+JVS(395)*UV(54)+JVS(397)*UV(67)+JVS(398)*UV(69)+JVS(400)*UV(72)+JVS(401)*UV(74)
  JUV(55) = JVS(402)*UV(11)+JVS(403)*UV(21)+JVS(404)*UV(23)+JVS(405)*UV(25)+JVS(406)*UV(30)+JVS(407)*UV(34)+JVS(408)&
              &*UV(35)+JVS(409)*UV(37)+JVS(411)*UV(41)+JVS(412)*UV(44)+JVS(413)*UV(45)+JVS(414)*UV(46)+JVS(415)*UV(47)&
              &+JVS(416)*UV(49)+JVS(417)*UV(53)+JVS(418)*UV(54)+JVS(419)*UV(55)+JVS(420)*UV(56)+JVS(421)*UV(61)+JVS(422)&
              &*UV(63)+JVS(423)*UV(64)+JVS(425)*UV(67)+JVS(426)*UV(68)+JVS(427)*UV(69)+JVS(428)*UV(70)+JVS(429)*UV(72)&
              &+JVS(430)*UV(73)+JVS(431)*UV(74)+JVS(432)*UV(75)
  JUV(56) = JVS(434)*UV(35)+JVS(435)*UV(56)+JVS(437)*UV(63)+JVS(438)*UV(67)+JVS(439)*UV(69)+JVS(440)*UV(72)+JVS(441)&
              &*UV(74)
  JUV(57) = JVS(443)*UV(6)+JVS(444)*UV(11)+JVS(445)*UV(13)+JVS(446)*UV(29)+JVS(447)*UV(39)+JVS(448)*UV(51)+JVS(449)&
              &*UV(53)+JVS(450)*UV(54)+JVS(451)*UV(56)+JVS(452)*UV(57)+JVS(454)*UV(63)+JVS(455)*UV(65)+JVS(457)*UV(67)&
              &+JVS(458)*UV(68)+JVS(459)*UV(69)+JVS(460)*UV(70)+JVS(461)*UV(71)+JVS(462)*UV(72)+JVS(463)*UV(73)+JVS(464)&
              &*UV(74)+JVS(465)*UV(75)
  JUV(58) = JVS(467)*UV(34)+JVS(468)*UV(35)+JVS(470)*UV(41)+JVS(471)*UV(44)+JVS(472)*UV(45)+JVS(473)*UV(46)+JVS(474)&
              &*UV(50)+JVS(475)*UV(51)+JVS(476)*UV(52)+JVS(478)*UV(54)+JVS(479)*UV(56)+JVS(480)*UV(58)+JVS(481)*UV(59)&
              &+JVS(483)*UV(63)+JVS(484)*UV(66)+JVS(485)*UV(67)+JVS(486)*UV(68)+JVS(487)*UV(69)+JVS(488)*UV(70)+JVS(489)&
              &*UV(72)+JVS(490)*UV(73)+JVS(491)*UV(74)+JVS(492)*UV(75)
  JUV(59) = JVS(494)*UV(24)+JVS(495)*UV(45)+JVS(496)*UV(53)+JVS(497)*UV(59)+JVS(498)*UV(63)+JVS(500)*UV(68)+JVS(501)&
              &*UV(69)+JVS(502)*UV(70)+JVS(503)*UV(72)+JVS(504)*UV(73)+JVS(505)*UV(75)+JVS(506)*UV(76)
  JUV(60) = JVS(507)*UV(6)+JVS(508)*UV(12)+JVS(509)*UV(32)+JVS(510)*UV(39)+JVS(511)*UV(44)+JVS(512)*UV(45)+JVS(513)&
              &*UV(46)+JVS(514)*UV(51)+JVS(515)*UV(54)+JVS(516)*UV(56)+JVS(519)*UV(60)+JVS(522)*UV(63)+JVS(523)*UV(66)&
              &+JVS(524)*UV(67)+JVS(525)*UV(68)+JVS(526)*UV(69)+JVS(527)*UV(70)+JVS(528)*UV(72)+JVS(529)*UV(73)+JVS(530)&
              &*UV(74)+JVS(531)*UV(75)
  JUV(61) = JVS(533)*UV(27)+JVS(534)*UV(46)+JVS(535)*UV(61)+JVS(537)*UV(68)+JVS(538)*UV(69)+JVS(539)*UV(70)+JVS(541)&
              &*UV(73)+JVS(543)*UV(75)
  JUV(62) = JVS(544)*UV(6)+JVS(545)*UV(11)+JVS(546)*UV(12)+JVS(547)*UV(13)+JVS(548)*UV(14)+JVS(549)*UV(15)+JVS(550)&
              &*UV(29)+JVS(551)*UV(32)+JVS(552)*UV(35)+JVS(553)*UV(39)+JVS(554)*UV(41)+JVS(555)*UV(44)+JVS(556)*UV(45)&
              &+JVS(557)*UV(46)+JVS(558)*UV(49)+JVS(559)*UV(51)+JVS(560)*UV(53)+JVS(561)*UV(54)+JVS(562)*UV(56)+JVS(564)&
              &*UV(59)+JVS(566)*UV(61)+JVS(567)*UV(62)+JVS(568)*UV(63)+JVS(569)*UV(65)+JVS(570)*UV(66)+JVS(571)*UV(67)&
              &+JVS(572)*UV(68)+JVS(573)*UV(69)+JVS(574)*UV(70)+JVS(575)*UV(71)+JVS(576)*UV(72)+JVS(577)*UV(73)+JVS(578)&
              &*UV(74)+JVS(579)*UV(75)
  JUV(63) = JVS(581)*UV(16)+JVS(582)*UV(46)+JVS(583)*UV(61)+JVS(584)*UV(63)+JVS(585)*UV(67)+JVS(586)*UV(68)+JVS(587)&
              &*UV(69)+JVS(588)*UV(70)+JVS(589)*UV(72)+JVS(590)*UV(73)+JVS(591)*UV(74)+JVS(592)*UV(75)
  JUV(64) = JVS(593)*UV(5)+JVS(594)*UV(13)+JVS(595)*UV(17)+JVS(596)*UV(23)+JVS(598)*UV(34)+JVS(599)*UV(36)+JVS(600)&
              &*UV(38)+JVS(602)*UV(40)+JVS(603)*UV(43)+JVS(604)*UV(47)+JVS(608)*UV(57)+JVS(609)*UV(58)+JVS(610)*UV(59)&
              &+JVS(611)*UV(60)+JVS(612)*UV(61)+JVS(613)*UV(62)+JVS(614)*UV(63)+JVS(615)*UV(64)+JVS(619)*UV(68)+JVS(620)&
              &*UV(69)+JVS(621)*UV(70)+JVS(622)*UV(71)+JVS(624)*UV(73)+JVS(626)*UV(75)
  JUV(65) = JVS(628)*UV(12)+JVS(629)*UV(27)+JVS(630)*UV(35)+JVS(631)*UV(39)+JVS(632)*UV(44)+JVS(633)*UV(46)+JVS(634)&
              &*UV(54)+JVS(635)*UV(56)+JVS(636)*UV(59)+JVS(639)*UV(65)+JVS(640)*UV(66)+JVS(641)*UV(67)+JVS(642)*UV(68)&
              &+JVS(643)*UV(69)+JVS(644)*UV(70)+JVS(645)*UV(72)+JVS(646)*UV(73)+JVS(647)*UV(74)
  JUV(66) = JVS(650)*UV(12)+JVS(651)*UV(13)+JVS(652)*UV(35)+JVS(653)*UV(39)+JVS(654)*UV(44)+JVS(655)*UV(46)+JVS(656)&
              &*UV(47)+JVS(657)*UV(54)+JVS(658)*UV(56)+JVS(660)*UV(63)+JVS(661)*UV(66)+JVS(662)*UV(67)+JVS(663)*UV(68)&
              &+JVS(664)*UV(69)+JVS(665)*UV(70)+JVS(666)*UV(72)+JVS(667)*UV(73)+JVS(668)*UV(74)+JVS(669)*UV(75)
  JUV(67) = JVS(671)*UV(41)+JVS(672)*UV(44)+JVS(673)*UV(46)+JVS(674)*UV(51)+JVS(675)*UV(53)+JVS(676)*UV(54)+JVS(677)&
              &*UV(56)+JVS(678)*UV(59)+JVS(680)*UV(63)+JVS(681)*UV(67)+JVS(683)*UV(69)+JVS(684)*UV(70)+JVS(685)*UV(71)&
              &+JVS(686)*UV(72)+JVS(687)*UV(73)+JVS(688)*UV(74)+JVS(689)*UV(75)+JVS(690)*UV(76)
  JUV(68) = JVS(691)*UV(5)+JVS(692)*UV(6)+JVS(693)*UV(9)+JVS(694)*UV(10)+JVS(695)*UV(11)+JVS(696)*UV(12)+JVS(697)*UV(13)&
              &+JVS(698)*UV(14)+JVS(699)*UV(15)+JVS(700)*UV(17)+JVS(701)*UV(23)+JVS(702)*UV(27)+JVS(703)*UV(29)+JVS(705)&
              &*UV(32)+JVS(706)*UV(34)+JVS(707)*UV(35)+JVS(708)*UV(36)+JVS(709)*UV(38)+JVS(710)*UV(39)+JVS(711)*UV(40)&
              &+JVS(712)*UV(41)+JVS(713)*UV(43)+JVS(714)*UV(44)+JVS(715)*UV(45)+JVS(716)*UV(46)+JVS(717)*UV(47)+JVS(718)&
              &*UV(49)+JVS(719)*UV(50)+JVS(720)*UV(51)+JVS(721)*UV(52)+JVS(722)*UV(53)+JVS(723)*UV(54)+JVS(725)*UV(56)&
              &+JVS(726)*UV(57)+JVS(727)*UV(58)+JVS(728)*UV(59)+JVS(729)*UV(60)+JVS(730)*UV(61)+JVS(731)*UV(62)+JVS(732)&
              &*UV(63)+JVS(733)*UV(64)+JVS(734)*UV(65)+JVS(735)*UV(66)+JVS(736)*UV(67)+JVS(737)*UV(68)+JVS(738)*UV(69)&
              &+JVS(739)*UV(70)+JVS(740)*UV(71)+JVS(741)*UV(72)+JVS(742)*UV(73)+JVS(743)*UV(74)+JVS(744)*UV(75)
  JUV(69) = JVS(746)*UV(3)+JVS(747)*UV(4)+JVS(748)*UV(5)+JVS(749)*UV(6)+JVS(750)*UV(7)+JVS(751)*UV(9)+JVS(752)*UV(10)&
              &+JVS(753)*UV(11)+JVS(754)*UV(12)+JVS(755)*UV(14)+JVS(756)*UV(15)+JVS(757)*UV(16)+JVS(758)*UV(18)+JVS(759)&
              &*UV(20)+JVS(760)*UV(21)+JVS(761)*UV(22)+JVS(762)*UV(23)+JVS(763)*UV(24)+JVS(764)*UV(25)+JVS(765)*UV(26)&
              &+JVS(766)*UV(27)+JVS(767)*UV(28)+JVS(768)*UV(29)+JVS(769)*UV(30)+JVS(770)*UV(32)+JVS(771)*UV(33)+JVS(772)&
              &*UV(34)+JVS(773)*UV(35)+JVS(774)*UV(37)+JVS(775)*UV(38)+JVS(777)*UV(41)+JVS(778)*UV(42)+JVS(779)*UV(44)&
              &+JVS(780)*UV(45)+JVS(781)*UV(46)+JVS(782)*UV(47)+JVS(783)*UV(48)+JVS(784)*UV(49)+JVS(785)*UV(50)+JVS(786)&
              &*UV(51)+JVS(787)*UV(52)+JVS(788)*UV(53)+JVS(789)*UV(54)+JVS(790)*UV(55)+JVS(791)*UV(56)+JVS(792)*UV(57)&
              &+JVS(794)*UV(59)+JVS(796)*UV(61)+JVS(798)*UV(63)+JVS(800)*UV(65)+JVS(801)*UV(66)+JVS(802)*UV(67)+JVS(803)&
              &*UV(68)+JVS(804)*UV(69)+JVS(805)*UV(70)+JVS(806)*UV(71)+JVS(807)*UV(72)+JVS(808)*UV(73)+JVS(809)*UV(74)&
              &+JVS(810)*UV(75)+JVS(811)*UV(76)
  JUV(70) = JVS(812)*UV(3)+JVS(813)*UV(7)+JVS(814)*UV(9)+JVS(815)*UV(11)+JVS(816)*UV(14)+JVS(817)*UV(15)+JVS(818)*UV(20)&
              &+JVS(819)*UV(21)+JVS(820)*UV(25)+JVS(821)*UV(26)+JVS(822)*UV(28)+JVS(823)*UV(30)+JVS(824)*UV(31)+JVS(825)&
              &*UV(32)+JVS(827)*UV(36)+JVS(828)*UV(37)+JVS(829)*UV(39)+JVS(830)*UV(40)+JVS(831)*UV(41)+JVS(832)*UV(42)&
              &+JVS(833)*UV(43)+JVS(835)*UV(45)+JVS(836)*UV(46)+JVS(837)*UV(47)+JVS(838)*UV(49)+JVS(839)*UV(50)+JVS(840)&
              &*UV(51)+JVS(841)*UV(52)+JVS(842)*UV(53)+JVS(844)*UV(55)+JVS(845)*UV(56)+JVS(846)*UV(57)+JVS(847)*UV(58)&
              &+JVS(848)*UV(59)+JVS(849)*UV(60)+JVS(850)*UV(61)+JVS(851)*UV(62)+JVS(852)*UV(63)+JVS(853)*UV(64)+JVS(854)&
              &*UV(65)+JVS(856)*UV(67)+JVS(857)*UV(68)+JVS(858)*UV(69)+JVS(859)*UV(70)+JVS(860)*UV(71)+JVS(861)*UV(72)&
              &+JVS(862)*UV(73)+JVS(863)*UV(74)+JVS(864)*UV(75)+JVS(865)*UV(76)
  JUV(71) = JVS(866)*UV(13)+JVS(867)*UV(29)+JVS(869)*UV(44)+JVS(870)*UV(46)+JVS(871)*UV(59)+JVS(872)*UV(63)+JVS(873)&
              &*UV(65)+JVS(875)*UV(67)+JVS(876)*UV(68)+JVS(877)*UV(69)+JVS(878)*UV(70)+JVS(879)*UV(71)+JVS(880)*UV(72)&
              &+JVS(881)*UV(73)+JVS(882)*UV(74)+JVS(883)*UV(75)+JVS(884)*UV(76)
  JUV(72) = JVS(885)*UV(8)+JVS(886)*UV(16)+JVS(887)*UV(17)+JVS(888)*UV(20)+JVS(889)*UV(25)+JVS(890)*UV(29)+JVS(891)&
              &*UV(35)+JVS(892)*UV(37)+JVS(893)*UV(41)+JVS(894)*UV(44)+JVS(895)*UV(45)+JVS(896)*UV(46)+JVS(897)*UV(48)&
              &+JVS(898)*UV(49)+JVS(899)*UV(50)+JVS(900)*UV(51)+JVS(901)*UV(52)+JVS(902)*UV(53)+JVS(903)*UV(54)+JVS(904)&
              &*UV(55)+JVS(905)*UV(56)+JVS(906)*UV(57)+JVS(911)*UV(63)+JVS(913)*UV(65)+JVS(915)*UV(67)+JVS(917)*UV(69)&
              &+JVS(918)*UV(70)+JVS(920)*UV(72)+JVS(922)*UV(74)+JVS(923)*UV(75)+JVS(924)*UV(76)
  JUV(73) = JVS(925)*UV(13)+JVS(926)*UV(17)+JVS(927)*UV(18)+JVS(928)*UV(34)+JVS(929)*UV(36)+JVS(931)*UV(40)+JVS(932)&
              &*UV(43)+JVS(933)*UV(47)+JVS(934)*UV(49)+JVS(935)*UV(51)+JVS(936)*UV(52)+JVS(937)*UV(53)+JVS(940)*UV(57)&
              &+JVS(941)*UV(58)+JVS(942)*UV(59)+JVS(943)*UV(60)+JVS(944)*UV(61)+JVS(945)*UV(62)+JVS(946)*UV(63)+JVS(947)&
              &*UV(64)+JVS(950)*UV(67)+JVS(952)*UV(69)+JVS(953)*UV(70)+JVS(954)*UV(71)+JVS(955)*UV(72)+JVS(956)*UV(73)&
              &+JVS(957)*UV(74)+JVS(958)*UV(75)+JVS(959)*UV(76)
  JUV(74) = JVS(960)*UV(4)+JVS(961)*UV(26)+JVS(962)*UV(41)+JVS(963)*UV(44)+JVS(964)*UV(46)+JVS(965)*UV(54)+JVS(966)&
              &*UV(55)+JVS(967)*UV(56)+JVS(968)*UV(57)+JVS(972)*UV(65)+JVS(974)*UV(67)+JVS(976)*UV(69)+JVS(977)*UV(70)&
              &+JVS(979)*UV(72)+JVS(981)*UV(74)+JVS(982)*UV(75)+JVS(983)*UV(76)
  JUV(75) = JVS(984)*UV(22)+JVS(985)*UV(30)+JVS(986)*UV(36)+JVS(988)*UV(40)+JVS(989)*UV(43)+JVS(991)*UV(47)+JVS(994)&
              &*UV(58)+JVS(995)*UV(59)+JVS(996)*UV(60)+JVS(997)*UV(61)+JVS(998)*UV(62)+JVS(1000)*UV(64)+JVS(1003)*UV(67)&
              &+JVS(1005)*UV(69)+JVS(1006)*UV(70)+JVS(1007)*UV(71)+JVS(1008)*UV(72)+JVS(1009)*UV(73)+JVS(1010)*UV(74)&
              &+JVS(1011)*UV(75)+JVS(1012)*UV(76)
  JUV(76) = JVS(1013)*UV(8)+JVS(1014)*UV(17)+JVS(1015)*UV(20)+JVS(1016)*UV(22)+JVS(1017)*UV(24)+JVS(1018)*UV(29)&
              &+JVS(1019)*UV(30)+JVS(1020)*UV(31)+JVS(1021)*UV(33)+JVS(1022)*UV(35)+JVS(1023)*UV(36)+JVS(1025)*UV(39)&
              &+JVS(1026)*UV(40)+JVS(1027)*UV(41)+JVS(1028)*UV(43)+JVS(1029)*UV(44)+JVS(1031)*UV(46)+JVS(1032)*UV(47)&
              &+JVS(1033)*UV(48)+JVS(1036)*UV(51)+JVS(1039)*UV(54)+JVS(1041)*UV(56)+JVS(1043)*UV(58)+JVS(1044)*UV(59)&
              &+JVS(1046)*UV(61)+JVS(1047)*UV(62)+JVS(1048)*UV(63)+JVS(1049)*UV(64)+JVS(1052)*UV(67)+JVS(1054)*UV(69)&
              &+JVS(1055)*UV(70)+JVS(1056)*UV(71)+JVS(1057)*UV(72)+JVS(1058)*UV(73)+JVS(1059)*UV(74)+JVS(1060)*UV(75)&
              &+JVS(1061)*UV(76)
      
END SUBROUTINE Jac_SP_Vec

! End of Jac_SP_Vec function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! JacTR_SP_Vec - sparse multiplication: sparse Jacobian transposed times vector
!   Arguments :
!      JVS       - sparse Jacobian of variables
!      UV        - User vector for variables
!      JTUV      - Jacobian transposed times user vector
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE JacTR_SP_Vec ( JVS, UV, JTUV )

! JVS - sparse Jacobian of variables
  REAL(kind=dp) :: JVS(LU_NONZERO)
! UV - User vector for variables
  REAL(kind=dp) :: UV(NVAR_CB6)
! JTUV - Jacobian transposed times user vector
  REAL(kind=dp) :: JTUV(NVAR_CB6)

  JTUV(1) = JVS(1)*UV(1)
  JTUV(2) = JVS(9)*UV(2)
  JTUV(3) = JVS(10)*UV(2)+JVS(12)*UV(3)+JVS(746)*UV(69)+JVS(812)*UV(70)
  JTUV(4) = JVS(14)*UV(4)+JVS(747)*UV(69)+JVS(960)*UV(74)
  JTUV(5) = JVS(16)*UV(5)+JVS(593)*UV(64)+JVS(691)*UV(68)+JVS(748)*UV(69)
  JTUV(6) = JVS(18)*UV(6)+JVS(443)*UV(57)+JVS(507)*UV(60)+JVS(544)*UV(62)+JVS(692)*UV(68)+JVS(749)*UV(69)
  JTUV(7) = JVS(20)*UV(7)+JVS(102)*UV(28)+JVS(202)*UV(42)+JVS(322)*UV(50)+JVS(750)*UV(69)+JVS(813)*UV(70)
  JTUV(8) = JVS(22)*UV(8)+JVS(270)*UV(48)+JVS(885)*UV(72)+JVS(1013)*UV(76)
  JTUV(9) = JVS(25)*UV(9)+JVS(156)*UV(36)+JVS(246)*UV(45)+JVS(377)*UV(53)+JVS(693)*UV(68)+JVS(751)*UV(69)+JVS(814)&
              &*UV(70)
  JTUV(10) = JVS(27)*UV(10)+JVS(261)*UV(47)+JVS(694)*UV(68)+JVS(752)*UV(69)
  JTUV(11) = JVS(30)*UV(11)+JVS(307)*UV(49)+JVS(402)*UV(55)+JVS(444)*UV(57)+JVS(545)*UV(62)+JVS(695)*UV(68)+JVS(753)&
               &*UV(69)+JVS(815)*UV(70)
  JTUV(12) = JVS(32)*UV(12)+JVS(146)*UV(34)+JVS(508)*UV(60)+JVS(546)*UV(62)+JVS(628)*UV(65)+JVS(650)*UV(66)+JVS(696)&
               &*UV(68)+JVS(754)*UV(69)
  JTUV(13) = JVS(34)*UV(13)+JVS(445)*UV(57)+JVS(547)*UV(62)+JVS(594)*UV(64)+JVS(651)*UV(66)+JVS(697)*UV(68)+JVS(866)&
               &*UV(71)+JVS(925)*UV(73)
  JTUV(14) = JVS(36)*UV(14)+JVS(190)*UV(40)+JVS(247)*UV(45)+JVS(378)*UV(53)+JVS(548)*UV(62)+JVS(698)*UV(68)+JVS(755)&
               &*UV(69)+JVS(816)*UV(70)
  JTUV(15) = JVS(38)*UV(15)+JVS(234)*UV(43)+JVS(248)*UV(45)+JVS(347)*UV(51)+JVS(549)*UV(62)+JVS(699)*UV(68)+JVS(756)&
               &*UV(69)+JVS(817)*UV(70)
  JTUV(16) = JVS(40)*UV(16)+JVS(271)*UV(48)+JVS(581)*UV(63)+JVS(757)*UV(69)+JVS(886)*UV(72)
  JTUV(17) = JVS(43)*UV(17)+JVS(595)*UV(64)+JVS(700)*UV(68)+JVS(887)*UV(72)+JVS(926)*UV(73)+JVS(1014)*UV(76)
  JTUV(18) = JVS(46)*UV(18)+JVS(758)*UV(69)+JVS(927)*UV(73)
  JTUV(19) = JVS(52)*UV(19)+JVS(272)*UV(48)
  JTUV(20) = JVS(64)*UV(20)+JVS(759)*UV(69)+JVS(818)*UV(70)+JVS(888)*UV(72)+JVS(1015)*UV(76)
  JTUV(21) = JVS(68)*UV(21)+JVS(403)*UV(55)+JVS(760)*UV(69)+JVS(819)*UV(70)
  JTUV(22) = JVS(73)*UV(22)+JVS(761)*UV(69)+JVS(984)*UV(75)+JVS(1016)*UV(76)
  JTUV(23) = JVS(78)*UV(23)+JVS(404)*UV(55)+JVS(596)*UV(64)+JVS(701)*UV(68)+JVS(762)*UV(69)
  JTUV(24) = JVS(53)*UV(19)+JVS(83)*UV(24)+JVS(203)*UV(42)+JVS(323)*UV(50)+JVS(494)*UV(59)+JVS(763)*UV(69)+JVS(1017)&
               &*UV(76)
  JTUV(25) = JVS(87)*UV(25)+JVS(122)*UV(31)+JVS(274)*UV(48)+JVS(405)*UV(55)+JVS(764)*UV(69)+JVS(820)*UV(70)+JVS(889)&
               &*UV(72)
  JTUV(26) = JVS(91)*UV(26)+JVS(765)*UV(69)+JVS(821)*UV(70)+JVS(961)*UV(74)
  JTUV(27) = JVS(28)*UV(10)+JVS(98)*UV(27)+JVS(394)*UV(54)+JVS(533)*UV(61)+JVS(629)*UV(65)+JVS(702)*UV(68)+JVS(766)&
               &*UV(69)
  JTUV(28) = JVS(103)*UV(28)+JVS(767)*UV(69)+JVS(822)*UV(70)
  JTUV(29) = JVS(114)*UV(29)+JVS(446)*UV(57)+JVS(550)*UV(62)+JVS(703)*UV(68)+JVS(768)*UV(69)+JVS(867)*UV(71)+JVS(890)&
               &*UV(72)+JVS(1018)*UV(76)
  JTUV(30) = JVS(79)*UV(23)+JVS(104)*UV(28)+JVS(118)*UV(30)+JVS(406)*UV(55)+JVS(769)*UV(69)+JVS(823)*UV(70)+JVS(985)&
               &*UV(75)+JVS(1019)*UV(76)
  JTUV(31) = JVS(123)*UV(31)+JVS(163)*UV(37)+JVS(249)*UV(45)+JVS(824)*UV(70)+JVS(1020)*UV(76)
  JTUV(32) = JVS(130)*UV(32)+JVS(509)*UV(60)+JVS(551)*UV(62)+JVS(705)*UV(68)+JVS(770)*UV(69)+JVS(825)*UV(70)
  JTUV(33) = JVS(54)*UV(19)+JVS(136)*UV(33)+JVS(771)*UV(69)+JVS(1021)*UV(76)
  JTUV(34) = JVS(147)*UV(34)+JVS(204)*UV(42)+JVS(407)*UV(55)+JVS(467)*UV(58)+JVS(598)*UV(64)+JVS(706)*UV(68)+JVS(772)&
               &*UV(69)+JVS(928)*UV(73)
  JTUV(35) = JVS(2)*UV(1)+JVS(105)*UV(28)+JVS(152)*UV(35)+JVS(308)*UV(49)+JVS(408)*UV(55)+JVS(434)*UV(56)+JVS(468)&
               &*UV(58)+JVS(552)*UV(62)+JVS(630)*UV(65)+JVS(652)*UV(66)+JVS(707)*UV(68)+JVS(773)*UV(69)+JVS(891)*UV(72)&
               &+JVS(1022)*UV(76)
  JTUV(36) = JVS(3)*UV(1)+JVS(157)*UV(36)+JVS(324)*UV(50)+JVS(379)*UV(53)+JVS(599)*UV(64)+JVS(708)*UV(68)+JVS(827)&
               &*UV(70)+JVS(929)*UV(73)+JVS(986)*UV(75)+JVS(1023)*UV(76)
  JTUV(37) = JVS(55)*UV(19)+JVS(74)*UV(22)+JVS(124)*UV(31)+JVS(164)*UV(37)+JVS(276)*UV(48)+JVS(380)*UV(53)+JVS(409)&
               &*UV(55)+JVS(774)*UV(69)+JVS(828)*UV(70)+JVS(892)*UV(72)
  JTUV(38) = JVS(170)*UV(38)+JVS(600)*UV(64)+JVS(709)*UV(68)+JVS(775)*UV(69)
  JTUV(39) = JVS(35)*UV(13)+JVS(137)*UV(33)+JVS(148)*UV(34)+JVS(186)*UV(39)+JVS(447)*UV(57)+JVS(510)*UV(60)+JVS(553)&
               &*UV(62)+JVS(631)*UV(65)+JVS(653)*UV(66)+JVS(710)*UV(68)+JVS(829)*UV(70)+JVS(1025)*UV(76)
  JTUV(40) = JVS(4)*UV(1)+JVS(191)*UV(40)+JVS(325)*UV(50)+JVS(348)*UV(51)+JVS(358)*UV(52)+JVS(381)*UV(53)+JVS(602)&
               &*UV(64)+JVS(711)*UV(68)+JVS(830)*UV(70)+JVS(931)*UV(73)+JVS(988)*UV(75)+JVS(1026)*UV(76)
  JTUV(41) = JVS(106)*UV(28)+JVS(138)*UV(33)+JVS(197)*UV(41)+JVS(206)*UV(42)+JVS(309)*UV(49)+JVS(411)*UV(55)+JVS(470)&
               &*UV(58)+JVS(554)*UV(62)+JVS(671)*UV(67)+JVS(712)*UV(68)+JVS(777)*UV(69)+JVS(831)*UV(70)+JVS(893)*UV(72)&
               &+JVS(962)*UV(74)+JVS(1027)*UV(76)
  JTUV(42) = JVS(207)*UV(42)+JVS(778)*UV(69)+JVS(832)*UV(70)
  JTUV(43) = JVS(56)*UV(19)+JVS(235)*UV(43)+JVS(326)*UV(50)+JVS(349)*UV(51)+JVS(359)*UV(52)+JVS(382)*UV(53)+JVS(603)&
               &*UV(64)+JVS(713)*UV(68)+JVS(833)*UV(70)+JVS(932)*UV(73)+JVS(989)*UV(75)+JVS(1028)*UV(76)
  JTUV(44) = JVS(5)*UV(1)+JVS(208)*UV(42)+JVS(241)*UV(44)+JVS(412)*UV(55)+JVS(471)*UV(58)+JVS(511)*UV(60)+JVS(555)&
               &*UV(62)+JVS(632)*UV(65)+JVS(654)*UV(66)+JVS(672)*UV(67)+JVS(714)*UV(68)+JVS(779)*UV(69)+JVS(869)*UV(71)&
               &+JVS(894)*UV(72)+JVS(963)*UV(74)+JVS(1029)*UV(76)
  JTUV(45) = JVS(88)*UV(25)+JVS(125)*UV(31)+JVS(209)*UV(42)+JVS(251)*UV(45)+JVS(280)*UV(48)+JVS(327)*UV(50)+JVS(360)&
               &*UV(52)+JVS(383)*UV(53)+JVS(413)*UV(55)+JVS(472)*UV(58)+JVS(495)*UV(59)+JVS(512)*UV(60)+JVS(556)*UV(62)&
               &+JVS(715)*UV(68)+JVS(780)*UV(69)+JVS(835)*UV(70)+JVS(895)*UV(72)
  JTUV(46) = JVS(57)*UV(19)+JVS(210)*UV(42)+JVS(256)*UV(46)+JVS(414)*UV(55)+JVS(473)*UV(58)+JVS(513)*UV(60)+JVS(534)&
               &*UV(61)+JVS(557)*UV(62)+JVS(582)*UV(63)+JVS(633)*UV(65)+JVS(655)*UV(66)+JVS(673)*UV(67)+JVS(716)*UV(68)&
               &+JVS(781)*UV(69)+JVS(836)*UV(70)+JVS(870)*UV(71)+JVS(896)*UV(72)+JVS(964)*UV(74)+JVS(1031)*UV(76)
  JTUV(47) = JVS(107)*UV(28)+JVS(171)*UV(38)+JVS(211)*UV(42)+JVS(263)*UV(47)+JVS(310)*UV(49)+JVS(328)*UV(50)+JVS(361)&
               &*UV(52)+JVS(415)*UV(55)+JVS(604)*UV(64)+JVS(656)*UV(66)+JVS(717)*UV(68)+JVS(782)*UV(69)+JVS(837)*UV(70)&
               &+JVS(933)*UV(73)+JVS(991)*UV(75)+JVS(1032)*UV(76)
  JTUV(48) = JVS(282)*UV(48)+JVS(783)*UV(69)+JVS(897)*UV(72)+JVS(1033)*UV(76)
  JTUV(49) = JVS(69)*UV(21)+JVS(212)*UV(42)+JVS(283)*UV(48)+JVS(311)*UV(49)+JVS(329)*UV(50)+JVS(416)*UV(55)+JVS(558)&
               &*UV(62)+JVS(718)*UV(68)+JVS(784)*UV(69)+JVS(838)*UV(70)+JVS(898)*UV(72)+JVS(934)*UV(73)
  JTUV(50) = JVS(213)*UV(42)+JVS(284)*UV(48)+JVS(330)*UV(50)+JVS(474)*UV(58)+JVS(719)*UV(68)+JVS(785)*UV(69)+JVS(839)&
               &*UV(70)+JVS(899)*UV(72)
  JTUV(51) = JVS(58)*UV(19)+JVS(214)*UV(42)+JVS(331)*UV(50)+JVS(350)*UV(51)+JVS(362)*UV(52)+JVS(384)*UV(53)+JVS(448)&
               &*UV(57)+JVS(475)*UV(58)+JVS(514)*UV(60)+JVS(559)*UV(62)+JVS(674)*UV(67)+JVS(720)*UV(68)+JVS(786)*UV(69)&
               &+JVS(840)*UV(70)+JVS(900)*UV(72)+JVS(935)*UV(73)+JVS(1036)*UV(76)
  JTUV(52) = JVS(215)*UV(42)+JVS(286)*UV(48)+JVS(363)*UV(52)+JVS(476)*UV(58)+JVS(721)*UV(68)+JVS(787)*UV(69)+JVS(841)&
               &*UV(70)+JVS(901)*UV(72)+JVS(936)*UV(73)
  JTUV(53) = JVS(216)*UV(42)+JVS(287)*UV(48)+JVS(332)*UV(50)+JVS(364)*UV(52)+JVS(385)*UV(53)+JVS(417)*UV(55)+JVS(449)&
               &*UV(57)+JVS(496)*UV(59)+JVS(560)*UV(62)+JVS(675)*UV(67)+JVS(722)*UV(68)+JVS(788)*UV(69)+JVS(842)*UV(70)&
               &+JVS(902)*UV(72)+JVS(937)*UV(73)
  JTUV(54) = JVS(92)*UV(26)+JVS(139)*UV(33)+JVS(172)*UV(38)+JVS(217)*UV(42)+JVS(333)*UV(50)+JVS(365)*UV(52)+JVS(395)&
               &*UV(54)+JVS(418)*UV(55)+JVS(450)*UV(57)+JVS(478)*UV(58)+JVS(515)*UV(60)+JVS(561)*UV(62)+JVS(634)*UV(65)&
               &+JVS(657)*UV(66)+JVS(676)*UV(67)+JVS(723)*UV(68)+JVS(789)*UV(69)+JVS(903)*UV(72)+JVS(965)*UV(74)+JVS(1039)&
               &*UV(76)
  JTUV(55) = JVS(119)*UV(30)+JVS(218)*UV(42)+JVS(289)*UV(48)+JVS(419)*UV(55)+JVS(790)*UV(69)+JVS(844)*UV(70)+JVS(904)&
               &*UV(72)+JVS(966)*UV(74)
  JTUV(56) = JVS(93)*UV(26)+JVS(108)*UV(28)+JVS(140)*UV(33)+JVS(173)*UV(38)+JVS(219)*UV(42)+JVS(334)*UV(50)+JVS(366)&
               &*UV(52)+JVS(420)*UV(55)+JVS(435)*UV(56)+JVS(451)*UV(57)+JVS(479)*UV(58)+JVS(516)*UV(60)+JVS(562)*UV(62)&
               &+JVS(635)*UV(65)+JVS(658)*UV(66)+JVS(677)*UV(67)+JVS(725)*UV(68)+JVS(791)*UV(69)+JVS(845)*UV(70)+JVS(905)&
               &*UV(72)+JVS(967)*UV(74)+JVS(1041)*UV(76)
  JTUV(57) = JVS(220)*UV(42)+JVS(291)*UV(48)+JVS(452)*UV(57)+JVS(608)*UV(64)+JVS(726)*UV(68)+JVS(792)*UV(69)+JVS(846)&
               &*UV(70)+JVS(906)*UV(72)+JVS(940)*UV(73)+JVS(968)*UV(74)
  JTUV(58) = JVS(131)*UV(32)+JVS(174)*UV(38)+JVS(480)*UV(58)+JVS(609)*UV(64)+JVS(727)*UV(68)+JVS(847)*UV(70)+JVS(941)&
               &*UV(73)+JVS(994)*UV(75)+JVS(1043)*UV(76)
  JTUV(59) = JVS(47)*UV(18)+JVS(84)*UV(24)+JVS(175)*UV(38)+JVS(221)*UV(42)+JVS(335)*UV(50)+JVS(481)*UV(58)+JVS(497)&
               &*UV(59)+JVS(564)*UV(62)+JVS(610)*UV(64)+JVS(636)*UV(65)+JVS(678)*UV(67)+JVS(728)*UV(68)+JVS(794)*UV(69)&
               &+JVS(848)*UV(70)+JVS(871)*UV(71)+JVS(942)*UV(73)+JVS(995)*UV(75)+JVS(1044)*UV(76)
  JTUV(60) = JVS(59)*UV(19)+JVS(132)*UV(32)+JVS(141)*UV(33)+JVS(176)*UV(38)+JVS(519)*UV(60)+JVS(611)*UV(64)+JVS(729)&
               &*UV(68)+JVS(849)*UV(70)+JVS(943)*UV(73)+JVS(996)*UV(75)
  JTUV(61) = JVS(41)*UV(16)+JVS(99)*UV(27)+JVS(153)*UV(35)+JVS(177)*UV(38)+JVS(421)*UV(55)+JVS(535)*UV(61)+JVS(566)&
               &*UV(62)+JVS(583)*UV(63)+JVS(612)*UV(64)+JVS(730)*UV(68)+JVS(796)*UV(69)+JVS(850)*UV(70)+JVS(944)*UV(73)&
               &+JVS(997)*UV(75)+JVS(1046)*UV(76)
  JTUV(62) = JVS(133)*UV(32)+JVS(178)*UV(38)+JVS(567)*UV(62)+JVS(613)*UV(64)+JVS(731)*UV(68)+JVS(851)*UV(70)+JVS(945)&
               &*UV(73)+JVS(998)*UV(75)+JVS(1047)*UV(76)
  JTUV(63) = JVS(60)*UV(19)+JVS(109)*UV(28)+JVS(149)*UV(34)+JVS(222)*UV(42)+JVS(295)*UV(48)+JVS(313)*UV(49)+JVS(337)&
               &*UV(50)+JVS(368)*UV(52)+JVS(422)*UV(55)+JVS(437)*UV(56)+JVS(454)*UV(57)+JVS(483)*UV(58)+JVS(498)*UV(59)&
               &+JVS(522)*UV(60)+JVS(568)*UV(62)+JVS(584)*UV(63)+JVS(614)*UV(64)+JVS(660)*UV(66)+JVS(680)*UV(67)+JVS(732)&
               &*UV(68)+JVS(798)*UV(69)+JVS(852)*UV(70)+JVS(872)*UV(71)+JVS(911)*UV(72)+JVS(946)*UV(73)+JVS(1048)*UV(76)
  JTUV(64) = JVS(70)*UV(21)+JVS(80)*UV(23)+JVS(179)*UV(38)+JVS(423)*UV(55)+JVS(615)*UV(64)+JVS(733)*UV(68)+JVS(853)&
               &*UV(70)+JVS(947)*UV(73)+JVS(1000)*UV(75)+JVS(1049)*UV(76)
  JTUV(65) = JVS(223)*UV(42)+JVS(296)*UV(48)+JVS(455)*UV(57)+JVS(569)*UV(62)+JVS(639)*UV(65)+JVS(734)*UV(68)+JVS(800)&
               &*UV(69)+JVS(854)*UV(70)+JVS(873)*UV(71)+JVS(913)*UV(72)+JVS(972)*UV(74)
  JTUV(66) = JVS(187)*UV(39)+JVS(484)*UV(58)+JVS(523)*UV(60)+JVS(570)*UV(62)+JVS(640)*UV(65)+JVS(661)*UV(66)+JVS(735)&
               &*UV(68)+JVS(801)*UV(69)
  JTUV(67) = JVS(15)*UV(4)+JVS(94)*UV(26)+JVS(110)*UV(28)+JVS(150)*UV(34)+JVS(180)*UV(38)+JVS(198)*UV(41)+JVS(225)&
               &*UV(42)+JVS(242)*UV(44)+JVS(257)*UV(46)+JVS(338)*UV(50)+JVS(351)*UV(51)+JVS(369)*UV(52)+JVS(386)*UV(53)&
               &+JVS(397)*UV(54)+JVS(425)*UV(55)+JVS(438)*UV(56)+JVS(457)*UV(57)+JVS(485)*UV(58)+JVS(524)*UV(60)+JVS(571)&
               &*UV(62)+JVS(585)*UV(63)+JVS(641)*UV(65)+JVS(662)*UV(66)+JVS(681)*UV(67)+JVS(736)*UV(68)+JVS(802)*UV(69)&
               &+JVS(856)*UV(70)+JVS(875)*UV(71)+JVS(915)*UV(72)+JVS(950)*UV(73)+JVS(974)*UV(74)+JVS(1003)*UV(75)+JVS(1052)&
               &*UV(76)
  JTUV(68) = JVS(71)*UV(21)+JVS(158)*UV(36)+JVS(181)*UV(38)+JVS(192)*UV(40)+JVS(226)*UV(42)+JVS(236)*UV(43)+JVS(265)&
               &*UV(47)+JVS(315)*UV(49)+JVS(339)*UV(50)+JVS(352)*UV(51)+JVS(370)*UV(52)+JVS(387)*UV(53)+JVS(426)*UV(55)&
               &+JVS(458)*UV(57)+JVS(486)*UV(58)+JVS(500)*UV(59)+JVS(525)*UV(60)+JVS(537)*UV(61)+JVS(572)*UV(62)+JVS(586)&
               &*UV(63)+JVS(619)*UV(64)+JVS(642)*UV(65)+JVS(663)*UV(66)+JVS(737)*UV(68)+JVS(803)*UV(69)+JVS(857)*UV(70)&
               &+JVS(876)*UV(71)
  JTUV(69) = JVS(6)*UV(1)+JVS(11)*UV(2)+JVS(13)*UV(3)+JVS(17)*UV(5)+JVS(19)*UV(6)+JVS(21)*UV(7)+JVS(26)*UV(9)+JVS(29)&
               &*UV(10)+JVS(31)*UV(11)+JVS(33)*UV(12)+JVS(37)*UV(14)+JVS(39)*UV(15)+JVS(48)*UV(18)+JVS(61)*UV(19)+JVS(65)&
               &*UV(20)+JVS(72)*UV(21)+JVS(75)*UV(22)+JVS(81)*UV(23)+JVS(85)*UV(24)+JVS(89)*UV(25)+JVS(95)*UV(26)+JVS(100)&
               &*UV(27)+JVS(111)*UV(28)+JVS(115)*UV(29)+JVS(126)*UV(31)+JVS(134)*UV(32)+JVS(142)*UV(33)+JVS(151)*UV(34)&
               &+JVS(154)*UV(35)+JVS(159)*UV(36)+JVS(166)*UV(37)+JVS(182)*UV(38)+JVS(188)*UV(39)+JVS(193)*UV(40)+JVS(199)&
               &*UV(41)+JVS(227)*UV(42)+JVS(237)*UV(43)+JVS(243)*UV(44)+JVS(252)*UV(45)+JVS(258)*UV(46)+JVS(266)*UV(47)&
               &+JVS(300)*UV(48)+JVS(316)*UV(49)+JVS(340)*UV(50)+JVS(353)*UV(51)+JVS(371)*UV(52)+JVS(388)*UV(53)+JVS(398)&
               &*UV(54)+JVS(427)*UV(55)+JVS(439)*UV(56)+JVS(459)*UV(57)+JVS(487)*UV(58)+JVS(501)*UV(59)+JVS(526)*UV(60)&
               &+JVS(538)*UV(61)+JVS(573)*UV(62)+JVS(587)*UV(63)+JVS(620)*UV(64)+JVS(643)*UV(65)+JVS(664)*UV(66)+JVS(683)&
               &*UV(67)+JVS(738)*UV(68)+JVS(804)*UV(69)+JVS(858)*UV(70)+JVS(877)*UV(71)+JVS(917)*UV(72)+JVS(952)*UV(73)&
               &+JVS(976)*UV(74)+JVS(1005)*UV(75)+JVS(1054)*UV(76)
  JTUV(70) = JVS(49)*UV(18)+JVS(66)*UV(20)+JVS(82)*UV(23)+JVS(96)*UV(26)+JVS(101)*UV(27)+JVS(112)*UV(28)+JVS(120)*UV(30)&
               &+JVS(127)*UV(31)+JVS(135)*UV(32)+JVS(160)*UV(36)+JVS(183)*UV(38)+JVS(194)*UV(40)+JVS(228)*UV(42)+JVS(238)&
               &*UV(43)+JVS(253)*UV(45)+JVS(267)*UV(47)+JVS(317)*UV(49)+JVS(341)*UV(50)+JVS(372)*UV(52)+JVS(428)*UV(55)&
               &+JVS(460)*UV(57)+JVS(488)*UV(58)+JVS(502)*UV(59)+JVS(527)*UV(60)+JVS(539)*UV(61)+JVS(574)*UV(62)+JVS(588)&
               &*UV(63)+JVS(621)*UV(64)+JVS(644)*UV(65)+JVS(665)*UV(66)+JVS(684)*UV(67)+JVS(739)*UV(68)+JVS(805)*UV(69)&
               &+JVS(859)*UV(70)+JVS(878)*UV(71)+JVS(918)*UV(72)+JVS(953)*UV(73)+JVS(977)*UV(74)+JVS(1006)*UV(75)+JVS(1055)&
               &*UV(76)
  JTUV(71) = JVS(50)*UV(18)+JVS(116)*UV(29)+JVS(184)*UV(38)+JVS(461)*UV(57)+JVS(575)*UV(62)+JVS(622)*UV(64)+JVS(685)&
               &*UV(67)+JVS(740)*UV(68)+JVS(806)*UV(69)+JVS(860)*UV(70)+JVS(879)*UV(71)+JVS(954)*UV(73)+JVS(1007)*UV(75)&
               &+JVS(1056)*UV(76)
  JTUV(72) = JVS(7)*UV(1)+JVS(23)*UV(8)+JVS(42)*UV(16)+JVS(62)*UV(19)+JVS(90)*UV(25)+JVS(128)*UV(31)+JVS(143)*UV(33)&
               &+JVS(168)*UV(37)+JVS(200)*UV(41)+JVS(229)*UV(42)+JVS(244)*UV(44)+JVS(254)*UV(45)+JVS(259)*UV(46)+JVS(302)&
               &*UV(48)+JVS(318)*UV(49)+JVS(342)*UV(50)+JVS(355)*UV(51)+JVS(373)*UV(52)+JVS(390)*UV(53)+JVS(400)*UV(54)&
               &+JVS(429)*UV(55)+JVS(440)*UV(56)+JVS(462)*UV(57)+JVS(489)*UV(58)+JVS(503)*UV(59)+JVS(528)*UV(60)+JVS(576)&
               &*UV(62)+JVS(589)*UV(63)+JVS(645)*UV(65)+JVS(666)*UV(66)+JVS(686)*UV(67)+JVS(741)*UV(68)+JVS(807)*UV(69)&
               &+JVS(861)*UV(70)+JVS(880)*UV(71)+JVS(920)*UV(72)+JVS(955)*UV(73)+JVS(979)*UV(74)+JVS(1008)*UV(75)+JVS(1057)&
               &*UV(76)
  JTUV(73) = JVS(44)*UV(17)+JVS(51)*UV(18)+JVS(161)*UV(36)+JVS(185)*UV(38)+JVS(195)*UV(40)+JVS(230)*UV(42)+JVS(239)&
               &*UV(43)+JVS(268)*UV(47)+JVS(319)*UV(49)+JVS(343)*UV(50)+JVS(356)*UV(51)+JVS(374)*UV(52)+JVS(391)*UV(53)&
               &+JVS(430)*UV(55)+JVS(463)*UV(57)+JVS(490)*UV(58)+JVS(504)*UV(59)+JVS(529)*UV(60)+JVS(541)*UV(61)+JVS(577)&
               &*UV(62)+JVS(590)*UV(63)+JVS(624)*UV(64)+JVS(646)*UV(65)+JVS(667)*UV(66)+JVS(687)*UV(67)+JVS(742)*UV(68)&
               &+JVS(808)*UV(69)+JVS(862)*UV(70)+JVS(881)*UV(71)+JVS(956)*UV(73)+JVS(1009)*UV(75)+JVS(1058)*UV(76)
  JTUV(74) = JVS(97)*UV(26)+JVS(201)*UV(41)+JVS(231)*UV(42)+JVS(245)*UV(44)+JVS(260)*UV(46)+JVS(401)*UV(54)+JVS(431)&
               &*UV(55)+JVS(441)*UV(56)+JVS(464)*UV(57)+JVS(491)*UV(58)+JVS(530)*UV(60)+JVS(578)*UV(62)+JVS(591)*UV(63)&
               &+JVS(647)*UV(65)+JVS(668)*UV(66)+JVS(688)*UV(67)+JVS(743)*UV(68)+JVS(809)*UV(69)+JVS(863)*UV(70)+JVS(882)&
               &*UV(71)+JVS(922)*UV(72)+JVS(957)*UV(73)+JVS(981)*UV(74)+JVS(1010)*UV(75)+JVS(1059)*UV(76)
  JTUV(75) = JVS(8)*UV(1)+JVS(63)*UV(19)+JVS(76)*UV(22)+JVS(113)*UV(28)+JVS(121)*UV(30)+JVS(144)*UV(33)+JVS(155)*UV(35)&
               &+JVS(162)*UV(36)+JVS(196)*UV(40)+JVS(232)*UV(42)+JVS(240)*UV(43)+JVS(269)*UV(47)+JVS(321)*UV(49)+JVS(345)&
               &*UV(50)+JVS(357)*UV(51)+JVS(375)*UV(52)+JVS(392)*UV(53)+JVS(432)*UV(55)+JVS(465)*UV(57)+JVS(492)*UV(58)&
               &+JVS(505)*UV(59)+JVS(531)*UV(60)+JVS(543)*UV(61)+JVS(579)*UV(62)+JVS(592)*UV(63)+JVS(626)*UV(64)+JVS(669)&
               &*UV(66)+JVS(689)*UV(67)+JVS(744)*UV(68)+JVS(810)*UV(69)+JVS(864)*UV(70)+JVS(883)*UV(71)+JVS(923)*UV(72)&
               &+JVS(958)*UV(73)+JVS(982)*UV(74)+JVS(1011)*UV(75)+JVS(1060)*UV(76)
  JTUV(76) = JVS(24)*UV(8)+JVS(45)*UV(17)+JVS(67)*UV(20)+JVS(77)*UV(22)+JVS(86)*UV(24)+JVS(117)*UV(29)+JVS(129)*UV(31)&
               &+JVS(145)*UV(33)+JVS(169)*UV(37)+JVS(189)*UV(39)+JVS(306)*UV(48)+JVS(506)*UV(59)+JVS(690)*UV(67)+JVS(811)&
               &*UV(69)+JVS(865)*UV(70)+JVS(884)*UV(71)+JVS(924)*UV(72)+JVS(959)*UV(73)+JVS(983)*UV(74)+JVS(1012)*UV(75)&
               &+JVS(1061)*UV(76)
      
END SUBROUTINE JacTR_SP_Vec

! End of JacTR_SP_Vec function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



END MODULE mod_cb6_Jacobian

